(function () {
    
    function readConfig(path) {
        var str = jsb.fileUtils.getStringFromFile("/data/data/com.woyou.snakemerge.googleplay/files/" + path)
        // myLog(str);
        return str;
    }

    'use strict';

    class Observer {
        constructor(callback, context) {
            this._callback = null;
            this._this = null;
            this._callback = callback;
            this._this = context;
        }
        notify(...args) {
            this._callback.call(this._this, ...args);
        }
        compar(context) {
            return this._this == context;
        }
        notifyReturn(...args) {
            return this._callback.call(this._this, ...args);
        }
    }

    class UpEventHandle {
        constructor() {
            this._isUp = false;
            this._UpList = {};
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                this._ins = new UpEventHandle();
            }
            return this._ins;
        }
        AddUPEvent(name, func, context) {
            let observer = this._UpList[name];
            if (observer) {
                this._UpList[name] = null;
            }
            this._UpList[name] = new Observer(func, context);
        }
        removeListEvent(name) {
            let observer = this._UpList[name];
            if (!observer) {
                return;
            }
            delete this._UpList[name];
        }
        removeAllListEvent() {
            for (let key in this._UpList) {
                delete this._UpList[key];
            }
        }
        HandleUPEvent() {
            if (!this._isUp) {
                return;
            }
            for (let key in this._UpList) {
                let observer = this._UpList[key];
                if (!observer) {
                    continue;
                }
                observer.notify();
            }
        }
        StartGame() {
            this._isUp = true;
        }
        GameOver() {
            this._isUp = false;
        }
    }

    class BuildData {
        constructor() {
            this._newBuildData = {
                at: [
                    ["笤帚炮台", 8, 0, 4, 4, ""],
                    ["铲铲炮台", 16, 0, 8, 4.5, ""],
                    ["鱼叉炮台", 32, 0, 16, 5, ""],
                    ["喷射水枪", 64, 0, 32, 5.5, ""],
                    ["高压水枪", 256, 0, 64, 6, "game_1"],
                    ["气泡发射器", 512, 0, 128, 6.5, ""],
                    ["魔力气泡机", 1024, 32, 256, 7, "game_2"],
                    ["驱魔气泡机", 2048, 64, 512, 7.5, ""],
                    ["初级激光器", 4096, 128, 1024, 8, "game_3"],
                    ["恶魔激光器", 8192, 256, 2048, 8.5, "game_4"],
                    ["圣光生成器", 16384, 512, 4096, 9, "game_5"],
                    ["圣光发射器", 32768, 1024, 8192, 9.5, "game_6"],
                    ["圣光炮台", 65536, 2048, 16384, 10, ""]
                ],
                bed: [
                    ["发霉小床", 0, 0, 1, 0, ""],
                    ["湿冷小床", 25, 0, 2, 0, ""],
                    ["破旧小床", 50, 0, 4, 0, "door_2"],
                    ["简陋的床", 100, 0, 8, 0, ""],
                    ["标准床铺", 200, 0, 16, 0, "door_5"],
                    ["温暖床铺", 400, 0, 32, 0, ""],
                    ["精装床铺", 800, 16, 64, 0, "door_8"],
                    ["标准大床", 1600, 32, 128, 0, "door_10"],
                    ["豪华大床", 3200, 64, 256, 0, "door_11"],
                    ["多功能大床", 6400, 128, 512, 0, "door_12"],
                ],
                door: [
                    ["铁门1", 0, 0, 50, 0, ""],
                    ["铁门2", 16, 0, 80, 0, ""],
                    ["铁门3", 32, 0, 160, 0, ""],
                    ["铁门4", 64, 0, 200, 0, ""],
                    ["铁门5", 128, 0, 250, 0, ""],
                    ["钢门1", 256, 0, 320, 0, ""],
                    ["钢门2", 512, 16, 640, 0, ""],
                    ["钢门3", 1024, 32, 1280, 0, ""],
                    ["钢门4", 2048, 64, 2560, 0, ""],
                    ["钢门5", 4096, 128, 5120, 0, ""],
                    ["振金门1", 8192, 256, 10240, 0, ""],
                    ["振金门2", 16384, 512, 20480, 0, ""],
                    ["振金门3", 32768, 1024, 40960, 0, ""]
                ],
                game: [
                    ["发霉游戏机", 200, 0, 1, 0, ""],
                    ["破旧游戏机", 400, 0, 2, 0, ""],
                    ["简陋游戏机", 800, 0, 4, 0, ""],
                    ["古董游戏机", 1600, 0, 6, 0, ""],
                    ["怀旧游戏机", 3200, 0, 8, 0, ""],
                    ["NSN游戏机", 6400, 0, 10, 0, ""],
                    ["GBG游戏机", 12800, 0, 15, 0, ""],
                    ["qs5游戏机", 25600, 0, 20, 0, ""],
                    ["红盒游戏机", 51200, 0, 25, 0, ""],
                    ["顶配游戏机", 102400, 0, 30, 0, ""],
                ],
                mine: [
                    ["铜矿", 0, 128, 8, 0, ""],
                    ["银矿", 0, 1024, 32, 0, ""],
                    ["金矿", 0, 2048, 128, 0, ""],
                    ["钻石矿", 0, 4096, 512, 0, ""],
                ]
            };
            this._newBuildData1 = {
                spell: ["符咒弹射器", 0, 64, 0, 0, ""],
                ice: ["冰箱", 0, 256, 0, 0, ""],
                entrapment: ["诱捕", 0, 512, 0, 0, ""],
                barb: ["倒刺", 0, 512, 0, 0, ""],
                guillotine: ["断头台", 0, 2048, 0, 0, ""],
                repair: ["维修台", 0, 64, 0, 0, ""],
                energyhood: ["能量罩", 0, 64, 0, 0, ""],
                smoney: ["取款机", 0, 128, 0, 0, ""],
                longrange: ["瞭望台", 0, 256, 0, 0, ""],
                particlea: ["粒子加速器", 0, 2048, 0, 0, ""],
                solenoid: ["电磁圈", 0, 2048, 0, 0, ""]
            };
            this._introduce = {
                at: [
                    ["攻击力：  4\n攻击距离：4"],
                    ["攻击力：  8\n攻击距离：4.5"],
                    ["攻击力：  16\n攻击距离：5"],
                    ["攻击力：  32\n攻击距离：5.5"],
                    ["攻击力：  64\n攻击距离：6\n前置：发霉游戏机"],
                    ["攻击力：  128\n攻击距离：6.5"],
                    ["攻击力：  256\n攻击距离：7\n前置：破旧游戏机"],
                    ["攻击力：  512\n攻击距离：7.5"],
                    ["攻击力：  1024\n攻击距离：8\n前置：简陋游戏机"],
                    ["攻击力：  2048\n攻击距离：8.5\n前置：古董游戏机"],
                    ["攻击力：  4096\n攻击距离：9\n前置：怀旧游戏机"],
                    ["攻击力：  8192\n攻击距离：9.5\n前置：NSN游戏机"],
                    ["攻击力：  16384\n攻击距离：10"]
                ],
                bed: [
                    ["生产：  1金币/s"],
                    ["生产：  2金币/s"],
                    ["生产：  4金币/s\n前置：铁门2"],
                    ["生产：  8金币/s"],
                    ["生产：  16金币/s\n前置：铁门5"],
                    ["生产：  32金币/s"],
                    ["生产：  64金币/s\n前置：钢门3"],
                    ["生产：  128金币/s\n前置：钢门5"],
                    ["生产：  256金币/s\n前置：振金门1"],
                    ["生产：  512金币/s\n前置：振金门2"],
                ],
                door: [
                    ["血量：   50HP"],
                    ["血量：   70HP"],
                    ["血量：   140HP"],
                    ["血量：   200HP"],
                    ["血量：   250HP"],
                    ["血量：   320HP"],
                    ["血量：   640HP"],
                    ["血量：   1280HP"],
                    ["血量：   2560HP"],
                    ["血量：   5120HP"],
                    ["血量：   10240HP"],
                    ["血量：   20480HP"],
                    ["血量：   40960HP"]
                ],
                game: [
                    ["生产：  1闪电/2s"],
                    ["生产：  2闪电/s"],
                    ["生产：  4闪电/s"],
                    ["生产：  6闪电/s"],
                    ["生产：  8闪电/s"],
                    ["生产：  10闪电/s"],
                    ["生产：  15闪电/s"],
                    ["生产：  20闪电/s"],
                    ["生产：  25闪电/s"],
                    ["生产：  30闪电/s"],
                ],
                mine: [
                    ["生产：  8金币/s"],
                    ["生产：  32金币/s"],
                    ["生产：  128金币/s"],
                    ["生产：  512金币/s"],
                ]
            };
            this._introduce1 = {
                spell: "效果：   当鬼释放技能时，30%几率发出符咒，控制3s",
                ice: "效果：   减缓鬼20%攻速",
                entrapment: "效果：   100%对逃跑的鬼射出一张网，网住2s",
                barb: "效果：   门被攻击时，每秒对鬼造成1%最大生命值的伤害",
                guillotine: "效果：   敌人血量低于20%时 ，直接给予鬼10%最大生命值的伤害",
                repair: "效果：   每秒恢复门2%的血量，没有距离限制",
                energyhood: "效果：   当门血量低于30%，产生一个3s无敌的能量罩",
                smoney: "效果：   给予炮塔偷钱的能力，取决于塔的等级",
                longrange: "效果：   增加炮塔20%攻击范围",
                particlea: "效果：   增加炮塔50%攻击速度",
                solenoid: "效果：   敌人距离越近，攻速越快"
            };
            this._basicBuildData = [
                ["at_1", "game_1", "repair_1"],
                ["mine_1", "mine_2", "mine_3", "mine_4"],
                ["spell_1", "energyhood_1", "smoney_1", "ice_1"],
                ["entrapment_1", "barb_1", "guillotine_1"],
                ["longrange_1", "particlea_1", "solenoid_1"]
            ];
            this._ShopBuildData = [
                ["spell_1", "energyhood_1", "smoney_1", "ice_1"],
                ["entrapment_1", "barb_1", "guillotine_2", "repair_1"],
                ["longrange_1", "particlea_1", "solenoid_2"]
            ];
            this._skin = {
                spell: "map/spellimg_0.png",
                energyhood: "map/energyhood_2.png",
                smoney: "map/money.png",
                entrapment: "map/entramentImage_1.png",
                guillotine: "map/guillotine_3.png",
                particlea: "map/particleaImg.png",
                solenoid: "map/solenoidimg_1.png"
            };
            this._ShopBuildMoney = {
                repair: ["维修台", 10],
                spell: ["符咒弹射器", 20],
                smoney: ["取款机", 20],
                ice: ["冰箱", 30],
                entrapment: ["诱捕", 30],
                barb: ["倒刺", 50],
                energyhood: ["能量罩", 50],
                guillotine: ["断头台", 999],
                longrange: ["瞭望台", 30],
                particlea: ["粒子加速器", 100],
                solenoid: ["电磁圈", 999]
            };
            this._AIPos = [[21, 22], [21, 23], [22, 22], [22, 23], [23, 22], [23, 23]];
            this._trollPos = [[22, 1], [41, 23], [21, 35], [1, 23]];
            this.AtBasePower = [1, 2, 4, 6, 14, 22.5, 40, 75];
            this.bulletBuff = {
                "1": [0, 0, 0.01, 0.02, 0.03, 0.04, 0.05, 0.08],
                "2": [0, 0, 0, 0, 0, 0.5, 0.7, 1],
                "3": [0, 0, 1, 2, 3, 4, 5, 8],
            };
            this.AtBuffEff = [
                [0, 0, 0, 0, 0, 0.01, 0.02, 0.04],
                [0, 0, 0, 0, 0, 0.01, 0.02, 0.04],
                [0, 0, 0, 0, 0, 0.01, 0.02, 0.04],
            ];
        }
        GetSubSkin(str) {
            let skin = this._skin[str];
            if (skin) {
                return skin;
            }
            else {
                return null;
            }
        }
        GetBuildData(value, level) {
            let data = this._newBuildData[value];
            if (data == undefined) {
                data = this._newBuildData1[value];
                if (level == 1) {
                    if (data != undefined) {
                        return data;
                    }
                    else {
                        return undefined;
                    }
                }
                else {
                    return undefined;
                }
            }
            else {
                return data[level - 1];
            }
        }
        getbasicBuildData(index) {
            if (index >= this._basicBuildData.length) {
                index = 0;
            }
            return this._basicBuildData[index];
        }
        GetBulidBuff(bulletType, level) {
            var arr = this.bulletBuff[bulletType.toString()];
            if (arr != undefined) {
                return arr[level];
            }
            else {
                return 0;
            }
        }
        GetAtBuffEff(BuffEff, level) {
            return this.AtBuffEff[BuffEff - 1][level];
        }
        GetAtPower(index) {
            if (index >= 0 && index < 8) {
                return this.AtBasePower[index];
            }
            else {
                return null;
            }
        }
        GetAIPos(index) {
            return this._AIPos[index];
        }
        GetTrollPos() {
            let ran = Math.floor(Math.random() * this._trollPos.length);
            return this._trollPos[ran];
        }
        GetIntroduce(value, level) {
            let data = this._introduce[value];
            if (data == undefined) {
                data = this._introduce1[value];
                if (level == 1) {
                    if (data != undefined) {
                        return data;
                    }
                    else {
                        return undefined;
                    }
                }
                else {
                    return undefined;
                }
            }
            else {
                return data[level - 1];
            }
        }
        GetShopData(index) {
            return this._ShopBuildData[index];
        }
        GetShopBuildMoney(str) {
            return this._ShopBuildMoney[str];
        }
    }

    class CDNData {
        constructor() {
            this._cdn = {
                taskOpenCount: 3,
                animSelectOpenCount: 1,
                shopOpenCount: 1,
                diff: {
                    diffCount: [5],
                    diff: [[0, 1], [1, 2]]
                },
                treasureChestOpenCount: 2,
                treasureChestShow: 2,
                treasureChestFirstShow: 2,
                treasureChestLoopShow: [3, 0, 1, 2],
                treasureChestArr: [
                    ["repair_1", "repair_1", "repair_1", "spell_1", "spell_1", "ice_1"],
                    ["repair_1", "repair_1", "repair_1", "ice_1", "barb_1"],
                    ["repair_1", "repair_1", "smoney_1", "ice_1", "entrapment_1", "energyhood_1"],
                    ["repair_1", "repair_1", "repair_1", "repair_1", "ice_1", "entrapment_1", "longrange_1", "longrange_1", "particlea_1"]
                ],
                doorADVOpneCount: 2
            };
            this.tcArr = null;
        }
        get cdn() {
            return this._cdn;
        }
    }

    class GameData {
        constructor() {
            this.PR = {};
            this._startGame = false;
            this._winOrLoser = false;
            this._isMvp = false;
            this._mvpIndex = -1;
            this._playerArr = new Array();
            this._lpPath = null;
        }
        GetRoomPR(playerId) {
            let info = this.PR[playerId];
            if (info == undefined) {
                return null;
            }
            else {
                return info;
            }
        }
        SetRoomPR(playerId) {
            let s = this.PR[playerId];
            if (s == undefined) {
                s = { gold1: 0, gold2: 0, gold1_Count: 0, gold2_Count: 0 };
                this.PR[playerId] = s;
            }
            return s;
        }
        ClearPR() {
            this.PR = {};
        }
        SetPR(playerId, gold1, gold2) {
            let pr = this.PR[playerId];
            if (!pr) {
                pr = this.SetRoomPR(playerId);
            }
            pr.gold1 += gold1;
            pr.gold2 += gold2;
            pr.gold1_Count += gold1;
            pr.gold2_Count += gold2;
        }
        GameOver() {
            this.PR = {};
            this._playerArr = [];
            this._lpPath = null;
            this._startGame = false;
        }
        StartGame() {
            this._startGame = true;
        }
        set isWin(value) {
            this._winOrLoser = value;
        }
        get isWin() {
            return this._winOrLoser;
        }
        set playerArr(vlaue) {
            this._playerArr.push(vlaue);
        }
        GetPlayerArr(index) {
            return this._playerArr[index];
        }
        get trollName() {
            return this._trollName;
        }
        set trollName(vlaue) {
            this._trollName = vlaue;
        }
        get playerInfo() {
            return this._playerInfo;
        }
        sortPlayer(arr) {
            this.InitPlayerInfo(arr);
            if (this._playerInfo.length > 0) {
                for (let i = 0; i < this._playerInfo.length - 1; i++) {
                    let info_i = this._playerInfo[i];
                    for (let j = i; j < this._playerInfo.length; j++) {
                        let info_j = this._playerInfo[j];
                        if (info_i.time < info_j.time) {
                            this._playerInfo[i] = info_j;
                            this._playerInfo[j] = info_i;
                            info_i = info_j;
                        }
                        else if (info_i.time == info_j.time) {
                            let pr_i = info_i.gold1 * 0.3 + info_i.gold2 * 0.7;
                            let pr_j = info_j.gold1 * 0.3 + info_j.gold2 * 0.7;
                            if (pr_i < pr_j) {
                                this._playerInfo[i] = info_j;
                                this._playerInfo[j] = info_i;
                                info_i = info_j;
                            }
                        }
                    }
                }
            }
        }
        InitPlayerInfo(arr) {
            let players = arr;
            if (players.length > 0) {
                let arr = [];
                for (let i = 0; i < players.length; i++) {
                    let player = players[i];
                    let pr = this.GetRoomPR(player.roomIndex);
                    if (!pr) {
                        pr = { gold1_Count: 0, gold2_Count: 0 };
                    }
                    let win = player.win;
                    let lose = player.lose;
                    let info = { roomindex: player.roomIndex, name: player.name, time: player.dieTime, gold1: pr.gold1_Count, gold2: pr.gold2_Count, win: win, lose: lose };
                    arr.push(info);
                }
                this._playerInfo = arr;
            }
        }
        get isMvp() {
            return this._isMvp;
        }
        set isMvp(value) {
            this._isMvp = value;
        }
        set lpPath(value) {
            this._lpPath = value;
        }
        get lpPath() {
            return this._lpPath;
        }
        get isStart() {
            return this._startGame;
        }
        get mvpIndex() {
            return this._mvpIndex;
        }
        set mvpIndex(value) {
            this._mvpIndex = value;
        }
    }

    class PlayerData {
        constructor() {
            this._key = "PlayerData";
            this._trollIndex = 0;
            this.countI = 3;
            this.skinMaxNum = 6;
            this.skin = [0, 6, 2, 3, 4, 5];
            this._data = {
                _playerSelectIndex: 0,
                _playerSkin: [0],
                _win: 0,
                _lose: 0,
                _mvp: 0,
                _gold: 0,
                _task: 0,
                _taskOk: false,
                _ysOK: false,
                _blueprint: {
                    spell: 1,
                    ice: 1,
                    entrapment: 1,
                    barb: 1,
                    guillotine: 1,
                    repair: 10,
                    energyhood: 1,
                    smoney: 1,
                    longrange: 1,
                    particlea: 1,
                    solenoid: 1
                }
            };
            this._goldTextArr = [];
            this.Read();
        }
        get key() {
            return this._key;
        }
        get trollIndex() {
            let index = Math.floor(this.DZCount / this.countI);
            let index2 = Math.floor(index % this.skinMaxNum);
            this._trollIndex = index2;
            return this.skin[this._trollIndex];
        }
        get PlayerSkin() {
            return this._data._playerSkin;
        }
        set PlayerSkin(value) {
            if (!this.InspectplayerSkin(value[0])) {
                this._data._playerSkin.push(value[0]);
                this.Write();
            }
        }
        InspectplayerSkin(value) {
            for (let i = 0; i < this._data._playerSkin.length; i++) {
                let num = this._data._playerSkin[i];
                if (num == value) {
                    return true;
                }
            }
            return false;
        }
        get playerSelectIndex() {
            return this._data._playerSelectIndex;
        }
        set playerSelectIndex(value) {
            this._data._playerSelectIndex = value;
        }
        Read() {
            try {
                let isFrist = Laya.LocalStorage.getItem("isFrist");
                if(isFrist==null){ 
                    Laya.LocalStorage.setItem("isFrist","0");
                    Laya.LocalStorage.setItem("HpUp","0");
                    Laya.LocalStorage.setItem("gold","0");
                    Laya.LocalStorage.setItem("gold1","0");
                    Laya.LocalStorage.setItem("gold2","0");
                    Laya.LocalStorage.setItem("Power","0");
                    Laya.LocalStorage.setItem("Speed","0");
                    Laya.LocalStorage.setItem("Rage","0");
                    Laya.LocalStorage.setItem("StartTimer","0");
                    Laya.LocalStorage.setItem("repair_Skill","0");
                }
                let str = Laya.LocalStorage.getJSON(this.key);
                if (str != null) {
                    let data = JSON.parse(str);
                    this._data._playerSelectIndex = data._playerSelectIndex ? data._playerSelectIndex : this._data._playerSelectIndex;
                    this._data._playerSkin = data._playerSkin ? data._playerSkin : this._data._playerSkin;
                    this._data._win = data._win ? data._win : this._data._win;
                    this._data._lose = data._lose ? data._lose : this._data._lose;
                    this._data._mvp = data._mvp ? data._mvp : this._data._mvp;
                    this._data._gold = data._gold ? data._gold : this._data._gold;
                    this._data._task = data._task ? data._task : this._data._task;
                    this._data._taskOk = data._taskOk ? data._taskOk : this._data._taskOk;
                    this._data._ysOK = data._ysOK ? data._ysOK : this._data._ysOK;
                    this._data._blueprint = data._blueprint ? data._blueprint : this._data._blueprint;
                }
            }
            catch (error) {
                this.Write();
            }
        }
        Write() {
            try {
                let str = JSON.stringify(this._data);
                Laya.LocalStorage.setJSON(this.key, str);
            }
            catch (error) {
            }
        }
        get win() {
            return this._data._win;
        }
        get lose() {
            return this._data._lose;
        }
        get mvp() {
            return this._data._mvp;
        }
        set win(value) {
            this._data._win = value;
            this.Write();
        }
        set lose(value) {
            this._data._lose = value;
            this.Write();
        }
        set mvp(value) {
            this._data._mvp = value;
            this.Write();
        }
        GetBuileprintNum(str) {
            let count = this._data._blueprint[str];
            if (count != undefined)
                return count;
            else
                return null;
        }
        ModifiedBuileprintQuantity(str, num) {
            let count = this._data._blueprint[str];
            if (count != undefined) {
                this._data._blueprint[str] += num;
                if (this._data._blueprint[str] < 0)
                    this._data._blueprint[str] = 0;
                this.Write();
            }
        }
        set goldText(value) {
            this._goldTextArr.push(value);
        }
        get gold() {
            return this._data._gold;
        }
        get taskIndex() {
            return this._data._task;
        }
        set taskIndex(value) {
            this._data._task = value;
            this.Write();
        }
        set gold(vlaue) {
            this._data._gold = vlaue;
            if (this._data._gold < 0) {
                this._data._gold = 0;
            }
            if (this._goldTextArr.length > 0) {
                for (let i = 0; i < this._goldTextArr.length; i++) {
                    let img = this._goldTextArr[i];
                    img.text = this._data._gold.toString();
                }
            }
            this.Write();
        }
        get DZCount() {
            return this._data._win + this._data._lose;
        }
        get taskOk() {
            return this._data._taskOk;
        }
        set taskOk(value) {
            this._data._taskOk = value;
            this.Write();
        }
        set ysOK(value) {
            this._data._ysOK = value;
            this.Write();
        }
        get ysOK() {
            return this._data._ysOK;
        }
    }

    class TaskData {
        constructor() {
            this.taskTextArr = [
                "1.猛鬼来了，进入一间无人的房间，上床",
                "2.升级湿冷小床",
                "3.升级铁门2",
                "4.升级破旧小床",
                "5.升级简陋的床",
                "6.建造两座笤帚炮台",
                "7.升级标准床铺",
                "8.建造两个发霉游戏机",
                "9.升级精装床铺",
                "10.拥有一个高压水枪",
                "11.建造铜矿"
            ];
        }
        GetTaskText(index) {
            if (index < 0 && index >= this.taskTextArr.length) {
                return null;
            }
            return this.taskTextArr[index];
        }
    }

    class TrollData {
        constructor() {
            this.powers = [2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072];
            this.hps = [300, 400, 800, 1600, 3200, 6400, 12800, 12800, 51200, 51200, 204800, 204800, 819200, 819200, 3276800, 3276800, 13107200];
            this.upData = [30, 50, 60, 60, 60, 65, 70, 75, 80, 85, 90, 95];
            this._difficulty = 0;
            this._eHpPro = [0.3, 0.3, 0.3];
            this._attackPro = [0, 0, -0.1];
            this._eTimePro = [0.55, 0.5, 0.3];
        }
        get eHpPro() {
            return this._eHpPro[this._difficulty];
        }
        get attackPro() {
            return this._attackPro[this._difficulty];
        }
        get eTimePro() {
            return this._eTimePro[this._difficulty];
        }
        set difficulty(value) {
            if (value < 0 || value >= this._eHpPro.length) {
                value = 0;
            }
            this._difficulty = value;
        }
        get diffCount() {
            return this._eHpPro.length;
        }
    }

    class DataManager {
        static get instance() {
            if (!this._ins || this._ins == null) {
                this._ins = new DataManager();
            }
            return this._ins;
        }
        get build() {
            if (!this._buildData || this._buildData == null) {
                this._buildData = new BuildData();
            }
            return this._buildData;
        }
        get game() {
            if (!this._gameData || this._gameData == null) {
                this._gameData = new GameData();
            }
            return this._gameData;
        }
        get player() {
            if (!this._playerData || this._playerData == null) {
                this._playerData = new PlayerData();
            }
            return this._playerData;
        }
        get troll() {
            if (!this._trollData || this._trollData == null) {
                this._trollData = new TrollData();
            }
            return this._trollData;
        }
        get cdn() {
            if (!this._cdnData || this._cdnData == null) {
                this._cdnData = new CDNData();
            }
            return this._cdnData;
        }
        get task() {
            if (!this._taskData || this._taskData == null) {
                this._taskData = new TaskData();
            }
            return this._taskData;
        }
        GameOver() {
            this._gameData.GameOver();
        }
        StartGame() {
            this._gameData.StartGame();
        }
    }

    class EventBase {
        constructor() {
            this.CLICK_MAP = "ClickMap";
            this.CLICK_BUILD = "ClickBuild";
            this.COLLECTIVE_BUILD = "CollectiveBuild";
            this.SET_POS_MENU = "SetBuildMenuPos";
            this.SHOW_MENU = "ShowMenu";
            this.HIDE_MENU = "HideMenu";
            this.OFF_SHOW_MENU = "OffShowMenu";
            this.OFF_HIDE_MENU = "OffHideMenu";
            this.BUILD_BUILDORUP = "BuildOrUp";
            this.BUILD_BUILDORUP_ADV = "BuildOrUpADV";
            this.BUILD_CLICKBLICK_INIT = "ClickBlockInit";
            this.BUILD_UPBUILD = "BuildUpBuild";
            this.BUILD_NEW = "build";
            this.BUILD_BUILD_DISMANTLE = "BuildBuildDismantle";
            this.BUILD_HANDLEROOMBUFF = "BuildHandleRoomBuff";
            this.BUILD_FINDDOOR = "BuildFindDoor";
            this.BUILD_FINDBEDANDDOOR = "BuildFindBedAndDoor";
            this.BUILD_FINDROOM = "BuildFindRoom";
            this.BUILD_GOTOBED = "BuildGoToBed";
            this.BUILD_GET_ROOMALLBLOCK = "BuildGetRoomAllBlock";
            this.BUILD_FINDBLOCKPOS = "BuildFindBlockPos";
            this.BUILD_PARALYSIS_ON = "BuildParalysis_on";
            this.BUILD_SKILLEVENT = "BuildSkillEvent";
            this.BUILD_SETTWINKSKin = "BuildSetTWinkSkin";
            this.BUILD_SET_ROOM_DIE = "BuildSetRoomDie";
            this.BUILD_GET_AT_BUILDCOUNT = "BuildGetBuildAtCount";
            this.BUILD_GET_GAME_BUILDCOUNT = "BuildGetGameCount";
            this.BUILD_REACHC = "BuildReachConditions";
            this.MAP_BUILD_NEW = "NewBuild";
            this.MAP_UPBUILD = "MapUpBuild";
            this.MAP_BUILD_DISMANTLE = "MapBuildDismantle";
            this.MAP_DISTANCE = "MapReturnDistance";
            this.MAP_ADD_ACTIVITY = "MapAddActivity";
            this.MAP_GET_ACTIVITYMAP = "MapGetActivityMap";
            this.MAP_MAPMOVE = "MapMapMove";
            this.MAP_DEMOLISH = "MAPDemolish";
            this.MGM_START_END_PATH = "MGMGetStartPos_EndPos_Path";
            this.MGM_PROTAGONIST_MOVE = "MGMProtagonistMove";
            this.MGM_AIORTROLLIS_MOVE = "MGMAIOrTrollIsMove";
            this.MGM_FIND_AROUND_BUILD = "MGMFindTheTarget";
            this.MGM_GET_ROOMCOUNT = "MGMGetRoomCount";
            this.MGM_GET_BLOCKFINDROOM = "MGMGetBlockIsRoom";
            this.MGM_SET_BLOCKWALKABLE = "MGMSetBlockWalkable";
            this.MGM_SET_BLOCKDYNWALKABLE = "MGMSetBlockDynWalkable";
            this.MGM_GET_OPENSPACE = "MGMGetOpenSpace";
            this.MGM_MONTIORPLAYERAROUND = "MGMMonitorPlayerAround";
            this.MGM_FINDPOSBLOCK = "MGMFindPosBLock";
            this.MGM_BUILDDIE = "MGMBuildDie";
            this.MGM_GET_DATAPOSTMAPPOS = "MGMGetDataPosTMapPos";
            this.MGM_GET_MAPPOSTSCENEPOS = "MGMGetMapPosTScenePos";
            this.MGM_GET_BLOCKPOSS = "MGMGetBlockPosS";
            this.MGM_GET_POSAROUND = "MGMGetPosAroundBuild";
            this.MGM_IS_SCREENRANGE = "MGMIsScreenRange";
            this.MGM_ROOMBLACK = "MGMRoomBlack";
            this.MGM_LOOKPOS = "MGMLookPos";
            this.TL_GET_AROUNDPLAYER = "TLGetAroundPlayer";
            this.TL_MOVESELECT_HANDLE = "TLMoveSelectHandle";
            this.TL_MOVEOVER_HANDLE = "TLMoveOverHandle";
            this.TL_STARTATTACK = "TLStartAttack";
            this.TL_TROLLHIT = "TLTrollHit";
            this.TL_MOVESPEED_REDUCTION = "TLMoveSpeedReduction";
            this.TL_VERTIGO_REDUCTION = "TLVertigoReduction";
            this.PAIL_FILTERDIEAI = "PAILFilterDieAI";
            this.PAIL_KILLPLAYER = "PAILKillPlayer";
            this.PAIL_SET_ATTACKEDAI = "PAILSetAtackedAI";
            this.OINPUT_Event_RS_ON = "OInPutEvent_RS_on";
            this.OINPUT_Event_ON = "OInPutEvent_on";
            this.PLOGIC_OFFEVENTHANDLE = "PLogicOffEventHandle";
            this.PLOGIC_TESTAROUNDBLOCK = "PLogicTestAroundBlock";
            this.GM_STARTGAME = "GMStartGame";
            this.GM_GAMEOVER = "GMGameOver";
            this.UIGM_SHOW = "UIGMshow";
            this.UIGM_HIDE = "UIGMhide";
            this.UIGM_TIPS = "UIGMTips";
            this.UIGM_SHOWSKILL = "UIGMShowSkill";
            this.UIGM_HIDESKILL = "UIGMHideSkill";
            this.UIGM_PLAYERHIT = "UIGMPlayerHit";
            this.UIGM_PLAYERHITEFFECT = "UIGMplayerHitEffect";
            this.SKILL_ADDUPEVENT = "SkillAddEvent";
            this.BATTLEUI_TASKCOMPLETE = "BattleUITaskComplete";
            this.MAINLG_TROLLUPDATA = "MainLgTrollUpData";
        }
    }

    class EventCenter extends EventBase {
        constructor() {
            super(...arguments);
            this.listEvent = {};
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                this._ins = new EventCenter();
            }
            return this._ins;
        }
        AddListEvent(name, callback, context) {
            let observer = this.listEvent[name];
            if (observer) {
                this.listEvent[name] = null;
            }
            this.listEvent[name] = new Observer(callback, context);
        }
        removeListEvent(name, context) {
            let observer = this.listEvent[name];
            if (!observer) {
                return;
            }
            delete this.listEvent[name];
        }
        Fire(name, ...args) {
            let observer = this.listEvent[name];
            if (!observer) {
                return;
            }
            observer.notify(...args);
        }
        FireReturn(name, ...args) {
            let observer = this.listEvent[name];
            if (!observer) {
                return null;
            }
            return observer.notifyReturn(...args);
        }
    }

    class EffectSequence {
        constructor() {
            this.path = "res/effect/";
            this.effectStr = {
                bulletEffect: "bulletEffect",
                trollAttackEffect: "trollAttackEffect",
                trollBaoqiEffect: "trollBaoqiEffect",
                trollZH: "trollZH",
                buildDownEffect: "buildDownEffect",
                build_vertigo: "build_vertigo"
            };
            this.loadeffect = {
                bulletEffect: false,
                trollAttackEffect: false,
                trollBaoqiEffect: false,
                trollZH: false,
                buildDownEffect: false,
                build_vertigo: false
            };
            this.bulletArr = [];
            this.playEffectPos = [];
            this.AddUpData();
        }
        static get instance() {
            if (!this._ins && this._ins == null) {
                this._ins = new EffectSequence();
            }
            return this._ins;
        }
        AddUpData() {
            UpEventHandle.instance.AddUPEvent("EffectPlayUp", this.PlayEffectUp, this);
        }
        getEffect(name, x, y, iszOeder, loop) {
            if (this.bulletArr.length > 0) {
                for (let i = 0; i < this.bulletArr.length; i++) {
                    let eff = this.bulletArr[i];
                    if (eff.anim == null) {
                        continue;
                    }
                    if (eff.effectName == name) {
                        let anim = eff.anim;
                        eff.anim = null;
                        return anim;
                    }
                }
            }
            if (!this.loadeffect[name]) {
                Laya.loader.load(this.path + name + ".atlas", Laya.Handler.create(this, () => {
                    let anim = new Laya.Animation();
                    anim.loadAtlas(this.path + name + ".atlas");
                    anim.play(0, false);
                    let bounds = anim.getGraphicBounds(true);
                    anim.pivot(bounds.width / 2, bounds.height / 2);
                    this.loadeffect[name] = true;
                    this.PlayAnim(anim, x, y, name, iszOeder, loop);
                }));
            }
            else {
                let anim = new Laya.Animation();
                anim.loadAtlas(this.path + name + ".atlas");
                anim.play(0, false);
                let bounds = anim.getGraphicBounds(true);
                anim.pivot(bounds.width / 2, bounds.height / 2);
                return anim;
            }
        }
        PlayEffectUp() {
            if (this.playEffectPos.length > 0) {
                let effInfo = this.playEffectPos.shift();
                let eff = this.getEffect(effInfo.effectName, effInfo.pos.x, effInfo.pos.y, effInfo.iszOeder, effInfo.loop);
                if (eff != null) {
                    this.PlayAnim(eff, effInfo.pos.x, effInfo.pos.y, effInfo.effectName, effInfo.iszOeder, effInfo.loop);
                }
            }
        }
        AddBulletArr(effectName, anim) {
            for (let i = 0; i < this.bulletArr.length; i++) {
                let eff = this.bulletArr[i];
                if (eff.effectName == effectName) {
                    if (eff.anim == null) {
                        eff.anim = anim;
                        return;
                    }
                }
            }
            let eff = { effectName: effectName, anim: anim };
            this.bulletArr.push(eff);
        }
        AddEffect(name, x, y, iszOeder = false, loop = 0) {
            this.playEffectPos.push({ effectName: name, pos: { x: x, y: y }, iszOeder: iszOeder, loop: loop });
        }
        PlayAnim(eff, x, y, effectNaem, iszOeder, loop) {
            this.panel.addChild(eff);
            if (!iszOeder) {
                eff.zOrder = y;
            }
            else {
                eff.zOrder = Number.MAX_VALUE;
            }
            eff.pos(x, y);
            if (loop == 0) {
                eff.play(0, false);
                eff.on(Laya.Event.COMPLETE, this, () => {
                    this.AddBulletArr(effectNaem, eff);
                    this.panel.removeChild(eff);
                    eff.offAll();
                });
            }
            else {
                eff.play(0, true);
                Laya.timer.once(loop, this, () => {
                    this.AddBulletArr(effectNaem, eff);
                    this.panel.removeChild(eff);
                    eff.stop();
                });
            }
        }
        get panel() {
            if (this._panel || this._panel == null) {
                this._panel = EventCenter.instance.FireReturn(EventCenter.instance.MAP_GET_ACTIVITYMAP);
            }
            return this._panel;
        }
        GameOver() {
            this.playEffectPos = [];
        }
    }

    class TimeManager {
        constructor() {
            this._listOnce = {};
            this._listLoop = {};
            this._gameTime = 0;
            UpEventHandle.instance.AddUPEvent("TimeManager", this.UpTime, this);
            UpEventHandle.instance.AddUPEvent("HandleOnceEvent", this.HandleOnceEvent, this);
            UpEventHandle.instance.AddUPEvent("HandleLoopEven", this.HandleLoopEven, this);
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                this._ins = new TimeManager();
            }
            return this._ins;
        }
        get gameTime() {
            return this._gameTime / 1000;
        }
        set gameTime(value) {
            this._gameTime = value;
        }
        UpTime() {
            let time = Laya.timer.delta;
            this._gameTime += time;
        }
        StartGame() {
            this._gameTime = 0;
        }
        AfterAPeriodOfTime_Bool(time, timeInterval) {
            let off = this.gameTime - time;
            return off >= timeInterval;
        }
        AfterAPeriodOfTime_Proportion(time, timeInterval) {
            let off = this.gameTime - time;
            off /= timeInterval;
            off *= 1000;
            off = Math.floor(off);
            off /= 1000;
            off = Math.min(1, off);
            return off;
        }
        AddTimeOnceEvent(name, func, context, time) {
            let observer = this._listOnce[name];
            if (observer) {
                this._listOnce[name] = null;
            }
            this._listOnce[name] = { observer: new Observer(func, context), time: time, timeInterval: this.gameTime };
        }
        RemoveListOnceEvent(name) {
            let observer = this._listOnce[name];
            if (!observer) {
                return;
            }
            delete this._listOnce[name];
        }
        AddTimeLoopEvent(name, func, context, time) {
            let observer = this._listLoop[name];
            if (observer) {
                this._listLoop[name] = null;
            }
            this._listLoop[name] = { observer: new Observer(func, context), time: time, timeInterval: this.gameTime };
        }
        RemoveListLoopEvent(name) {
            let observer = this._listLoop[name];
            if (!observer) {
                return;
            }
            delete this._listLoop[name];
        }
        HandleOnceEvent() {
            for (let key in this._listOnce) {
                let observer = this._listOnce[key];
                if (!observer) {
                    continue;
                }
                if (this.AfterAPeriodOfTime_Bool(observer.timeInterval, observer.time)) {
                    observer.observer.notify();
                    this.RemoveListOnceEvent(key);
                }
            }
        }
        HandleLoopEven() {
            for (let key in this._listLoop) {
                let observer = this._listLoop[key];
                if (!observer) {
                    continue;
                }
                if (this.AfterAPeriodOfTime_Bool(observer.timeInterval, observer.time)) {
                    observer.observer.notify();
                    observer.timeInterval = this.gameTime;
                }
            }
        }
        GameOver() {
            this._listLoop = {};
            this._listOnce = {};
        }
    }

    class Sound {
        constructor() {
            this.soundManager = Laya.SoundManager;
            this._room = null;
            this.ppTime = 0;
            this._ppTimeInterval = 3;
            this.BG_music = {
                gameBGM: "bgm.wav",
                gs: "gs.wav"
            };
            this.TB_sound = {
                troll_Wll: "troll_Wall.wav",
                troll_attack: "troll_attack.wav",
                troll_up: "troll_up.wav",
                troll_rage: "troll_rage.wav",
                build_at_attack: "at_attack.wav",
                build_build: "build_build.wav",
                build_up: "build_up.wav",
                build_die: "build_die.wav",
                build_PP: "build_PP.wav"
            };
            this.Other_sound = {
                btn_gameStart: "btn_gameStart.wav",
                ermt_0: "ermt_0.wav",
                timer: "timer.wav",
                game_fail: "game_fail.wav",
                CC: "cc.wav",
                MP: "maopao.wav",
                weixiu: "weixiu.wav",
                tcOpen: "TCOpen.wav",
                Btn_Down: "BtnDown.wav",
                Btn_Up: "BtnUp.wav"
            };
            this.ermt = [];
            this.path = "res/sound/";
        }
        static get instance() {
            if (this._ins || this._ins == null) {
                this._ins = new Sound();
            }
            return this._ins;
        }
        playMusic(url) {
            let path = this.GetPath(url);
            this.soundManager.playMusic(path);
        }
        PlaySound(url, loop = 1, x = null, y = null) {
            let path = this.GetPath(url);
            if (x == null) {
                this.soundManager.playSound(path, loop);
            }
            else {
                let isPlay = EventCenter.instance.FireReturn(EventCenter.instance.MGM_IS_SCREENRANGE, x, y);
                if (isPlay) {
                    this.soundManager.playSound(path, loop);
                }
            }
        }
        StopSound(url) {
            let path = this.GetPath(url);
            this.soundManager.stopSound(path);
        }
        StopMusic() {
            this.soundManager.stopMusic();
        }
        StopAll() {
            this.soundManager.stopAll();
        }
        StopAllSound() {
            this.soundManager.stopAllSound();
        }
        CloaseSound() {
            this.soundManager.stopAllSound();
        }
        GetPath(url) {
            return this.path + url;
        }
        AddUpSound(room) {
            this._room = room;
            TimeManager.instance.AddTimeLoopEvent("Sound_UpSound", this.UpSound, this, 0.1);
        }
        GameOver() {
            this._room = null;
            this.ppTime = 0;
        }
        UpSound() {
        }
    }

    class EffectTween {
        constructor() {
            this.PRArr = new Array();
            this.closeArr = new Array();
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                this._ins = new EffectTween();
            }
            return this._ins;
        }
        Shake(node, off) {
            if (!node || node == null || node == undefined) {
                return;
            }
            node.scaleX = 1;
            node.scaleY = 1;
            Laya.Tween.to(node, { scaleX: 1 + off, scaleY: 1 + off }, 50, null, Laya.Handler.create(this, function () {
                Laya.Tween.to(node, { scaleX: 1 - 2 * off, scaleY: 1 - 2 * off }, 50, null, Laya.Handler.create(this, function () {
                    Laya.Tween.to(node, { scaleX: 1, scaleY: 1 }, 50, null, null, 0, true);
                }), 0, true);
            }), 0, true);
        }
        ShakeHide(node, func) {
            if (!node || node == null || node == undefined) {
                return;
            }
            node.scaleX = 1;
            node.scaleY = 1;
            Laya.Tween.to(node, { scaleX: 0, scaleY: 0 }, 50, null, Laya.Handler.create(this, function () {
                func && func();
            }), 0, true);
        }
        GetPR() {
            let view = null;
            if (this.PRArr.length > 0) {
                view = this.PRArr.shift();
            }
            else {
                view = new Laya.View();
                let s = Laya.loader.getRes("Prefabs/RF.json");
                view.createView(s);
            }
            return view;
        }
        RFEffect(img, num, block) {
            var node = this.GetPR();
            if (node == null) {
                return;
            }
            block.parent.addChild(node);
            let index = this.closeArr.length;
            this.closeArr.push({ index: index, view: node });
            node.getChildAt(0).skin = img;
            node.getChildAt(1).text = "+" + num;
            node.alpha = 0;
            node.scaleY = 0;
            node.scaleX = 0;
            node.pos(block.x, block.y);
            Laya.Tween.to(node, { alpha: 1, scaleX: 1, scaleY: 1, y: node.y - 15 }, 500, null, Laya.Handler.create(this, function () {
                Laya.Tween.to(node, { y: node.y - 45 }, 1000, null, Laya.Handler.create(this, function () {
                    Laya.Tween.to(node, { y: node.y - 45, alpha: 0, scaleX: 0, scaleY: 0 }, 1000, null, Laya.Handler.create(this, function () {
                        this.PRArr.push(node);
                        if (node.parent != null) {
                            node.parent.removeChild(node);
                        }
                        this.RemoveCloseArr(node);
                    }), 0, true);
                }), 0, true);
            }), 0, true);
        }
        RemoveCloseArr(node) {
            if (this.closeArr.length > 0) {
                for (let i = this.closeArr.length - 1; i >= 0; i--) {
                    let close = this.closeArr[i];
                    if (close.view == node) {
                        this.closeArr.splice(i, 1);
                        return;
                    }
                }
            }
        }
        GameOver() {
            if (this.closeArr.length > 0) {
                for (let i = 0; i < this.closeArr.length; i++) {
                    let node = this.closeArr[i];
                    if (node.view.parent != null) {
                        node.view.parent.removeChild(node.view);
                        this.PRArr.push(node.view);
                    }
                }
                this.closeArr.length = 0;
            }
        }
        Hide(node) {
            if (!node || node == null || node == undefined) {
                return;
            }
            Laya.Tween.to(node, { scaleX: 0, scaleY: 0 }, 200, null, Laya.Handler.create(this, () => {
                node.visible = false;
            }), 0, true);
        }
        Show(node) {
            if (!node || node == null || node == undefined) {
                return;
            }
            node.visible = true;
            Laya.Tween.to(node, { scaleX: 1, scaleY: 1 }, 200, null, null, 0, true);
        }
        Alpha(node, time = 1, alpha = 1) {
            if (!node || node == null || node == undefined) {
                return;
            }
            Laya.Tween.to(node, { alpha: alpha }, time * 1000, null, null, 0, true);
        }
        ClickDown(btn) {
            Laya.Tween.to(btn, { scaleX: 0.9, scaleY: 0.9 }, 50, null, null, 0, true);
            Sound.instance.PlaySound(Sound.instance.Other_sound.Btn_Down);
        }
        ClickUp(btn) {
            Laya.Tween.to(btn, { scaleX: 1, scaleY: 1 }, 50, null, null, 0, true);
            Sound.instance.PlaySound(Sound.instance.Other_sound.Btn_Up);
        }
        MoveOut(btn) {
            Laya.Tween.to(btn, { scaleX: 1, scaleY: 1 }, 50, null, null, 0, true);
            Sound.instance.PlaySound(Sound.instance.Other_sound.Btn_Up);
        }
        AddBtnEvent(btnArr) {
            if (btnArr.length > 0) {
                for (let i = 0; i < btnArr.length; i++) {
                    let btn = btnArr[i];
                    btn.on(Laya.Event.MOUSE_DOWN, this, this.ClickDown, [btn]);
                    btn.on(Laya.Event.MOUSE_UP, this, this.ClickUp, [btn]);
                    btn.on(Laya.Event.MOUSE_OUT, this, this.MoveOut, [btn]);
                }
            }
        }
        RemoveBtnEvent(btnArr) {
            if (btnArr.length > 0) {
                for (let i = 0; i < btnArr.length; i++) {
                    let btn = btnArr[i];
                    btn.off(Laya.Event.MOUSE_DOWN, this, this.ClickDown);
                    btn.off(Laya.Event.MOUSE_UP, this, this.ClickUp);
                    btn.off(Laya.Event.MOUSE_OUT, this, this.MoveOut);
                }
            }
        }
        Breathing(node, index, count, alpha = 1) {
            if (!node || node == null || node == undefined) {
                return;
            }
            if (index == count) {
                return;
            }
            index++;
            Laya.Tween.to(node, { alpha: alpha }, 200, null, Laya.Handler.create(this, () => {
                alpha = alpha == 0 ? 1 : 0;
                this.Breathing(node, index, count, alpha);
            }), 0, true);
        }
        ShakeHead(node, index, count, alpha = -1) {
            if (!node || node == null || node == undefined) {
                return;
            }
            if (index == count) {
                return;
            }
            index++;
            Laya.Tween.to(node, { x: node.x + 2 * alpha }, 50, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(node, { x: node.x + 2 * alpha * -1 }, 50, null, Laya.Handler.create(this, () => {
                    alpha = alpha == -1 ? 1 : -1;
                    this.ShakeHead(node, index, count, alpha);
                }), 0, true);
            }), 0, true);
        }
        RotEffect(node, index, count, alpha = -1, isLoop = false) {
            if (!node || node == null || node == undefined) {
                return;
            }
            if (index == count) {
                if (isLoop) {
                    Laya.timer.once(1000, this, () => {
                        if (!node.visible) {
                            return;
                        }
                        this.RotEffect(node, 0, count, -1, true);
                    }, null, true);
                }
                return;
            }
            index++;
            Laya.Tween.to(node, { rotation: node.rotation + 10 * alpha }, 50, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(node, { rotation: node.rotation + 10 * alpha * -1 }, 50, null, Laya.Handler.create(this, () => {
                    alpha = alpha == -1 ? 1 : -1;
                    this.RotEffect(node, index, count, alpha, isLoop);
                }), 0, true);
            }), 0, true);
        }
        ScaleEffect(node, index, count, alpha = -1, isLoop = false) {
            if (!node || node == null || node == undefined) {
                return;
            }
            if (index == count) {
                if (isLoop) {
                    Laya.timer.once(1000, this, () => {
                        if (node.visible == false) {
                            return;
                        }
                        this.ScaleEffect(node, 0, count, -1, true);
                    }, null, true);
                }
                return;
            }
            index++;
            Laya.Tween.to(node, { scaleX: node.scaleX + 0.1 * alpha, scaleY: node.scaleY + 0.1 * alpha }, 50, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(node, { scaleX: node.scaleX + 0.1 * alpha * -1, scaleY: node.scaleY + 0.1 * alpha * -1 }, 50, null, Laya.Handler.create(this, () => {
                    alpha = alpha == -1 ? 1 : -1;
                    this.ScaleEffect(node, index, count, alpha, isLoop);
                }), 0, true);
            }), 0, true);
        }
        ADVEffect(node, mod = 0) {
            if (!node || node == null || node == undefined) {
                return;
            }
            if (!node.visible) {
                return;
            }
            if (mod == 0) {
                Laya.timer.once(2000, this, () => {
                    this.RotEffect(node, 0, 5);
                    this.ADVEffect(node, 1);
                }, null, true);
            }
            else {
                Laya.timer.once(2000, this, () => {
                    this.ScaleEffect(node, 0, 5);
                    this.ADVEffect(node, 0);
                }, null, true);
            }
        }
        RotEffect_360(node, rot) {
            if (!node || node == null || node == undefined) {
                return;
            }
            if (!node.visible) {
                return;
            }
            Laya.Tween.to(node, { rotation: node.rotation + rot }, 1000, null, Laya.Handler.create(this, () => {
                this.RotEffect_360(node, rot);
            }), 0, true);
        }
        Gold3Effwct(node) {
            if (!node) {
                return;
            }
            let y = node.y;
            node.visible = true;
            node.scale(0, 0);
            Laya.Tween.to(node, { scaleX: 1, scaleY: 1, y: node.y - 10 }, 200, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(node, { y: node.y - 30 }, 500, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(node, { scaleX: 0, scaleY: 0, y: node.y - 20 }, 500, null, Laya.Handler.create(this, () => {
                        node.y = y;
                        node.visible = false;
                    }, null, true));
                }, null, true));
            }, null, true));
        }
    }

    class PlayerBase {
        constructor() {
            this.uid = -1;
            this.name = null;
            this._roomIndex = -1;
            this._curRoom = -1;
            this._playerType = -1;
            this._skPath = "res/Skeleton/player/player_0.sk";
            this._animIndex = -1;
            this._speed = 3;
            this._bed = null;
            this._isBed = false;
            this._isRoom = false;
            this._isGod = false;
            this._isDie = false;
            this._buildAdvantage = 0;
            this._advantage = 0;
            this._HP = 1;
            this._dieTime = null;
        }
        get animNum() {
            return 5;
        }
        set playerType(value) {
            this._playerType = value;
        }
        get playerType() {
            return this._playerType;
        }
        get roomIndex() {
            return this._roomIndex;
        }
        set roomIndex(value) {
            this._roomIndex = value;
        }
        get curRoom() {
            return this._curRoom;
        }
        set curRoom(value) {
            this._curRoom = value;
        }
        LoadAnim() {
            this._animFactory = new Laya.Templet();
            this._animFactory.on(Laya.Event.COMPLETE, this, this.parseComplete);
            this._animFactory.loadAni(this.skin);
        }
        parseComplete() {
            if (this._player != null) {
                this._player.destroy();
            }
            this._player = this._animFactory.buildArmature(0);
            this._player.visible = true;
            this._player.play(1, true);
            this._player.pivotY = -20;
            let pos = DataManager.instance.build.GetAIPos(this._playerType);
            this.SetPlayerPos(pos[0], pos[1]);
            this._player.zOrder = this._player.y;
        }
        SetPlayerPos(x, y) {
            EventCenter.instance.Fire(EventCenter.instance.MAP_ADD_ACTIVITY, this.player, x, y);
        }
        get player() {
            if (this._player) {
                return this._player;
            }
            else {
                return null;
            }
        }
        get x() {
            return this.player.x;
        }
        get y() {
            return this.player.y;
        }
        set x(value) {
            this.player.x = value;
        }
        set y(value) {
            this.player.y = value;
        }
        get speed() {
            return this._speed;
        }
        set speed(value) {
            this._speed = value;
        }
        set isbed(value) {
            this._isBed = value;
        }
        get isbed() {
            return this._isBed;
        }
        get isRoom() {
            return this._isRoom;
        }
        set isRoom(value) {
            this._isRoom = value;
        }
        set buildAdvantage(value) {
            this._buildAdvantage += value;
        }
        get advantage() {
            if (this.isRoom) {
                this._advantage += 20;
            }
            if (this.isbed) {
                this._advantage += 10;
            }
            this._advantage += this._buildAdvantage;
            return this._advantage;
        }
        Hit(power) {
            this._HP -= power;
            if (this._HP <= 0) {
                EventCenter.instance.Fire(EventCenter.instance.UIGM_PLAYERHIT, this.uid);
            }
            return this._HP > 0;
        }
        get isGod() {
            return this._isGod;
        }
        set isGod(value) {
            this._isGod = value;
        }
        get isDie() {
            this._isDie = this._HP > 0;
            if (!this._isDie) {
                this.player.visible = false;
                this._dieTime = TimeManager.instance.gameTime;
            }
            return this._isDie;
        }
        set direction(value) {
            this.player.scaleX = value;
        }
        set bed(value) {
            this._bed = value;
        }
        get bed() {
            return this._bed;
        }
        GameOver() {
            this._HP = 1;
            this._isBed = false;
            this._isRoom = false;
            this._isGod = false;
            this._roomIndex = -1;
            this._curRoom = -1;
            this._playerType = -1;
            this._isDie = false;
            this.player.visible = false;
            this._buildAdvantage = 0;
            this.player.parent.removeChild(this.player);
            this.bed = null;
            this.name = null;
            this._dieTime = null;
        }
        set id(value) {
            this._id = value;
        }
        get id() {
            return this._id + 1;
        }
        get skin() {
            if (this._id > 5) {
                return this._skPath;
            }
            return this._skPath = "res/Skeleton/player/player_" + this._id + ".sk";
        }
        get dieTime() {
            if (this._dieTime == null) {
                return TimeManager.instance.gameTime;
            }
            return this._dieTime;
        }
        get win() {
            if (this.isGod) {
                return DataManager.instance.player.win;
            }
            else {
                return Math.floor(Math.random() * 100);
            }
        }
        get lose() {
            if (this.isGod) {
                return DataManager.instance.player.lose;
            }
            else {
                return Math.floor(Math.random() * 100);
            }
        }
    }

    class Player extends PlayerBase {
    }

    class PlayerManager {
        constructor() {
            PlayerManager._ins = this;
            this._diePlayer = [];
            this._players = [];
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                return null;
            }
            return this._ins;
        }
        gettroll() {
        }
        StartGame(num) {
            this.CreateAllPlayer(num);
        }
        CreateAllPlayer(count = 1) {
            for (let i = 0; i < count; i++) {
                this.CreatePlayer(i);
            }
            this._player = this._players[0];
            this._player.isGod = true;
            this._player.name = "我";
        }
        CreatePlayer(playerType = 0) {
            let player = this.GetDiePlayer();
            this._players.push(player);
            player.playerType = playerType;
            player.isGod = false;
            if (playerType == 0) {
                player.id = this.selectIndex;
            }
            else {
                let info = DataManager.instance.game.GetPlayerArr(playerType - 1);
                player.id = info.index;
                player.name = info.name;
            }
            player.uid = playerType;
            player.LoadAnim();
        }
        GetDiePlayer() {
            if (this._diePlayer.length > 0) {
                return this._diePlayer.shift();
            }
            let player = new Player();
            return player;
        }
        get playerSorts() {
            if (this._players.length > 3) {
                for (let i = 0; i < this._players.length; i++) {
                    let player1 = this._players[i];
                    for (let j = 1; j < this._players.length; j++) {
                        let player2 = this._players[j];
                        if (player2.advantage < player1.advantage) {
                            let p = player1;
                            player1 = player2;
                            player2 = p;
                        }
                    }
                }
            }
            return this._players;
        }
        get players() {
            let players = [];
            for (let i = 0; i < this._players.length; i++) {
                let player = this._players[i];
                if (!player.isGod) {
                    players.push(player);
                }
            }
            return players;
        }
        get player() {
            return this._player;
        }
        get playerArr() {
            return this._players;
        }
        GameOver() {
            if (this._players.length > 0) {
                for (let i = 0; i < this._players.length; i++) {
                    let player = this._players[i];
                    player.GameOver();
                    this._diePlayer.push(player);
                }
                this._players.length = 0;
            }
            this._player = undefined;
        }
        get selectIndex() {
            return DataManager.instance.player.playerSelectIndex;
        }
        GetPlayerName(roomIndex) {
            for (let i = 0; i < this._players.length; i++) {
                let player = this._players[i];
                if (player.roomIndex == roomIndex) {
                    return player.name;
                }
            }
            return null;
        }
        GetPlayerSkinId(roomIndex) {
            for (let i = 0; i < this._players.length; i++) {
                let player = this._players[i];
                if (player.roomIndex == roomIndex) {
                    return player.id;
                }
            }
            return 0;
        }
        get head() {
            if (this._players.length > 0) {
                let headarr = [];
                for (let i = 1; i < this._players.length; i++) {
                    let player = this._players[i];
                    headarr.push(player.id - 1);
                }
                return headarr;
            }
            return null;
        }
        LookPos(index) {
            if (this._player.roomIndex == -1) {
                return;
            }
            if (index + 1 < this._players.length) {
                let player = this._players[index + 1];
                if (player) {
                    EventCenter.instance.Fire(EventCenter.instance.MGM_LOOKPOS, player.x, player.y);
                }
            }
            else if (index + 1 == this._players.length) {
                EventCenter.instance.Fire(EventCenter.instance.MGM_LOOKPOS, this._player.x, this._player.y);
            }
        }
    }

    class GameDynamics {
        constructor() {
            this.Init();
            this.AddUPEvent();
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                this._ins = new GameDynamics();
            }
            return this._ins;
        }
        AddUPEvent() {
            UpEventHandle.instance.AddUPEvent("UpHandleEvent", this.UpHandleEvent, this);
        }
        removeUpEvent() {
            UpEventHandle.instance.removeListEvent("UpHandleEvent");
        }
        Init() {
            this._moveArr = new Array();
            this._rotArr = new Array();
            this._trackMoveArr = new Array();
            this._scaleArr = new Array();
        }
        Move(element) {
            let moveoff = element.speed / 60;
            if (element.pos.length > 0) {
                let pos = element.pos[0];
                let xdiff = element.node.x - pos[0];
                let ydiff = element.node.y - pos[1];
                var diffCount = Math.abs(xdiff) + Math.abs(ydiff);
                if (xdiff > 0) {
                    element.node.x -= moveoff * (Math.abs(xdiff) / diffCount);
                }
                else if (xdiff < 0) {
                    element.node.x += moveoff * (Math.abs(xdiff) / diffCount);
                }
                if (ydiff > 0) {
                    element.node.y -= moveoff * (Math.abs(ydiff) / diffCount);
                }
                else if (ydiff < 0) {
                    element.node.y += moveoff * (Math.abs(ydiff) / diffCount);
                }
                if (Math.abs(xdiff) < moveoff) {
                    element.node.x = pos[0];
                }
                if (Math.abs(ydiff) < moveoff) {
                    element.node.y = pos[1];
                }
                if (element.node.x == pos[0] && element.node.y == pos[1]) {
                    if (element.pos.length == 1) {
                        this.RemoveArr(element.node, this._moveArr);
                        return true;
                    }
                    else {
                        element.pos.shift();
                        return false;
                    }
                }
                return false;
            }
        }
        TrackMove(element) {
            let moveoff = element.moveSpeed / 60;
            let rotoff = element.rotSpeed / 60;
            let x = element.node.x;
            let y = element.node.y;
            let xdiff = x - element.tar.x;
            let ydiff = y - element.tar.y;
            var countDiff = Math.abs(xdiff) + Math.abs(ydiff);
            let angle = this.AircraftAngle(element.node, element.tar);
            let rotdiff = element.node.rotation - angle;
            let rotdiff2;
            if (rotdiff > 0) {
                rotdiff2 = element.node.rotation - 360 - angle;
            }
            else {
                rotdiff2 = element.node.rotation + 360 - angle;
            }
            if (Math.abs(rotdiff) > Math.abs(rotdiff2)) {
                rotdiff = rotdiff2;
            }
            if (Math.abs(rotdiff) < rotoff) {
                element.node.rotation = angle;
            }
            else {
                if (rotdiff > 0) {
                    element.node.rotation -= rotoff;
                }
                else {
                    element.node.rotation += rotoff;
                }
            }
            if (xdiff > 0) {
                element.node.x -= moveoff * (Math.abs(xdiff) / countDiff);
            }
            else if (xdiff < 0) {
                element.node.x += moveoff * (Math.abs(xdiff) / countDiff);
            }
            if (ydiff > 0) {
                element.node.y -= moveoff * (Math.abs(ydiff) / countDiff);
            }
            else if (ydiff < 0) {
                element.node.y += moveoff * (Math.abs(ydiff) / countDiff);
            }
            if (Math.abs(xdiff) < 5 && Math.abs(ydiff) < 5) {
                this.RemoveArr(element.node, this._trackMoveArr);
                element.node.visible = false;
            }
        }
        Rot(element) {
            let rotoff = element.rotSpeed / 60;
            let rotdiff = element.node.rotation - element.angle;
            let rotdiff2;
            if (rotdiff > 0) {
                rotdiff2 = element.node.rotation - 360 - element.angle;
            }
            else {
                rotdiff2 = element.node.rotation + 360 - element.angle;
            }
            if (Math.abs(rotdiff) > Math.abs(rotdiff2)) {
                rotdiff = rotdiff2;
            }
            if (Math.abs(rotdiff) < 10) {
                element.node.rotation = element.angle;
                this.RemoveArr(element.node, this._rotArr);
                element.func && element.func();
            }
            else {
                if (rotdiff > 0) {
                    element.node.rotation -= rotoff;
                }
                else {
                    element.node.rotation += rotoff;
                }
            }
        }
        AircraftAngle(node, target) {
            var nodepos = node.localToGlobal(new Laya.Point(node.pivotX, node.pivotY));
            var targetPos = target.localToGlobal(new Laya.Point(target.pivotX, target.pivotY));
            var A = [0, 1];
            var B = [nodepos.x, nodepos.y];
            var C = [targetPos.x, targetPos.y];
            var CB = [B[0] - C[0], B[1] - C[1]];
            var sinACB = (A[0] * CB[1] - A[1] * CB[0]) / (Math.sqrt((Math.pow(A[0], 2) + Math.pow(A[1], 2))) * Math.sqrt((Math.pow(CB[0], 2) + Math.pow(CB[1], 2))));
            var angle = Math.asin(sinACB) / Math.PI * 180;
            if (CB[1] <= 0) {
                angle = 180 - angle;
            }
            angle = angle % 360;
            return angle;
        }
        RemoveArr(node, arr) {
            for (let i = 0; i < arr.length; i++) {
                if (node == arr[i].node) {
                    arr.splice(i, 1);
                    break;
                }
            }
        }
        SetRot(node, tar) {
            node.rotation = this.AircraftAngle(node, tar);
        }
        Scale(element) {
            element.node.scaleX += element.off;
            element.node.scaleY += element.off;
            if (element.node.scaleX >= element.x && element.node.scaleY >= element.y) {
                element.node.scaleX = element.x;
                element.node.scaleY = element.y;
                this.RemoveArr(element.node, this._scaleArr);
            }
        }
        AddMove(node, pos, speed) {
            this._moveArr.forEach(element => {
                if (element.node == node) {
                    element.pos = pos;
                    element.speed = speed;
                    return;
                }
            });
            let move = { node: node, pos: pos, speed: speed };
            this._moveArr.push(move);
        }
        AddTMoveMent(node, tar, rotSpeed, moveSpeed) {
            this._trackMoveArr.forEach(element => {
                if (element.node == node) {
                    element.tar = tar;
                    element.rotSpeed = rotSpeed;
                    element.moveSpeed = moveSpeed;
                    return;
                }
            });
            let move = { node: node, tar: tar, rotSpeed: rotSpeed, moveSpeed: moveSpeed };
            this._trackMoveArr.push(move);
        }
        AddRotation(node, target, rotSpeed, func) {
            let angle = this.AircraftAngle(node, target);
            this._rotArr.forEach(element => {
                if (element.node == node) {
                    element.angle = angle;
                    element.rotSpeed = rotSpeed;
                    element.tar = target;
                    element.func = func;
                    return;
                }
            });
            let rot = { node: node, tar: target, angle: angle, rotSpeed: rotSpeed, func: func };
            this._rotArr.push(rot);
        }
        AddScale(node, x, y, off) {
            this._scaleArr.forEach(element => {
                if (element.node == node) {
                    element.x = x;
                    element.y = y;
                    element.off = off;
                    return;
                }
            });
            let move = { node: node, x: x, y: y, off: off };
            this._scaleArr.push(move);
        }
        HandelMoveEvent_Update() {
            if (this._moveArr.length > 0) {
                for (let i = this._moveArr.length - 1; i >= 0; i--) {
                    let element = this._moveArr[i];
                    this.Move(element);
                }
            }
        }
        HandelRotEvent_Update() {
            if (this._rotArr.length > 0) {
                for (let i = this._rotArr.length - 1; i >= 0; i--) {
                    let element = this._rotArr[i];
                    this.Rot(element);
                }
            }
        }
        HandelTrackMoveMentEvent_Update() {
            if (this._trackMoveArr.length > 0) {
                for (let i = this._trackMoveArr.length - 1; i >= 0; i--) {
                    let element = this._trackMoveArr[i];
                    this.TrackMove(element);
                }
            }
        }
        HandleScaleEvent_Update() {
            if (this._scaleArr.length > 0) {
                for (let i = 0; i < this._scaleArr.length; i++) {
                    let element = this._scaleArr[i];
                    this.Scale(element);
                }
            }
        }
        UpHandleEvent() {
            this.HandelRotEvent_Update();
            this.HandelMoveEvent_Update();
            this.HandelTrackMoveMentEvent_Update();
            this.HandleScaleEvent_Update();
        }
        OperationMovement(node, RSXS, RSYS) {
            node.x += RSXS;
            node.y += RSYS;
        }
        GameOver() {
            this._moveArr.length = 0;
            this._rotArr.length = 0;
            this._trackMoveArr.length = 0;
        }
    }

    class Block {
        constructor() {
            this._isUse = false;
            this._isOpen = true;
            this._build = null;
            this._name = null;
            this._level = -1;
            this._pos = { x: null, y: null };
            this._invincible = false;
            this._HPStrip = null;
            this._battleBB = null;
            this._promptUpImg = null;
            this.isPromptUp = false;
            this._x = null;
            this._y = null;
        }
        Hit(power) {
            if (this.invincible) {
                return true;
            }
            this.hpCur -= power;
            if (this.hp <= 0) {
                this.isUse = false;
                this.hpCur = 0;
            }
            this.hpStrip = this.hp;
            if (!this._HPStrip.visible) {
                this._HPStrip.visible = true;
            }
            let s = this.hpCur > 0;
            EffectTween.instance.Shake(this.build, (1 - this.hp) / 5 + 0.05);
            if (!s) {
                this.room.Die(this);
                this.build.visible = false;
                Sound.instance.PlaySound(Sound.instance.TB_sound.build_die, 1, this.x, this.y);
                EventCenter.instance.Fire(EventCenter.instance.BUILD_SETTWINKSKin, this.x, this.y);
                EventCenter.instance.Fire(EventCenter.instance.MGM_BUILDDIE, this.x, this.y, this.build);
                this.GameOver();
            }
            return s;
        }
        set hpMax(value) {
            if (value < 0) {
                return;
            }
            this._hpMax = value;
        }
        get hpMax() {
            return this._hpMax;
        }
        set hpCur(value) {
            if (value < 0) {
                value = 0;
            }
            if (value > this._hpMax) {
                value = this._hpMax;
            }
            this._hpCur = value;
            this.hpStripView = this.hp;
        }
        get hpCur() {
            return this._hpCur;
        }
        get hp() {
            return this.hpCur / this.hpMax;
        }
        set battleBB(v) {
            this._battleBB = v;
        }
        get battleBB() {
            return this._battleBB;
        }
        get isOpen() {
            return this._isOpen;
        }
        set isOpen(value) {
            this._isOpen = value;
        }
        set build(value) {
            this._build = value;
            if (this._build == null) {
                this._x = null;
                this._y = null;
            }
            else {
                this._x = this.build.x;
                this._y = this.build.y;
            }
            if (value == null) {
                this.level = -1;
            }
            else {
                let level = parseInt(value.name.split("_")[1]);
                this._level = level;
            }
        }
        get build() {
            return this._build;
        }
        set level(value) {
            if (value >= this._level) {
                this._level = value;
            }
        }
        get level() {
            return Math.max(0, this._level);
        }
        set time(value) {
            if (value < 0) {
                this._time = 0;
            }
            else {
                this._time = value;
            }
        }
        get time() {
            return this._time;
        }
        set timeInterval(value) {
            if (value < 0) {
                this._timeInterval = 0;
            }
            else {
                this._timeInterval = value;
            }
        }
        get timeInterval() {
            return this._timeInterval;
        }
        get name() {
            if (this._name == null) {
                if (this._build != null) {
                    this._name = this._build.name.split("_")[0];
                }
            }
            return this._name;
        }
        get buildName() {
            return this.name + "_" + this.level;
        }
        get isUse() {
            return this._isUse;
        }
        set isUse(value) {
            this._isUse = value;
        }
        set hpStripView(value) {
            if (this._HPStrip != null) {
                this.hpStrip = value;
            }
        }
        set hpStrip(value) {
            if (this._HPStrip == null) {
                let info = Laya.loader.getRes("Prefabs/BuildBloodStrip.json");
                this._HPStrip = new Laya.View();
                this._HPStrip.createView(info);
                this._build.addChild(this._HPStrip);
                let rot = this.build.rotation / 90;
                if (rot == 0) {
                    this._HPStrip.pos(45, 10);
                }
                else if (rot == 1) {
                    this._HPStrip.pos(10, 45);
                }
                else if (rot == 2) {
                    this._HPStrip.pos(45, 80);
                }
                else if (rot == 3) {
                    this._HPStrip.pos(80, 45);
                }
                this._HPStrip.zOrder = 3;
                this._HPStrip.rotation = -this._build.rotation;
            }
            else if (this._HPStrip.parent != this._build) {
                this._build.addChild(this._HPStrip);
                let rot = this.build.rotation / 90;
                if (rot == 0) {
                    this._HPStrip.pos(45, 10);
                }
                else if (rot == 1) {
                    this._HPStrip.pos(10, 45);
                }
                else if (rot == 2) {
                    this._HPStrip.pos(45, 80);
                }
                else if (rot == 3) {
                    this._HPStrip.pos(80, 45);
                }
                this._HPStrip.rotation = -this._build.rotation;
            }
            if (value >= 0 && value <= 1) {
                this._HPStrip.getChildAt(1).scaleX = value;
            }
        }
        get x() {
            return this._x;
        }
        get y() {
            return this._y;
        }
        GameOver() {
            this.HidePromptUp();
            this._GameOver();
            if (this._HPStrip != null) {
                if (this._build && this._build != null) {
                    if (this._HPStrip.parent == this._build) {
                        this._build.removeChild(this._HPStrip);
                        this._HPStrip.visible = false;
                    }
                }
            }
            this.isUse = false;
            this.build = null;
            this.isOpen = true;
            this.invincible = false;
            this.room = null;
            this._name = null;
        }
        _GameOver() {
            EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, this.build, null);
        }
        get pos() {
            return this._pos;
        }
        set pos(value) {
            this._pos = value;
        }
        set room(value) {
            this._room = value;
        }
        get room() {
            return this._room;
        }
        set invincible(value) {
            this._invincible = value;
        }
        get invincible() {
            return this._invincible;
        }
        get roomIndex() {
            return this.room.roomIndex;
        }
        ShowPromptUp() {
            if (!this._promptUpImg) {
                this._promptUpImg = new Laya.Image();
                this._promptUpImg.width = 42;
                this._promptUpImg.height = 42;
                this._promptUpImg.pivot(21, 21);
                this._promptUpImg.skin = "UI/Up.png";
                this._promptUpImg.zOrder = Number.MAX_VALUE;
            }
            if (this._build) {
                this._build.parent.addChild(this._promptUpImg);
                this._promptUpImg.visible = true;
                this._promptUpImg.pos(this.x, this.y);
                EffectTween.instance.Shake(this._promptUpImg, 0.1);
                this.UpDownTween(this._promptUpImg);
            }
        }
        UpDownTween(node, index = 1) {
            Laya.Tween.to(node, { y: node.y + 10 * index }, 200, null, Laya.Handler.create(this, () => {
                this.UpDownTween(node, index * -1);
            }), 0, true);
        }
        HidePromptUp() {
            if (this._promptUpImg) {
                Laya.Tween.clearAll(this._promptUpImg);
                this._promptUpImg.removeSelf();
                this._promptUpImg.visible = false;
            }
            if (this._build != null) {
                EventCenter.instance.Fire(EventCenter.instance.BUILD_SETTWINKSKin, this.x, this.y);
            }
        }
    }

    class AtBlock extends Block {
        constructor() {
            super(...arguments);
            this._subObj = null;
            this._rSpeed = 0;
            this._isAttack = false;
            this._paralysis = false;
        }
        get subObj() {
            if (this._subObj == null && this.build != null) {
                if (this.build.numChildren > 0) {
                    this._subObj = this.build.getChildAt(0);
                }
                else {
                    return null;
                }
            }
            return this._subObj;
        }
        get attackPos() {
            this._attackPos = this.subObj.localToGlobal(AtBlock._forwardPos, true);
            return this._attackPos;
        }
        set power(value) {
            if (value < 0) {
                value = this._power;
            }
            this._power = value;
        }
        get power() {
            return this._power;
        }
        set attackSpeed(value) {
            if (value < 0) {
                return;
            }
            this._attackSpeed = value;
        }
        get attackSpeed() {
            let speed = 1 / (this._attackSpeed + this.room.atSpeed + this._rSpeed);
            return speed;
        }
        set rSpeed(value) {
            this._rSpeed = value;
        }
        set attackRadius(value) {
            if (value <= 0) {
                value = 4;
            }
            this._attackRadius = value;
        }
        get attackRadius() {
            let r = (this._attackRadius * 8100 * this._attackRadius) * this.room.atRange;
            return r;
        }
        set isAttack(value) {
            this._isAttack = value;
        }
        get isAttack() {
            return this._isAttack;
        }
        set paralysis(value) {
            this._paralysis = value;
        }
        get paralysis() {
            return this._paralysis;
        }
        _GameOver() {
            if (this.build != null && this.subObj != null) {
                this.build.removeChild(this.subObj);
            }
            EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, this.build, this.subObj);
            this._subObj = null;
        }
    }
    AtBlock._forwardPos = new Laya.Point(45, 0);

    class BlockBase {
        constructor() {
            this._blockInfos = new Array();
            this.Constructor();
        }
        Constructor() { }
        UpData() {
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    let block = this._blockInfos[i];
                    if (block.isUse && TimeManager.instance.AfterAPeriodOfTime_Bool(block.time, block.timeInterval)) {
                        block.time = TimeManager.instance.gameTime;
                        this.Handel_UpData(block);
                    }
                }
            }
        }
        FindBlockInfo_Pos(pos) {
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    if (!this._blockInfos[i].isUse) {
                        continue;
                    }
                    let poss = this.StrTPos(pos);
                    if (poss.x == this._blockInfos[i].pos.x && poss.y == this._blockInfos[i].pos.y) {
                        return this._blockInfos[i];
                    }
                }
            }
            return null;
        }
        FindBlockInfo_RoomIndex(roomIndex) {
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    if (!this._blockInfos[i].isUse) {
                        continue;
                    }
                    if (roomIndex == this._blockInfos[i].room.roomIndex) {
                        return this._blockInfos[i];
                    }
                }
            }
            return null;
        }
        FindBlockInfo_RoomIndex_count(roomIndex) {
            let count = 0;
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    if (!this._blockInfos[i].isUse) {
                        continue;
                    }
                    if (roomIndex == this._blockInfos[i].room.roomIndex) {
                        count++;
                    }
                }
            }
            return count;
        }
        GetRoomAllBlock(roomIndex) {
            let block = [];
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    if (this._blockInfos[i].isUse && roomIndex == this._blockInfos[i].room.roomIndex) {
                        block.push(this._blockInfos[i]);
                    }
                }
            }
            return block.length > 0 ? block : null;
        }
        GetBlockInfo() {
            if (this._blockInfos.length > 0) {
                for (let i = this._blockInfos.length - 1; i >= 0; i--) {
                    if (!this._blockInfos[i].isUse) {
                        let block = this._blockInfos[i];
                        this._blockInfos.splice(i, 1);
                        return block;
                    }
                }
            }
            var info = new Block();
            return info;
        }
        Build(pos, blockImg, room) {
            let block = this.GetBlockInfo();
            block.build = blockImg;
            block.room = room;
            block.isUse = true;
            block.isOpen = false;
            block.hpMax = 1;
            block.hpCur = block.hpMax;
            block.time = TimeManager.instance.gameTime;
            block.timeInterval = 1;
            block.pos = this.StrTPos(pos);
            this._blockInfos.push(block);
            this.SetBlockInfo(block);
            block.hpStripView = block.hp;
            this._build(block);
            EventCenter.instance.Fire(EventCenter.instance.MGM_SET_BLOCKDYNWALKABLE, block.x, block.y, block.isOpen);
            return block;
        }
        _build(block) {
        }
        BuildUp(pos, block = null) {
            if (block == null) {
                block = this.FindBlockInfo_Pos(pos);
            }
            block.level++;
            this.SetBlockInfo(block);
        }
        SetBlockInfo(block) {
            let blockInfo = DataManager.instance.build.GetBuildData(block.name, block.level);
            this.BlockInfo(block, blockInfo);
        }
        BlockInfo(block, blockInfo) { }
        Handel_UpData(block) {
        }
        ReachConditions(level, roomIndex) {
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    let block = this._blockInfos[i];
                    if (block.isUse && block.room.roomIndex == roomIndex) {
                        if (block.level >= level) {
                            return true;
                        }
                    }
                }
            }
            return false;
        }
        GameOver() {
            if (this._blockInfos.length > 0) {
                for (let i = 0; i < this._blockInfos.length; i++) {
                    let block = this._blockInfos[i];
                    block.GameOver();
                }
            }
            this._GameOver();
        }
        _GameOver() {
        }
        StrTPos(pos) {
            let arrstr = pos.split("_");
            return { x: parseInt(arrstr[0]), y: parseInt(arrstr[1]) };
        }
    }

    var trollState;
    (function (trollState) {
        trollState[trollState["move"] = 0] = "move";
        trollState[trollState["wait"] = 1] = "wait";
        trollState[trollState["attack"] = 2] = "attack";
        trollState[trollState["vertigo"] = 3] = "vertigo";
        trollState[trollState["escape"] = 4] = "escape";
        trollState[trollState["ide"] = 5] = "ide";
    })(trollState || (trollState = {}));
    var trollAnim;
    (function (trollAnim) {
        trollAnim[trollAnim["ide"] = 0] = "ide";
        trollAnim[trollAnim["attack"] = 1] = "attack";
        trollAnim[trollAnim["move"] = 2] = "move";
    })(trollAnim || (trollAnim = {}));
    class TrollBase {
        constructor() {
            this._hpMax = 270;
            this._hpCur = 270;
            this._power = 10;
            this._speed = 4.5;
            this._r = 4;
            this._atSpeed = 1;
            this._atR = 1.5;
            this._lastAtTime = 0;
            this._speedScale = 1;
            this._powerScale = 1;
            this._atSpeedScale = 1;
            this._rScale = 1;
            this._state = trollState.attack;
            this._animindex = trollAnim.ide;
            this._moveSpeedTime = 0;
            this._vertigoTime = 0;
            this._startVertiogTime = 0;
            this._abilityPoint = 0;
            this._attackUpCount = 0;
            this.attackUpCur = 0;
            this._attackPro = 0;
            this.isGuillotine = false;
        }
        Init() {
            this._powers = DataManager.instance.troll.powers;
            this._hps = DataManager.instance.troll.hps;
            this._upData = DataManager.instance.troll.upData;
            this._attackPro = DataManager.instance.troll.attackPro;
            this._speed = 4.5;
            this._level = 1;
            this._power = this._powers[this._level - 1];
            this._hpMax = this._hps[this.level - 1];
            this._hpCur = this._hpMax;
            if (this._hpStrip != null) {
                this.hpStrip = this.hp;
            }
            this._r = 4;
            this._atSpeed = 1;
            this._atR = 1.5;
            this._lastAtTime = 0;
            this._speedScale = 1;
            this._powerScale = 1;
            this._atSpeedScale = 1;
            this._rScale = 1;
            this._state = trollState.ide;
            this._animindex = trollAnim.ide;
            this._moveSpeedTime = 0;
            this._vertigoTime = 0;
            this._abilityPoint = 0;
            this._attackUpCount = this._upData[this._level - 1];
            this.attackUpCur = 0;
        }
        set hpMax(value) {
            this._hpMax = value;
        }
        get hpMax() {
            return this._hpMax;
        }
        set hpCur(value) {
            this._hpCur = value;
            if (this.hpCur > this.hpMax) {
                this._hpCur = this.hpMax;
            }
            this.hpStrip = this.hp;
        }
        get hpCur() {
            return this._hpCur;
        }
        set power(value) {
            this._power = value;
        }
        get power() {
            // let hack_power = Laya.LocalStorage.getItem("Power");
            let hack_power = Laya.LocalStorage.getItem("Power");
            if (hack_power != null) {
                // let data = JSON.parse(str);
                // console.log("伤害："+this._power+"是否hack"+hack_power);
            }
            if(hack_power == 1){
                return this._atSpeed * this._atSpeedScale * 3;
            }
            return this._power * this._powerScale;
        }
        set atSpeed(value) {
            if (value > 0.2) {
                this._atSpeed = value;
            }
            else {
                this._atSpeed = 0.2;
            }
        }
        get atSpeed() {
            let hack_Speed = Laya.LocalStorage.getItem("Speed");
            // console.log("炮塔速度："+this._atSpeed+"是否hack"+hack_Speed);
            if(hack_Speed == 1){
                return this._atSpeed * this._atSpeedScale * 3;
            }
            if (this._atSpeed * this._atSpeedScale < 0.2) {
                return 0.2;
            }
            return this._atSpeed * this._atSpeedScale;
        }
        set powerScale(value) {
            this._powerScale = value;
        }
        get powerScale() {
            return this._powerScale;
        }
        set speedScale(value) {
            if (value < 0) {
                value = 0.1;
            }
            this._speedScale = value;
        }
        get speedScale() {
            return this._speedScale;
        }
        set rScale(value) {
            this._rScale = value;
        }
        get rScale() {
            return this._rScale;
        }
        set atSpeedScale(value) {
            this._atSpeedScale = value;
        }
        get atSpeedScale() {
            return this._atSpeedScale;
        }
        get r() {
            return this._r * this._rScale * this._r * this._rScale * 8100;
        }
        set speed(value) {
            if (this._speed > 13.5) {
                this._speed = 13.5;
            }
            else {
                this._speed = value;
            }
        }
        get speed() {
            return this._speed * this._speedScale;
        }
        get hp() {
            return this._hpCur / this._hpMax;
        }
        get troll() {
            if (this._troll) {
                return this._troll;
            }
            else {
                return null;
            }
        }
        StartGame() {
            this.LoadAnim();
        }
        LoadAnim() {
            this._trollFactory = new Laya.Templet();
            this._trollFactory.on(Laya.Event.COMPLETE, this, this.parseComplete);
            this._trollFactory.loadAni(this.skin);
        }
        parseComplete() {
            if (this._troll != null) {
                this._troll.destroy();
            }
            this._troll = this._trollFactory.buildArmature(0);
            let pos = DataManager.instance.build.GetTrollPos();
            EventCenter.instance.Fire(EventCenter.instance.MAP_ADD_ACTIVITY, this.troll, pos[0], pos[1]);
            this.setplay(trollAnim.move, true);
            this._troll.play(0, true);
            this._troll.zOrder = this._troll.y;
            this.Init();
        }
        get x() {
            return this.troll.x;
        }
        get y() {
            return this.troll.y;
        }
        set x(value) {
            this.troll.x = value;
        }
        set y(value) {
            this.troll.y = value;
        }
        set range(value) {
            this._range = value;
            this._r = this.range * 8100 * this.range;
        }
        get range() {
            return this._range;
        }
        hit(power) {
            this.hpCur -= power;
            this._abilityPoint += 0.01;
            this.hpStrip = this.hp;
            if (this.hp == 0) {
                this.BeDoomed();
            }
            if (this.hp <= 0.3 && !this.isGuillotine) {
                this.isGuillotine = true;
                EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, this._attackRoom, 4);
            }
        }
        BeDoomed() {
        }
        set lastAtTime(value) {
            this._lastAtTime = value;
        }
        get lastAtTime() {
            return this._lastAtTime;
        }
        get atR() {
            return this._atR * this._atR * 8100;
        }
        StateDetection(value) {
            return this._state == value;
        }
        set state(value) {
            this._state = value;
        }
        get state() {
            return this._state;
        }
        setplay(value, loop) {
            this.troll.play(value, loop);
            this._animindex = value;
        }
        IsPlayIndex(value) {
            return this._animindex == value;
        }
        set animIndex(value) {
            this._animindex = value;
        }
        set moveSpeedTime(value) {
            this._moveSpeedTime = value;
        }
        get moveSpeedTime() {
            return this._moveSpeedTime;
        }
        get vertigoTime() {
            return this._vertigoTime;
        }
        get startVertiogTime() {
            return this._startVertiogTime;
        }
        set vertigoTime(value) {
            if (value == 0) {
                this._vertigoTime = 0;
                this._startVertiogTime = 0;
                this.state = this.upstate;
            }
            else {
                if (this._startVertiogTime != 0) {
                    this._vertigoTime += value;
                }
                else {
                    this._startVertiogTime = TimeManager.instance.gameTime;
                    this._vertigoTime = value;
                }
                if (!this.StateDetection(trollState.vertigo)) {
                    this.upstate = this.state;
                    this.state = trollState.vertigo;
                }
            }
        }
        gethpStrip() {
            if (this._hpStrip) {
                return this._hpStrip;
            }
            else {
                return null;
            }
        }
        set hpStrip(value) {
            if (this._hpStrip == null) {
                this._hpStrip = new Laya.View();
                let info = Laya.loader.getRes("Prefabs/TrollBloodStrip.json");
                this._hpStrip.createView(info);
                this._troll.addChild(this._hpStrip);
                this._hpStrip.pos(this._troll.pivotX, -this._troll.getBounds().height);
                this._levelText = this._hpStrip.getChildByName("level");
            }
            else if (this._hpStrip.parent != this._troll) {
                this._troll.addChild(this._hpStrip);
                this._hpStrip.pos(this._troll.pivotX, -this._troll.getBounds().height);
                this._hpStrip.visible = true;
            }
            if (value >= 0 && value <= 1) {
                this._hpStrip.getChildAt(1).scaleX = value;
                this._levelText.text = "LV." + this._level;
                this._hpStrip.scaleX = this._troll.scaleX;
            }
        }
        Attack() {
            if (this._animindex != trollAnim.attack) {
                this._animindex = trollAnim.attack;
            }
            this._troll.play(this._animindex, false);
            this._abilityPoint++;
            this._attack();
        }
        _attack() { }
        set abilityPoint(value) {
            this._abilityPoint = value;
        }
        UpAdilityPoint() {
            let r1 = Math.random() * 0.5;
            let r2 = Math.random() * 0.3;
            let r3 = Math.random() * 0.1;
            let r4 = Math.random() * 0.1;
            this.hpMax += r1 * this._abilityPoint * this.hpMax * 0.02;
            this.hpCur += r1 * this._abilityPoint * this.hpMax * 0.02;
            this.power += r2 * this._abilityPoint * this.power * 0.03;
            this.atSpeed -= r3 * this._abilityPoint * 0.05;
            this.speed += r4 * this._abilityPoint * 0.1;
            this.abilityPoint = 0;
        }
        EscapeUp() {
            this.atSpeedScale = 1;
            this.speedScale = 1;
            this.powerScale = 1;
            this.isGuillotine = false;
            this.level++;
            this.power = this._powers[this._level];
            let hp = this._hps[this.level];
            hp -= this.hpMax;
            this.hpMax = this._hps[this.level];
            this.hpCur += hp;
            this._attackUpCount = this._upData[this._level - 1];
            this.attackUpCur = 0;
            Sound.instance.PlaySound(Sound.instance.TB_sound.troll_up);
            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼升级：LV." + this._level);
        }
        get level() {
            return this._level;
        }
        set level(value) {
            if (value <= 13) {
                if (value >= this._powers.length) {
                    value = this._powers.length - 1;
                }
                this._level = value;
                if (this._levelText) {
                    this._levelText.text = "Lv." + this._level;
                }
            }
        }
        get skin() {
            return "res/Skeleton/mg/mg_" + DataManager.instance.player.trollIndex + ".sk";
        }
        TrollSkill() {
            this.OnTrollSkill();
            TimeManager.instance.AddTimeOnceEvent("OffTrollSkill", this.OffTrollSkill, this, 5);
        }
        OnTrollSkill() {
        }
        OffTrollSkill() {
        }
        AttackEvent(...param) {
        }
        StartAttack(block) {
        }
        Escape() {
        }
        GameOver() {
            if (this._hpStrip) {
                this._hpStrip.removeSelf();
                this._hpStrip.visible = false;
            }
        }
        get attackUpCount() {
            return this._attackUpCount + this._attackUpCount * this._attackPro;
        }
    }

    class Troll extends TrollBase {
        constructor() {
            super(...arguments);
            this._paralysis = false;
            this._attackTime = 0;
            this._rageTime = 20;
            this._isRage = false;
        }
        _attack() {
            if (this.atSpeedScale > 0.5) {
                this.atSpeedScale -= 0.05;
            }
            else {
                if (this._isRage) {
                    this.atSpeedScale = this.atSpeed1;
                }
                else {
                    this.atSpeedScale = 1;
                }
            }
            this.attackUpCur++;
            if (this.attackUpCur > this.attackUpCount) {
                this.EscapeUp();
            }
            this.Rage();
        }
        OnTrollSkill() {
            this.atSpeedScale -= 0.3;
            this.powerScale = 1.25;
        }
        OffTrollSkill() {
            this.atSpeedScale = 1;
            this.powerScale = 1;
        }
        AttackEvent(...param) {
            this.Paralysis(param[0]);
        }
        Paralysis(door) {
            if (!this._paralysis) {
                if (door.name == "door" && door.isUse) {
                    if (door.hp <= 0.2) {
                        let ran = Math.random();
                        if (ran <= 0.3) {
                            EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.trollZH, this.x - 80, this.y - 135, true);
                            let buils = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_POSAROUND, this.x, this.y, "at", 4);
                            EventCenter.instance.Fire(EventCenter.instance.BUILD_PARALYSIS_ON, buils);
                            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼震撼");
                        }
                        this._paralysis = true;
                    }
                }
            }
        }
        StartAttack(block) {
            if (block != null) {
                this._attackRoom = block.room.roomIndex;
                block.room.isEnerguhood = false;
                EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, this._attackRoom, 3);
            }
            this._attackTime = TimeManager.instance.gameTime;
            this._paralysis = false;
        }
        Rage() {
			let Rage = Laya.LocalStorage.getItem("Rage");
            console.log("mod_js 猛鬼狂暴了啊=="+Rage);
            if(Rage==1){
                this.Rage_on();
				return;
            } 
            if (TimeManager.instance.AfterAPeriodOfTime_Bool(this._attackTime, this._rageTime)) {
                this.Rage_on();
            }
        }
        Rage_on() {

            let Rage = Laya.LocalStorage.getItem("Rage");
            if(Rage==1){
               Sound.instance.PlaySound(Sound.instance.TB_sound.troll_rage);
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼狂暴了");
                this._isRage = true;
                this.atSpeed1 = this.atSpeedScale;
                this.atSpeedScale -= 0.3;
                TimeManager.instance.AddTimeOnceEvent("rang_off", this.Rage_off, this, 8);
                if (this._attackRoom != null) {
                    EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, this._attackRoom, 0);
                }
                EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.trollBaoqiEffect, this.x, this.y - 60, true);
				this._attackTime = TimeManager.instance.gameTime;
				return;
            }

            let ran = Math.random();
            if (ran <= 1) {
                Sound.instance.PlaySound(Sound.instance.TB_sound.troll_rage);
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼狂暴了");
                this._isRage = true;
                this.atSpeed1 = this.atSpeedScale;
                this.atSpeedScale -= 0.3;
                TimeManager.instance.AddTimeOnceEvent("rang_off", this.Rage_off, this, 8);
                if (this._attackRoom != null) {
                    EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, this._attackRoom, 0);
                }
                EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.trollBaoqiEffect, this.x, this.y - 60, true);
            }
            this._attackTime = TimeManager.instance.gameTime;
        }
        Rage_off() {
            this._isRage = false;
            this.atSpeedScale = this.atSpeed1;
        }
        Escape() {
            EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, this._attackRoom, 3);
            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼逃跑了");
        }
    }

    class TrollManager {
        constructor() {
            TrollManager._ins = this;
            this._troll = new Troll();
        }
        static get instance() {
            if (!this._ins || this._ins == null) {
                return null;
            }
            return this._ins;
        }
        get troll() {
            return this._troll.troll;
        }
        get trollSprict() {
            return this._troll;
        }
        StartGame() {
            this._troll.StartGame();
        }
        GameOver() {
            this._troll.GameOver();
        }
    }

    class BulletManager {
        constructor() {
            this.Init();
            UpEventHandle.instance.AddUPEvent("BulletMoveUp", this.MoveUP, this);
        }
        get troll() {
            return TrollManager.instance.troll;
        }
        Init() {
            this.BulletImgArr = new Array();
            this.bulletSprite = EventCenter.instance.FireReturn(EventCenter.instance.MAP_GET_ACTIVITYMAP);
        }
        TrackMoveMent(build, moveSpeed) {
            GameDynamics.instance.SetRot(build, this.troll);
            GameDynamics.instance.AddTMoveMent(build, this.troll, 180, moveSpeed);
            GameDynamics.instance.AddScale(build, 1, 1, 7 / 20);
        }
        attack(power, pos, bulletName, roomIndex) {
            var element = this.GetBuild();
            this.InitBuild(element, power, roomIndex);
            var bulletPos = (element.bullet.parent).globalToLocal(pos);
            element.bullet.pos(bulletPos.x, bulletPos.y);
            element.bullet.skin = "bullet/" + bulletName + "_Bullet.png";
            this.TrackMoveMent(element.bullet, element.movespeed);
        }
        InitBuild(element, power, roomIndex) {
            element.bullet.width = 90;
            element.bullet.height = 90;
            element.movespeed = 1000;
            element.bullet.pivotX = 45;
            element.bullet.pivotY = 45;
            element.bullet.rotation = 0;
            element.bullet.scaleX = 0.2;
            element.bullet.scaleY = 0.2;
            element.power = power;
            element.bullet.visible = true;
            element.roomIndex = roomIndex;
            this.bulletSprite.addChild(element.bullet);
        }
        GetBuild() {
            if (this.BulletImgArr.length > 0) {
                for (var i = 0; i < this.BulletImgArr.length; i++) {
                    var element = this.BulletImgArr[i];
                    if (!element.isUse) {
                        element.isUse = true;
                        return element;
                    }
                }
            }
            var img = new Laya.Image();
            img.visible = true;
            var element = { bullet: img, isUse: true, power: 0, movespeed: 0, roomIndex: -1 };
            this.BulletImgArr.push(element);
            return element;
        }
        MoveUP() {
            this.HandleMoveOver();
        }
        HandleMoveOver() {
            if (this.BulletImgArr.length > 0) {
                for (var i = this.BulletImgArr.length - 1; i >= 0; i--) {
                    var element = this.BulletImgArr[i];
                    if (element == undefined || !element.isUse) {
                        continue;
                    }
                    var bulletPoint = element.bullet.localToGlobal(new Laya.Point(element.bullet.pivotX, element.bullet.pivotY));
                    var trollPoint = this.troll.localToGlobal(new Laya.Point(this.troll.pivotX, this.troll.pivotY));
                    if (this.Distance(bulletPoint, trollPoint) < 400) {
                        let bullet = element;
                        EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.bulletEffect, bullet.bullet.x - 20, bullet.bullet.y - 20, true);
                        this.Attack(bullet.bullet, bullet.power, bullet.roomIndex);
                        bullet.isUse = false;
                    }
                }
            }
        }
        Attack(bullet, power, roomIndex) {
            EventCenter.instance.Fire(EventCenter.instance.TL_TROLLHIT, power, roomIndex);
            bullet.visible = false;
            this.bulletSprite.removeChild(bullet);
        }
        Distance(a, b) {
            var x = a.x - b.x;
            var y = a.y - b.y;
            var dis = x * x + y * y;
            return dis;
        }
        GameOver() {
            if (this.BulletImgArr.length > 0) {
                this.BulletImgArr.forEach(element => {
                    element.bullet.removeSelf();
                    element.bullet.visible = false;
                });
            }
        }
    }

    class BlockAtower extends BlockBase {
        UpData() {
            if (this._blockInfos.length > 0) {
                if (this._bulletManager.troll != null) {
                    for (let i = 0; i < this._blockInfos.length; i++) {
                        let block = this._blockInfos[i];
                        if (block.isUse) {
                            if (block.paralysis) {
                                return;
                            }
                            if (TimeManager.instance.AfterAPeriodOfTime_Bool(block.time, block.attackSpeed)) {
                                let dis = EventCenter.instance.FireReturn(EventCenter.instance.MAP_DISTANCE, block.build, this._bulletManager.troll);
                                if (dis <= block.attackRadius) {
                                    let room = block.room;
                                    if (room.BuffSwitch(room.buffTypeStr.solenoid)) {
                                        block.rSpeed = (1 - (dis / block.attackRadius)) * room.solenoidMax;
                                    }
                                    else {
                                        block.rSpeed = 0;
                                    }
                                    if (room.BuffSwitch(room.buffTypeStr.smoney)) {
                                        room.SmoneyEvent(block.level);
                                    }
                                    block.time = TimeManager.instance.gameTime;
                                    this.Handel_UpData(block);
                                }
                            }
                        }
                    }
                }
            }
        }
        Constructor() {
            this._bulletManager = new BulletManager();
            this._bullet_effet_Arr = [];
            this._use_bullet_effet_arr = [];
        }
        Handel_UpData(block) {
            this.ShootSkill(block);
        }
        ShootSkill(block) {
            let selt = this;
            GameDynamics.instance.AddRotation(block.subObj, this._bulletManager.troll, 720, () => {
                EffectTween.instance.Shake(block.subObj, 0.2);
                if (!block.isUse) {
                    return;
                }
                let img = selt.img;
                selt.Effect(img, block);
                selt.Attack(block);
            });
        }
        Attack(block) {
            Sound.instance.PlaySound(Sound.instance.TB_sound.build_at_attack, 1, block.x, block.y);
            this._bulletManager.attack(block.power, block.attackPos, block.buildName, block.roomIndex);
            block.time = TimeManager.instance.gameTime;
        }
        BlockInfo(block, blockInfo) {
            block.power = blockInfo[3];
            block.attackRadius = blockInfo[4];
            block.attackSpeed = 1;
            block.rSpeed = 0;
            block.paralysis = false;
        }
        UpGradeAttackSpeed(block, buffeEff) {
            if (block.attackSpeed == 0.2) {
                return;
            }
            block.attackSpeed -= buffeEff;
            if (block.attackSpeed <= 0.2) {
                block.attackSpeed = 0.2;
            }
        }
        _GameOver() {
            this._bulletManager.GameOver();
            this.ClearBulletEffectAll();
        }
        GetBlockInfo() {
            if (this._blockInfos.length > 0) {
                for (let i = this._blockInfos.length - 1; i >= 0; i--) {
                    if (!this._blockInfos[i].isUse) {
                        let block = this._blockInfos[i];
                        this._blockInfos.splice(i, 1);
                        return block;
                    }
                }
            }
            var info = new AtBlock();
            return info;
        }
        get img() {
            let img;
            if (this._bullet_effet_Arr.length > 0) {
                img = this._bullet_effet_Arr.shift();
            }
            else {
                img = new Laya.Image();
                img.width = 59;
                img.height = 95;
                img.pivot(30, 81);
                img.skin = "UI/bullet_effect.png";
            }
            img.alpha = 0;
            img.visible = true;
            this._use_bullet_effet_arr.push(img);
            return img;
        }
        ClearBulletEffectAll() {
            if (this._use_bullet_effet_arr.length > 0) {
                for (let i = this._use_bullet_effet_arr.length - 1; i >= 0; i--) {
                    let img = this._use_bullet_effet_arr[i];
                    this.ClearBulletEffect(img);
                }
                this._use_bullet_effet_arr = [];
            }
        }
        ClearBulletEffect(img) {
            Laya.Tween.clearAll(img);
            img.removeSelf();
            img.visible = false;
            this._bullet_effet_Arr.push(img);
        }
        Effect(img, block) {
            if (!block.isUse) {
                return;
            }
            block.subObj.addChild(img);
            img.pos(45, 0);
            Laya.Tween.to(img, { alpha: 1 }, 20, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(img, { alpha: 0 }, 20, null, Laya.Handler.create(this, () => {
                    this.ClearBulletEffect(img);
                }), 0, true);
            }), 0, true);
        }
    }

    class ResourcesBlock extends Block {
        get pREffect() {
            return this.build.visible;
        }
        get pR() {
            return this._pR;
        }
        set pR(value) {
            this._pR = value;
        }
    }

    class BedBlock extends ResourcesBlock {
        set head(skin) {
            if (!this._head) {
                this._head = new Laya.Image();
                this._head.width = 90;
                this._head.height = 90;
                this._head.pivot(45, 45);
            }
            this.build.addChild(this._head);
            this._head.visible = true;
            this._head.pos(45, 45);
            this._head.skin = "bullet/head_" + skin + ".png";
        }
        _GameOver() {
            if (this._head) {
                this._head.removeSelf();
                this._head.visible = false;
            }
            EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, this.build, null);
        }
    }

    class BlockBed extends BlockBase {
        Handel_UpData(block) {
            this.IncreasePR(block);
        }
        BlockInfo(block, blockInfo) {
            block.pR = blockInfo[3];
            block.room.bed = block;
        }
        IncreasePR(block) {
            let pr = block.pR * block.room.prLevel * block.room.doubleGold1;
            DataManager.instance.game.SetPR(block.room.roomIndex, pr, 0);
            if (block.isOpen) {
                let off = 0.01 * block.level;
                if (block.pREffect) {
                    EffectTween.instance.Shake(block.build, off);
                    EffectTween.instance.RFEffect("UI/gold1.png", block.pR, block.build);
                }
            }
        }
        GetBlockInfo() {
            if (this._blockInfos.length > 0) {
                for (let i = this._blockInfos.length - 1; i >= 0; i--) {
                    if (!this._blockInfos[i].isUse) {
                        let block = this._blockInfos[i];
                        this._blockInfos.splice(i, 1);
                        return block;
                    }
                }
            }
            var info = new BedBlock();
            return info;
        }
    }

    class DoorBlock extends Block {
        constructor() {
            super(...arguments);
            this.adv = false;
        }
        OpenDoor() {
            if (!this.isOpen) {
                this.jt.visible = true;
                this.build.parent.addChild(this.jt);
                this.jt.rotation = this.build.rotation;
                this.jt.pos(this.x, this.y);
                this.jtShow();
                if (this.moveMod) {
                    Laya.Tween.to(this.build, { x: this.build.x + 90 }, 500, null, null, 0, true);
                }
                else {
                    Laya.Tween.to(this.build, { y: this.build.y + 90 }, 500, null, null, 0, true);
                }
                this.isOpen = true;
            }
        }
        CloseDoor() {
            if (this.isOpen) {
                if (this.moveMod) {
                    Laya.Tween.to(this.build, { x: this.build.x - 90 }, 500, null, Laya.Handler.create(this, () => {
                        Sound.instance.PlaySound(Sound.instance.TB_sound.build_build, 1, this.x, this.y);
                    }), 0, true);
                }
                else {
                    Laya.Tween.to(this.build, { y: this.build.y - 90 }, 500, null, Laya.Handler.create(this, () => {
                        Sound.instance.PlaySound(Sound.instance.TB_sound.build_build, 1, this.x, this.y);
                    }), 0, true);
                }
                this.jt.visible = false;
                this.jt.removeSelf();
                this.isOpen = false;
            }
        }
        get moveMod() {
            let rot = Math.abs(this.build.rotation);
            if (rot == 0 || rot == 180) {
                return true;
            }
            else {
                return false;
            }
        }
        get jt() {
            if (this._jt == null) {
                let img = new Laya.Image();
                img.width = 46;
                img.height = 46;
                img.pivot(23, 23);
                img.skin = "UI/jt.png";
                this._jt = img;
            }
            return this._jt;
        }
        jtShow(index = 0) {
            Laya.Tween.to(this.jt, { alpha: index }, 1000, null, Laya.Handler.create(this, () => {
                if (this.jt == null || !this.jt.visible) {
                    return;
                }
                if (index == 1) {
                    this.jtShow();
                }
                else {
                    this.jtShow(1);
                }
            }), 0, true);
        }
        _GameOver() {
            this.adv = false;
            this.jt.visible = false;
            this.jt.removeSelf();
            EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, this.build, null);
        }
    }

    class BlockDoor extends BlockBase {
        BlockInfo(block, blockInfo) {
            block.hpMax = blockInfo[3];
            block.hpCur = blockInfo[3];
            block.battleBB = 0.01 * block.level;
            block.room.door = block;
        }
        _build(block) {
            block.OpenDoor();
        }
        BloodReturn(block) {
            if (block.hp == 1) {
                return;
            }
            block.hpCur += (block.hpMax * block.battleBB);
            block.hpStrip = block.hp;
        }
        Handel_UpData(block) {
            this.BloodReturn(block);
        }
        GetBlockInfo() {
            if (this._blockInfos.length > 0) {
                for (let i = this._blockInfos.length - 1; i >= 0; i--) {
                    if (!this._blockInfos[i].isUse) {
                        let block = this._blockInfos[i];
                        this._blockInfos.splice(i, 1);
                        return block;
                    }
                }
            }
            var info = new DoorBlock();
            return info;
        }
    }

    class BlockGame extends BlockBase {
        Handel_UpData(block) {
            if (!block.room.die) {
                this.IncreasePR(block);
            }
        }
        BlockInfo(block, blockInfo) {
            block.pR = blockInfo[3];
            if (block.level == 1) {
                block.timeInterval = 2;
            }
            else {
                block.timeInterval = 1;
            }
        }
        IncreasePR(block) {
            let pr = block.pR * block.room.doubleGold2;
            DataManager.instance.game.SetPR(block.room.roomIndex, 0, pr);
            let off = 0.01 * block.level;
            EffectTween.instance.Shake(block.build, off);
            EffectTween.instance.RFEffect("UI/gold2.png", pr, block.build);
        }
    }

    class BuffBlock extends Block {
    }

    class BlockBuff {
        constructor() {
            this.bulletSprite = EventCenter.instance.FireReturn(EventCenter.instance.MAP_GET_ACTIVITYMAP);
            this.imgs = new Array();
            this.imgUse = new Array();
        }
        static get instence() {
            if (!this._ins || this._ins == null) {
                this._ins = new BlockBuff();
            }
            return this._ins;
        }
        get troll() {
            if (this._troll || this._troll == null) {
                this._troll = TrollManager.instance.trollSprict;
            }
            return this._troll;
        }
        TriggerEvent(mod, block) {
            if (!block.isUse) {
                return;
            }
            switch (mod) {
                case 0:
                    this.SpellEvent(block);
                    break;
                case 1:
                    this.EntrapmentEvent(block);
                    break;
                case 2:
                    this.GuillotineEvent(block);
                    break;
                case 3: return this.EnergyhoodEvent(block);
            }
        }
        get spellImage() {
            if (!this._spellImage || this._spellImage == undefined) {
                this._spellImage = this.Img;
                this._spellImage.skin = "map/spellimg_0.png";
            }
            return this._spellImage;
        }
        SpellEvent(block) {
            if (!block.isUse) {
                return;
            }
            let ran = Math.random();
            if (ran <= 0.3) {
                this.bulletSprite.addChild(this.spellImage);
                this.spellImage.x = block.x;
                this.spellImage.y = block.y;
                this.spellImage.visible = true;
                this.spellImage.alpha = 1;
                GameDynamics.instance.SetRot(this.spellImage, this.troll.troll);
                Laya.Tween.to(this.spellImage, { x: this.troll.x, y: this.troll.y - 100 }, 400, null, Laya.Handler.create(this, function () {
                    this.troll.troll.addChild(this.spellImage);
                    this.spellImage.pos(this.troll.troll.pivotX, this.troll.troll.pivotY - 100);
                    Laya.Tween.to(this.spellImage, { alpha: 0 }, 3000, null, Laya.Handler.create(this, function () {
                        this.spellImage.visible = false;
                        this.spellImage.removeSelf();
                    }), 0, true);
                    EventCenter.instance.Fire(EventCenter.instance.TL_VERTIGO_REDUCTION, 3);
                }), 0, true);
            }
        }
        get entramentImage() {
            if (!this._entrapmentImage || this._entrapmentImage == undefined) {
                this._entrapmentImage = this.Img;
                this._entrapmentImage.skin = "map/entramentImage_1.png";
            }
            return this._entrapmentImage;
        }
        EntrapmentEvent(block) {
            if (!block.isUse) {
                return;
            }
            this.bulletSprite.addChild(this.entramentImage);
            this.entramentImage.pos(block.x, block.y);
            this.entramentImage.visible = true;
            this.entramentImage.alpha = 1;
            this.entramentImage.scale(2, 2);
            GameDynamics.instance.SetRot(this.entramentImage, this.troll.troll);
            Laya.Tween.to(this.entramentImage, { x: this.troll.x, y: this.troll.y, scaleX: 1, scaleY: 1 }, 400, null, Laya.Handler.create(this, function () {
                this.troll.troll.addChild(this.entramentImage);
                this.entramentImage.pos(this.troll.troll.pivotX, this.troll.troll.pivotY);
                this._entrapmentImage.skin = "map/entramentImage_2.png";
                Laya.Tween.to(this.entramentImage, { alpha: 0 }, 2000, null, Laya.Handler.create(this, function () {
                    this.entramentImage.visible = false;
                    this.entramentImage.removeSelf();
                }), 0, true);
                EventCenter.instance.Fire(EventCenter.instance.TL_VERTIGO_REDUCTION, 2);
            }), 0, true);
        }
        get guillotineImg() {
            if (!this._guillotineImg || this._guillotineImg == undefined) {
                this._guillotineImg = this.Img;
                this._guillotineImg.skin = "map/guillotineImg.png";
            }
            return this._guillotineImg;
        }
        GuillotineEvent(block) {
            if (!block.isUse) {
                return;
            }
            let hit = this.troll.hpMax * 0.1;
            this.bulletSprite.addChild(this.guillotineImg);
            this.guillotineImg.pos(block.x, block.y);
            GameDynamics.instance.SetRot(this.guillotineImg, this.troll.troll);
            Laya.Tween.to(this.guillotineImg, { x: this.troll.x, y: this.troll.y, scaleX: 1, scaleY: 1, rotation: this.guillotineImg.rotation - 720 }, 400, null, Laya.Handler.create(this, function () {
                EventCenter.instance.Fire(EventCenter.instance.TL_TROLLHIT, hit, block.room.roomIndex);
                this.guillotineImg.removeSelf();
                this.guillotineImg.visible = false;
            }), 0, true);
        }
        get energuhoodImg() {
            if (!this._energuhoodImg || this._energuhoodImg == undefined) {
                this._energuhoodImg = this.Img;
                this._energuhoodImg.skin = "map/energuhoodImg.png";
            }
            return this._energuhoodImg;
        }
        EnergyhoodEvent(block) {
            if (!block.isUse) {
                return;
            }
            this.energuhoodImg.scale(0, 0);
            if (block.build != null) {
                block.build.addChild(this.energuhoodImg);
                this.energuhoodImg.pos(45, 45);
                this.energuhoodImg.alpha = 0;
            }
            return this.energuhoodImg;
        }
        IceEvent(block) {
            if (!block.isUse) {
                return;
            }
            let img = this.Img;
            img.zOrder = 1;
            img.skin = "map/Ice_ice.png";
            img.alpha = 0;
            img.scale(0, 0);
            img.pos(45, 45);
            block.build.addChild(img);
            Laya.Tween.to(img, { scaleX: 1, scaleY: 1, alpha: 1 }, 1500, null, null, 0, true);
            return img;
        }
        BarbEvent(block) {
            if (!block.isUse) {
                return;
            }
            let img = this.Img;
            img.zOrder = 2;
            img.skin = "map/Barb_barb.png";
            img.alpha = 0;
            img.scale(0, 0);
            img.pos(45, 45);
            block.build.addChild(img);
            Laya.Tween.to(img, { scaleX: 1, scaleY: 1, alpha: 1 }, 1500, null, null, 0, true);
            return img;
        }
        get Img() {
            let img = null;
            if (this.imgs.length > 0) {
                img = this.imgs.shift();
            }
            else {
                img = new Laya.Image();
            }
            img.width = 90;
            img.height = 90;
            img.pivot(45, 45);
            img.rotation = 0;
            img.name = "event";
            img.visible = true;
            img.zOrder = 0;
            this.imgUse.push(img);
            return img;
        }
        repairEvent(block) {
            if (!block.isUse) {
                return;
            }
            let img = this.Img;
            img.skin = "map/wrench.png";
            block.build.addChild(img);
            img.pivot(41, 36);
            img.pos(45, 45);
            return img;
        }
        GameOver() {
            for (let i = this.imgUse.length - 1; i >= 0; i--) {
                let img = this.imgUse[i];
                img.removeSelf();
                img.visible = false;
                img.pivot(45, 45);
                this.imgs.push(img);
            }
            this.imgUse.length = 0;
            this._energuhoodImg = null;
            this._spellImage = null;
            this._guillotineImg = null;
            this._entrapmentImage = null;
        }
        TrollIceEvent() {
            this.troll.atSpeedScale -= 0.3;
        }
        TrollBarbEvent(roomIndex) {
            let hit = this.troll.hpMax * 0.01;
            EventCenter.instance.Fire(EventCenter.instance.TL_TROLLHIT, hit, roomIndex);
        }
    }

    class Room {
        constructor(index) {
            this.isuse = false;
            this._die = false;
            this._roomIndex = null;
            this._attacked = false;
            this.prLevel = 1;
            this.doubleGold1 = 1;
            this.doubleGold2 = 1;
            this._buffType = {
                ice: 0,
                barb: 0,
                repair: 0,
                particlea: 0,
                spell: 1,
                entrapment: 1,
                guillotine: 1,
                energyhood: 1,
                smoney: 2,
                longrange: 2,
                solenoid: 2,
            };
            this.buildBuff = {
                ice: null,
                barb: null,
                repair: null,
                particlea: null,
                spell: null,
                entrapment: null,
                guillotine: null,
                energyhood: null,
                smoney: null,
                longrange: null,
                solenoid: null
            };
            this.buff_immediately = {
                ice: { addFunc: null, removeFunc: null, isUse: false },
                barb: { addFunc: null, removeFunc: null, isUse: false },
                repair: { addFunc: null, removeFunc: null, isUse: false },
                particlea: { addFunc: null, removeFunc: null, isUse: false }
            };
            this.buff_event = {
                spell: { addFunc: null, removeFunc: null, isUse: false },
                entrapment: { addFunc: null, removeFunc: null, isUse: false },
                guillotine: { addFunc: null, removeFunc: null, isUse: false },
                energyhood: { addFunc: null, removeFunc: null, isUse: false }
            };
            this.buff_other = {
                smoney: { addFunc: null, removeFunc: null, isUse: false },
                longrange: { addFunc: null, removeFunc: null, isUse: false },
                solenoid: { addFunc: null, removeFunc: null, isUse: false }
            };
            this.repairNum = 0;
            this.repairTime = 0;
            this.pr = 0;
            this.energuhoodImg = null;
            this.isEnerguhood = false;
            this.isBarb = false;
            this.barbTime = 0;
            this.repairSkillImg = null;
            this.repairIndex = 0;
            this.AddFunc();
            this.StartGame();
            this.roomIndex = index;
            this._blocks = new Array();
        }
        BuildBuff(str) {
            let func = this.buildBuff[str];
            func && func.call(this);
        }
        AddBuff_immediately(typeName) {
            let buff = this.buff_immediately[typeName];
            buff.isUse = true;
            buff.addFunc != null && buff.addFunc.call(this);
        }
        RemoveBuff_immediately(typeName) {
            let buff = this.buff_immediately[typeName];
            buff.isUse = false;
            buff.removeFunc != null && buff.removeFunc.call(this);
        }
        AddBuff_event(typeName) {
            let buff = this.buff_event[typeName];
            buff.isUse = true;
        }
        RemoveBuff_event(typeName) {
            let buff = this.buff_event[typeName];
            buff.isUse = false;
            buff.removeFunc != null && buff.removeFunc.call(this);
        }
        AddbBuff_other(typeName) {
            let buff = this.buff_other[typeName];
            buff.isUse = true;
        }
        RemoveBuff_other(typeName) {
            let buff = this.buff_other[typeName];
            buff.isUse = false;
            buff.removeFunc != null && buff.removeFunc.call(this);
        }
        AddBuff(typeName) {
            let index = this._buffType[typeName];
            switch (index) {
                case 0:
                    this.AddBuff_immediately(typeName);
                    break;
                case 1:
                    this.AddBuff_event(typeName);
                    break;
                case 2:
                    this.AddbBuff_other(typeName);
                    break;
            }
            this.BuildBuff(typeName);
        }
        RemoveBuff(typeName) {
            let index = this._buffType[typeName];
            switch (index) {
                case 0:
                    this.RemoveBuff_immediately(typeName);
                    break;
                case 1:
                    this.RemoveBuff_event(typeName);
                    break;
                case 2:
                    this.RemoveBuff_other(typeName);
                    break;
            }
        }
        AddFunc() {
            this.buff_immediately.ice.addFunc = this.IceEvent;
            this.buff_immediately.barb.addFunc = this.BarbEvent;
            this.buff_immediately.particlea.addFunc = this.ParticleaEvent;
            this.buff_immediately.repair.addFunc = this.RepairEvent;
            this.buff_immediately.ice.removeFunc = this.RemoveIceEvent;
            this.buff_immediately.barb.removeFunc = this.RemoveBarbEvent;
            this.buff_immediately.repair.removeFunc = this.RemoveRepairEvent;
            this.buff_event.spell.removeFunc = this.RemoveSpellEvent;
            this.buff_event.guillotine.removeFunc = this.RemoveGuillotineEvent;
            this.buff_event.entrapment.removeFunc = this.RemoveEntarpmentEvent;
            this.buff_other.solenoid.removeFunc = this.RemoveSoleniodEvent;
            this.buff_other.smoney.removeFunc = this.RemoveSmoneyEvent;
            this.buff_immediately.particlea.removeFunc = this.RemoveParticleaEvent;
            this.buff_event.energyhood.removeFunc = this.RemoveEnergyhoodEvent;
            this.buff_other.longrange.removeFunc = this.RemoveLongrangEvent;
            this.buildBuff.spell = this.SpellBuild;
            this.buildBuff.guillotine = this.GuillotneBuild;
            this.buildBuff.entrapment = this.EntrapmentBuild;
            this.buildBuff.solenoid = this.SoleniodBuild;
            this.buildBuff.smoney = this.SmoneyBuild;
            this.buildBuff.particlea = this.ParticleaBuild;
            this.buildBuff.ice = this.IceBuild;
            this.buildBuff.barb = this.BarbBuild;
            this.buildBuff.energyhood = this.EnergyhoodBuild;
            this.buildBuff.longrange = this.LongrangeBuild;
        }
        Init() {
        }
        StartGame() {
            this.roomBuild = {
                spell: [],
                ice: [],
                entrapment: [],
                barb: [],
                guillotine: [],
                repair: [],
                energyhood: [],
                smoney: [],
                longrange: [],
                particlea: [],
                solenoid: []
            };
            this.buff_immediately.barb.isUse = false;
            this.buff_immediately.ice.isUse = false;
            this.buff_immediately.particlea.isUse = false;
            this.buff_immediately.repair.isUse = false;
            this.buff_other.longrange.isUse = false;
            this.buff_other.smoney.isUse = false;
            this.buff_other.solenoid.isUse = false;
            this.buff_event.energyhood.isUse = false;
            this.buff_event.entrapment.isUse = false;
            this.buff_event.guillotine.isUse = false;
            this.buff_event.spell.isUse = false;
        }
        get roomIndex() {
            return this._roomIndex;
        }
        set roomIndex(value) {
            this._roomIndex = value;
        }
        get atRange() {
            if (this.BuffSwitch(Room.buffTypeStr.longrange)) {
                return Room._atrange;
            }
            else {
                return 1;
            }
        }
        get atSpeed() {
            if (this.BuffSwitch(Room.buffTypeStr.particlea)) {
                return Room._atSpeed;
            }
            else {
                return 0;
            }
        }
        Build(pos, build) {
            let typeName = build.name.split("_")[0];
            let isbuild = false;
            if (this.IsAllowArchitecture(typeName)) {
                let block = this.block;
                block.build = build;
                block.pos = this.PosTxy(pos);
                block.room = this;
                block.isUse = true;
                block.isOpen = false;
                block.hpMax = 10;
                block.hpCur = 10;
                block.level = 1;
                isbuild = true;
                this._blocks.push(block);
                this.roomBuild[typeName].push(block);
                this.AddBuff(typeName);
                EventCenter.instance.Fire(EventCenter.instance.MGM_SET_BLOCKDYNWALKABLE, block.x, block.y, block.isOpen);
            }
            return isbuild;
        }
        IsAllowArchitecture(typeName) {
            let buildInfo = this.roomBuild[typeName];
            let buildCount = Room.roomBuildCount[typeName];
            if (buildInfo != undefined) {
                if (buildInfo.length < buildCount) {
                    return true;
                }
            }
            return false;
        }
        getBlock(str, pos) {
            let blocks = this.roomBuild[str];
            if (blocks.length > 1) {
                for (let i = 0; i < blocks.length; i++) {
                    let block = blocks[i];
                    if (block.pos.x == pos.x && block.pos.y == pos.y) {
                        return block;
                    }
                }
            }
            else {
                return blocks[0];
            }
        }
        BuildDismantle(block) {
            let type = block.name;
            let blocks = this.roomBuild[type];
            if (blocks.length > 1) {
                for (let i = blocks.length - 1; i >= 0; i--) {
                    let nblock = blocks[i];
                    if (block == nblock) {
                        blocks.splice(i, 1);
                        return;
                    }
                }
            }
            else {
                this.roomBuild[type].length = 0;
            }
        }
        PosTxy(pos) {
            let strs = pos.split("_");
            let x = parseInt(strs[0]);
            let y = parseInt(strs[1]);
            return { x: x, y: y };
        }
        get block() {
            return new BuffBlock();
        }
        BuffSwitch(buffStr) {
            let buffType = this._buffType[buffStr];
            let _switch = false;
            switch (buffType) {
                case 0:
                    _switch = this.getBuffSwitch(this.buff_immediately, buffStr);
                    break;
                case 1:
                    _switch = this.getBuffSwitch(this.buff_event, buffStr);
                    break;
                case 2:
                    _switch = this.getBuffSwitch(this.buff_other, buffStr);
                    break;
            }
            return _switch;
        }
        getBuffSwitch(buffs, buffEnum) {
            let buff = buffs[buffEnum];
            if (buff != undefined) {
                return buff.isUse;
            }
            return false;
        }
        UpHandle() {
            if (!this.die) {
                this.RepairUp();
                this.EnergyhoodUp();
                this.BarbUp();
            }
        }
        IceEvent() {
            this.iceImg = BlockBuff.instence.IceEvent(this.door);
        }
        IceBuild() {
            let block = this.roomBuild.ice[0];
            if (block) {
                this.IceSkinExchange(1);
            }
        }
        IceSkinExchange(index) {
            let block = this.roomBuild.ice[0];
            if (!block) {
                return;
            }
            if (block.isUse) {
                block.build.skin = "build/ice_" + index + ".png";
                index++;
                if (index == 3) {
                    index = 1;
                }
                Laya.timer.once(1000, this, this.IceSkinExchange, [index], true);
            }
        }
        RemoveIceEvent() {
            this.RemoveImg(this.iceImg);
            Laya.timer.clear(this, this.IceSkinExchange);
        }
        BarbEvent() {
            this.barbImg = BlockBuff.instence.BarbEvent(this.door);
        }
        RemoveBarbEvent() {
            this.RemoveImg(this.barbImg);
            this.isBarb = false;
            this.barb_2.visible = false;
            this.barb_2.removeSelf();
            this.barb_2 = undefined;
        }
        RemoveImg(img) {
            if (!img) {
                return;
            }
            Laya.Tween.to(img, { alpha: 0 }, 500, null, Laya.Handler.create(this, function () {
                img.visible = false;
                img.alpha = 1;
                img.removeSelf();
                img = null;
            }));
        }
        BarbBuild() {
            let block = this.roomBuild.barb[0];
            if (block) {
                if (!this.barb_2) {
                    let img = this.img;
                    img.pos(45, 45);
                    img.skin = "map/barb_2.png";
                    img.alpha = 0;
                    block.build.addChild(img);
                    this.barb_2 = img;
                }
                this.BarbSkinExchange(1);
            }
        }
        BarbSkinExchange(index) {
            if (this.barb_2) {
                Laya.Tween.to(this.barb_2, { alpha: index }, 700, null, Laya.Handler.create(this, function () {
                    if (index == 1) {
                        index = 0;
                    }
                    else {
                        index = 1;
                    }
                    this.BarbSkinExchange(index);
                }), 0, true);
            }
        }
        RepairEvent() {
            if (!this.repairImg || this.repairImg == undefined) {
                if (this.door.isUse) {
                    this.repairImg = BlockBuff.instence.repairEvent(this.door);
                }
            }
            this.repairNum++;
        }
        RemoveRepairEvent() {
            if (this.roomBuild.repair.length <= 1) {
                this.RemoveImg(this.repairImg);
            }
            else {
                this.buff_immediately.repair.isUse = true;
            }
        }
        RepairUp() {
            if (this.BuffSwitch(Room.buffTypeStr.repair)) {
                if (this.door.hp != 1) {
                    if (TimeManager.instance.AfterAPeriodOfTime_Bool(this.repairTime, 1)) {
                        this.repairTime = TimeManager.instance.gameTime;
                        this.Repatir_Tween_show(this.repairImg);
                    }
                }
                else if (this.repairImg.visible) {
                    this.Repatir_Tween_hide();
                }
            }
        }
        Repatir_Tween_show(repairImg, isSkill = false) {
            if (repairImg == null) {
                return;
            }
            repairImg.visible = true;
            let hp = 0;
            if (!isSkill) {
                hp = this.door.hpMax * 0.02 * this.repairNum / 4;
            }
            else {
                hp = this.door.hpMax * 0.1 / 4;
            }
            repairImg.rotation = 0;
            Laya.Tween.to(repairImg, { rotation: repairImg.rotation - 30, alpha: 1 }, 250, null, Laya.Handler.create(this, () => {
                this.door.hpCur += hp;
                if (this.door.isUse) {
                    Sound.instance.PlaySound(Sound.instance.Other_sound.weixiu, 1, this.door.x, this.door.y);
                }
                Laya.Tween.to(repairImg, { rotation: repairImg.rotation + 30 }, 250, null, Laya.Handler.create(this, () => {
                    this.door.hpCur += hp;
                    Laya.Tween.to(repairImg, { rotation: repairImg.rotation + 30 }, 250, null, Laya.Handler.create(this, () => {
                        this.door.hpCur += hp;
                        if (this.door.isUse) {
                            Sound.instance.PlaySound(Sound.instance.Other_sound.weixiu, 1, this.door.x, this.door.y);
                        }
                        Laya.Tween.to(repairImg, { rotation: repairImg.rotation - 30 }, 250, null, Laya.Handler.create(this, () => {
                            this.door.hpCur += hp;
                        }), 0, true);
                    }), 0, true);
                }), 0, true);
            }), 0, true);
        }
        Repatir_Tween_hide() {
            this.repairImg.visible = false;
        }
        SoleniodEvent() {
        }
        SoleniodBuild() {
            let block = this.roomBuild.solenoid[0];
            if (block) {
                let img = this.img;
                block.build.addChild(img);
                img.pos(45, 45);
                this.soneliodImg = img;
                this.SoleniodSkinExchange(0);
            }
        }
        SoleniodSkinExchange(index) {
            this.soneliodImg.skin = "map/solenoidimg_" + index + ".png";
            index++;
            if (index == 3) {
                index = 0;
            }
            Laya.timer.once(40, this, this.SoleniodSkinExchange, [index], true);
        }
        RemoveSoleniodEvent() {
            this.soneliodImg.visible = false;
            this.soneliodImg.removeSelf();
            this.soneliodImg = undefined;
            Laya.timer.clear(this, this.SoleniodSkinExchange);
        }
        get solenoidMax() {
            return Room._solenoidMax;
        }
        SmoneyEvent(level) {
            let pr = this.bed.pR / 200 * level;
            pr = Math.ceil(pr);
            this.pr += pr;
        }
        SmoneyBuild() {
            let block = this.roomBuild.smoney[0];
            if (block) {
                let img = this.img;
                block.build.addChild(img);
                img.pos(45, 45);
                img.skin = "map/money.png";
                img.alpha = 0;
                this.smoneyImg = img;
                this.SmoneySkinTwinkle(1);
                TimeManager.instance.AddTimeLoopEvent("UpATMPR" + this.roomIndex, this.UpATMPR, this, 1);
            }
        }
        SmoneySkinTwinkle(index) {
            if (this.smoneyImg) {
                Laya.Tween.to(this.smoneyImg, { alpha: index }, 500, null, Laya.Handler.create(this, function () {
                    if (index == 1) {
                        index = 0;
                    }
                    else {
                        index = 1;
                    }
                    this.SmoneySkinTwinkle(index);
                }), 0, true);
            }
        }
        UpATMPR() {
            if (!this.roomBuild.smoney[0] || !this.roomBuild.smoney[0].isUse) {
                TimeManager.instance.RemoveListLoopEvent("UpATMPR" + this.roomIndex);
                this.pr = 0;
                return;
            }
            let block = this.roomBuild.smoney[0];
            if (this.pr == 0) {
                return;
            }
            let count = this.pr;
            this.pr = 0;
            DataManager.instance.game.SetPR(this.roomIndex, count, 0);
            EffectTween.instance.Shake(block.build, 0.2);
            EffectTween.instance.RFEffect("UI/gold1.png", count, block.build);
        }
        RemoveSmoneyEvent() {
            Laya.Tween.clearAll(this.smoneyImg);
            this.smoneyImg.visible = false;
            this.smoneyImg.removeSelf();
            this.smoneyImg = undefined;
            TimeManager.instance.RemoveListLoopEvent("UpATMPR" + this.roomIndex);
            this.pr = 0;
        }
        ParticleaEvent() {
        }
        ParticleaBuild() {
            let block = this.roomBuild.particlea[0];
            if (block) {
                let img = this.img;
                block.build.addChild(img);
                img.skin = "map/particleaImg.png";
                img.pos(45, 45);
                this.particleaImg = img;
                this.ParticleaSkinRotation();
            }
        }
        ParticleaSkinRotation() {
            if (this.particleaImg) {
                Laya.Tween.to(this.particleaImg, { rotation: 360 }, 1000, null, Laya.Handler.create(this, function () {
                    this.particleaImg.rotation = 0;
                    this.ParticleaSkinRotation();
                }), 0, true);
            }
        }
        RemoveParticleaEvent() {
            Laya.Tween.clearAll(this.particleaImg);
            this.particleaImg.visible = false;
            this.particleaImg.removeSelf();
            this.particleaImg = undefined;
        }
        LongrangeEvent() {
        }
        LongrangeBuild() {
            let block = this.roomBuild.longrange[0];
            if (block) {
                let img = this.img;
                img.pos(45, 45);
                img.skin = "map/longrange_2.png";
                block.build.addChild(img);
                this.longrange_2 = img;
                this.longrange_2.alpha = 0;
                this.LongrangSkinTwinkle(1);
            }
        }
        LongrangSkinTwinkle(index) {
            if (this.longrange_2) {
                Laya.Tween.to(this.longrange_2, { alpha: index }, 500, null, Laya.Handler.create(this, function () {
                    if (index == 1) {
                        index = 0;
                    }
                    else {
                        index = 1;
                    }
                    this.LongrangSkinTwinkle(index);
                }), 0, true);
            }
        }
        RemoveLongrangEvent() {
            this.longrange_2.visible = false;
            this.longrange_2.removeSelf();
            this.longrange_2 = undefined;
        }
        SpellEvent() {
            if (this.BuffSwitch(Room.buffTypeStr.spell)) {
                let block = this.roomBuild.spell[0];
                BlockBuff.instence.TriggerEvent(0, block);
            }
        }
        SpellBuild() {
            let block = this.roomBuild.spell[0];
            if (block) {
                let img = this.img;
                img.skin = "map/spellimg_0.png";
                block.build.addChild(img);
                img.pos(45, 45);
                this.spellImg = img;
                this.SpellSkinExchange(0);
            }
        }
        SpellSkinExchange(index) {
            this.spellImg.skin = "map/spellimg_" + index + ".png";
            index++;
            if (index == 3) {
                index = 0;
            }
            Laya.timer.once(100, this, this.SpellSkinExchange, [index], true);
        }
        RemoveSpellEvent() {
            Laya.timer.clear(this, this.SpellSkinExchange);
            this.spellImg.visible = false;
            this.spellImg.removeSelf();
            this.spellImg = undefined;
        }
        EntrapmentEvent() {
            if (this.BuffSwitch(Room.buffTypeStr.entrapment)) {
                let block = this.roomBuild.entrapment[0];
                BlockBuff.instence.TriggerEvent(1, block);
            }
        }
        EntrapmentBuild() {
            let block = this.roomBuild.entrapment[0];
            if (block) {
                let img = this.img;
                img.skin = "map/entramentImage_1.png";
                img.pos(45, 45);
                block.build.addChild(img);
                this.entrapmentImg = img;
            }
        }
        RemoveEntarpmentEvent() {
            this.entrapmentImg.visible = false;
            this.entrapmentImg.removeSelf();
            this.entrapmentImg = undefined;
        }
        GuillotineEvent() {
            if (this.BuffSwitch(Room.buffTypeStr.guillotine)) {
                let block = this.roomBuild.guillotine[0];
                BlockBuff.instence.TriggerEvent(2, block);
            }
        }
        GuillotneBuild() {
            let block = this.roomBuild.guillotine[0];
            if (block) {
                let img = this.img;
                block.build.addChild(img);
                img.pos(45, 45);
                img.skin = "map/guillotine_3.png";
                this.guillotneImg = img;
                this.GuillotneExchange(1);
            }
        }
        GuillotneExchange(index) {
            let block = this.roomBuild.guillotine[0];
            if (block) {
                block.build.skin = "build/guillotine_" + index + ".png";
                index++;
                if (index == 3) {
                    index = 1;
                }
                Laya.timer.once(500, this, this.GuillotneExchange, [index], true);
            }
        }
        RemoveGuillotineEvent() {
            this.guillotneImg.visible = false;
            this.guillotneImg.removeSelf();
            Laya.timer.clear(this, this.GuillotneExchange);
        }
        EnergyhoodEvent() {
            if (this.BuffSwitch(Room.buffTypeStr.energyhood)) {
                this.energuhoodImg = BlockBuff.instence.TriggerEvent(3, this.door);
            }
        }
        EnergyhoodBuild() {
            let block = this.roomBuild.energyhood[0];
            if (block) {
                let img = this.img;
                block.build.addChild(img);
                img.skin = "map/energyhood_2.png";
                img.pos(45, 38);
                img.pivot(45, 38);
                this.energyhood_2 = img;
                this.EnergyhoodSkinRotation();
            }
        }
        EnergyhoodSkinRotation() {
            if (this.energyhood_2) {
                Laya.Tween.to(this.energyhood_2, { rotation: 360 }, 500, null, Laya.Handler.create(this, () => {
                    if (this.energyhood_2) {
                        this.energyhood_2.rotation = 0;
                        this.EnergyhoodSkinRotation();
                    }
                }), 0, true);
            }
        }
        RemoveEnergyhoodEvent() {
            if (!this.BuffSwitch(Room.buffTypeStr.energyhood)) {
                let block = this.roomBuild.energyhood[0];
                if (block.invincible) {
                    this.energuhoodImg.removeSelf();
                    block.invincible = false;
                    Laya.Tween.clearAll(this.energuhoodImg);
                    this.energuhoodImg.visible = false;
                    this.energuhoodImg = null;
                }
                this.energyhood_2.visible = false;
                this.energyhood_2.removeSelf();
                this.energyhood_2 = undefined;
                Laya.Tween.clearAll(this.energyhood_2);
            }
        }
        DoorHit() {
            if (this.energuhoodImg == null) {
                this.EnergyhoodEvent();
            }
            this.AttackHitEffect(this.energuhoodImg, () => {
                this.door.invincible = true;
                TimeManager.instance.AddTimeOnceEvent("DoorInvincible" + this.roomIndex, function () {
                    this.door.invincible = false;
                    if (this.energuhoodImg) {
                        Laya.Tween.to(this.energuhoodImg, { alpha: 0 }, 300, null, Laya.Handler.create(this, function () {
                            this.energuhoodImg.removeSelf();
                            this.energuhoodImg = null;
                        }), 0, true);
                    }
                }, this, 3);
            });
        }
        EnergyhoodUp() {
            if (this.BuffSwitch(Room.buffTypeStr.energyhood)) {
                if (this.door.hp <= 0.3 && !this.isEnerguhood) {
                    this.isEnerguhood = true;
                    this.DoorHit();
                }
            }
        }
        AttackHitEffect(img, func = undefined) {
            if (!img || img == null) {
                return;
            }
            img.visible = true;
            Laya.Tween.to(img, { scaleX: 1.1, scaleY: 1.1, alpha: 1 }, 350, null, Laya.Handler.create(this, function () {
                Laya.Tween.to(img, { scaleX: 1, scaleY: 1 }, 200, null, Laya.Handler.create(this, function () {
                    func && func();
                }), 0, true);
            }), 0, true);
        }
        get buffTypeStr() {
            return Room.buffTypeStr;
        }
        HandleRoomBuff(buffevent) {
            switch (buffevent) {
                case 0:
                    this.SpellEvent();
                    break;
                case 1:
                    this.EntrapmentEvent();
                    break;
                case 2:
                    this.HandleIceEvent();
                    break;
                case 3:
                    this.HandleBarbEvent();
                    break;
                case 4:
                    this.GuillotineEvent();
                    break;
            }
        }
        HandleIceEvent() {
            if (this.BuffSwitch(this.buffTypeStr.ice)) {
                BlockBuff.instence.TrollIceEvent();
            }
        }
        HandleBarbEvent() {
            if (this.BuffSwitch(this.buffTypeStr.barb)) {
                this.isBarb = !this.isBarb;
                this.barbTime = TimeManager.instance.gameTime;
            }
        }
        BarbUp() {
            if (!this.isBarb) {
                return;
            }
            if (TimeManager.instance.AfterAPeriodOfTime_Bool(this.barbTime, 1)) {
                BlockBuff.instence.TrollBarbEvent(this.roomIndex);
                this.barbTime = TimeManager.instance.gameTime;
            }
        }
        get img() {
            let img = null;
            if (Room.imgs.length > 0) {
                for (let index = 0; index < Room.imgs.length; index++) {
                    let imgR = Room.imgs[index];
                    if (!imgR.visible) {
                        imgR.visible = true;
                        img = imgR;
                        break;
                    }
                }
            }
            if (img == null) {
                img = new Laya.Image();
                Room.imgs.push(img);
            }
            img.width = 90;
            img.height = 90;
            img.pivot(45, 45);
            img.rotation = 0;
            img.name = "room";
            img.visible = true;
            return img;
        }
        GameOver() {
            if (this._blocks.length > 0) {
                for (let i = 0; i < this._blocks.length; i++) {
                    let block = this._blocks[i];
                    block.GameOver();
                }
            }
            this.spellImg = undefined;
            this.guillotneImg = undefined;
            this.entrapmentImg = undefined;
            this.repairSkillImg = undefined;
            this.isuse = false;
            this.die = false;
            this.prLevel = 1;
            Laya.timer.clearAll(this);
        }
        static GameOver() {
            for (let index = 0; index < this.imgs.length; index++) {
                let img = this.imgs[index];
                if (img.visible) {
                    img.visible = false;
                    img.removeSelf();
                    Laya.Tween.clearAll(img);
                }
            }
        }
        SkillEvent(index) {
            switch (index) {
                case 0:
                    this.RepairSkillEvent();
                    break;
            }
        }
        RepairSkillEvent() {
            if (!this.door.isUse) {
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "门已被摧毁！！！");
                return;
            }
            if (!this.repairSkillImg) {
                this.repairSkillImg = BlockBuff.instence.repairEvent(this.door);
            }
            this.RepairSkill();
            TimeManager.instance.AddTimeLoopEvent("RepairSkill" + this.roomIndex, this.RepairSkill, this, 1);
        }
        RepairSkill() {
            if (this.repairIndex == 5) {
                this.repairSkillImg.visible = false;
                TimeManager.instance.RemoveListLoopEvent("RepairSkill" + this.roomIndex);
                this.repairIndex = 0;
            }
            else {
                this.Repatir_Tween_show(this.repairSkillImg, true);
                this.repairIndex++;
            }
        }
        PosFindBlock(pos) {
            let posarr = pos.split("_");
            let x = parseInt(posarr[0]);
            let y = parseInt(posarr[1]);
            if (this._blocks.length > 0) {
                for (let i = 0; i < this._blocks.length; i++) {
                    let block = this._blocks[i];
                    if (block.isUse) {
                        if (block.pos.x == x && block.pos.y == y) {
                            return block;
                        }
                    }
                }
                return null;
            }
        }
        set die(vlaue) {
            this._die = vlaue;
        }
        get die() {
            return this._die;
        }
        Die(block) {
            if (!this.door.isUse) {
                if (this.repairImg) {
                    this.repairImg.removeSelf();
                    this.repairImg.visible = false;
                    this.repairImg = null;
                }
                if (this.iceImg) {
                    this.iceImg.removeSelf();
                    this.iceImg.visible = false;
                    this.iceImg = null;
                }
                if (this.barbImg) {
                    this.barbImg.removeSelf();
                    this.barbImg.visible = false;
                    this.barbImg = null;
                }
                if (this.energuhoodImg) {
                    this.energuhoodImg.removeSelf();
                    Laya.Tween.clearAll(this.energuhoodImg);
                    this.energuhoodImg.visible = false;
                    this.energuhoodImg = null;
                }
            }
            this.RemoveBuff(block.name);
        }
        GetBuildNum(str) {
            let buildArr = this.roomBuild[str];
            if (buildArr) {
                return buildArr.length;
            }
            else {
                return null;
            }
        }
    }
    Room._atrange = 1.3;
    Room._atSpeed = 1;
    Room.imgs = new Array();
    Room._solenoidMax = 2;
    Room.roomBuildCount = {
        spell: 1,
        ice: 1,
        entrapment: 1,
        barb: 1,
        guillotine: 1,
        repair: 4,
        energyhood: 1,
        smoney: 1,
        longrange: 1,
        particlea: 1,
        solenoid: 1,
    };
    Room.buffTypeStr = {
        spell: "spell",
        ice: "ice",
        entrapment: "entrapment",
        barb: "barb",
        guillotine: "guillotine",
        repair: "repair",
        energyhood: "energyhood",
        smoney: "smoney",
        longrange: "longrange",
        particlea: "particlea",
        solenoid: "solenoid",
    };

    class BuildMenu {
        constructor() {
            this._bgHeight = 150;
            this._buttonHeight = 140;
            this._selectIndex = 0;
            this.buildCount = Room.roomBuildCount;
            this._menus = new Array();
            this._btnarr = new Array();
            this._dashedBox = [];
            this._boxArr = [];
            this._panel = EventCenter.instance.FireReturn(EventCenter.instance.MAP_GET_ACTIVITYMAP);
            this.AddEvent();
            this.LoadMenu();
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.SHOW_MENU, this.MenuShow, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.HIDE_MENU, this.MenuHide, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.OFF_SHOW_MENU, this.ShowOff, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.OFF_HIDE_MENU, this.HideOff, this);
        }
        LoadMenu() {
            let menuLoad = Laya.loader.getRes("Prefabs/menu.json");
            this._sceen = Laya.stage.getChildAt(0).getChildAt(0);
            this._menu = new Laya.View;
            this._menu.createView(menuLoad);
            this.InitMenu();
        }
        InitMenu() {
            this._buildLoad = Laya.loader.getRes("Prefabs/buildMenu.json");
            this._head = this._menu.getChildByName("head");
            this._head.skin = "UI/Solidline.png";
            this._head.removeSelf();
            this._menuBg = this._menu.getChildByName("BG");
            this._select = this._menu.getChildByName("select");
            this._upText = this._menu.getChildByName("UpText");
            for (let i = 0; i < this._select.numChildren; i++) {
                let index = i;
                let btn = this._select.getChildAt(i);
                btn.on(Laya.Event.CLICK, this, this.SelectBtnEvent, [index, btn]);
            }
            this._build = this._menu.getChildByName("build");
            let load = Laya.loader.getRes("Prefabs/off.json");
            this._off = new Laya.View();
            this._off.createView(load);
            Laya.stage.getChildAt(0).getChildAt(0).addChild(this._off);
            this._off.visible = false;
            this._off.zOrder = 20;
            this._off.on(Laya.Event.CLICK, this, function () {
                EventCenter.instance.Fire(EventCenter.instance.PLOGIC_OFFEVENTHANDLE);
            });
        }
        SelectBtnEvent(index, btn) {
            if (index != this._selectIndex) {
                let p = this._select.getChildAt(this._selectIndex);
                let skin = p.skin;
                p.skin = btn.skin;
                btn.skin = skin;
                this._selectIndex = index;
                this.BuildMenu();
                this.MenuShow();
            }
            btn.skin = "pipei/select_0.png";
        }
        getmenu() {
            let menu = null;
            if (this._menus.length > 0) {
                menu = this._menus.shift();
                menu.visible = true;
            }
            if (menu == null) {
                menu = new Laya.View();
                menu.createView(this._buildLoad);
                let btn = menu.getChildByName("btn");
                EffectTween.instance.AddBtnEvent([btn]);
            }
            return menu;
        }
        BuildMenu() {
            this.ClearMenu();
            var basicBuildInfo = DataManager.instance.build.getbasicBuildData(this._selectIndex);
            for (let i = 0; i < basicBuildInfo.length; i++) {
                this.SubOption(basicBuildInfo[i]);
            }
            this._select.visible = true;
            this._build.y = 139;
            this._upText.text = "建筑";
            this._upText.fontSize = 45;
        }
        BuildUpMenu(block, isme = true) {
            this.ClearMenu();
            let blockName = block.buildName;
            let upStr = this.getUpBuildName(blockName);
            if (isme) {
                this.SubOption(upStr.str);
            }
            if (block.name != "bed" && block.name != "door") {
                this.Dismantle(block.buildName);
            }
            else if (block.name == "door" && !block.adv) {
                if (DataManager.instance.player.DZCount >= DataManager.instance.cdn.cdn.doorADVOpneCount) {
                    this.KingADV(upStr.str);
                }
            }
            this._select.visible = false;
            this._build.y = 72;
        }
        getUpBuildName(name) {
            let str = name.split("_");
            let level = parseInt(str[1]) + 1;
            return { name: str[0], level: level, str: str[0] + "_" + level };
        }
        ClearMenu() {
            if (this._build.numChildren > 0) {
                for (let i = this._build.numChildren - 1; i >= 0; i--) {
                    let view = this._build.getChildAt(i);
                    view.visible = false;
                    this._menus.push(view);
                    this._build.removeChild(view);
                    let btn = view.getChildByName("btn");
                    btn.off(Laya.Event.CLICK, this, this.DismantleClickEvent);
                    btn.off(Laya.Event.CLICK, this, this.MenuClickEvent);
                    btn.off(Laya.Event.CLICK, this, this.MenuClickEvent_ADV);
                }
            }
            this._btnarr.length = 0;
        }
        KingADV(buildStr) {
            let buildstrArr = buildStr.split("_");
            let buildInfo = DataManager.instance.build.GetBuildData(buildstrArr[0], parseInt(buildstrArr[1]));
            if (!buildInfo) {
                return;
            }
            let introduceStr = DataManager.instance.build.GetIntroduce(buildstrArr[0], parseInt(buildstrArr[1]));
            let view = this.getmenu();
            let buildImg = view.getChildByName("buildImg");
            let subBuildImg = view.getChildByName("subBuildImg");
            let buildName = view.getChildByName("name");
            let introduce = view.getChildByName("introduce");
            let count = view.getChildByName("count").getChildByName("counttext");
            count.parent.visible = false;
            let btn = view.getChildByName("btn");
            let goldText1 = btn.getChildByName("goldText1");
            let goldText2 = btn.getChildByName("goldText2");
            let mod1 = btn.getChildByName("mod1");
            let mod2 = btn.getChildByName("mod2");
            let mod3 = btn.getChildByName("mod3");
            let mod4 = btn.getChildByName("mod4");
            mod1.visible = false;
            mod2.visible = false;
            mod3.visible = false;
            mod4.visible = true;
            goldText1.visible = false;
            goldText2.visible = false;
            if (buildstrArr[0] == "at") {
                buildImg.skin = "Atower/" + buildStr + ".png";
                subBuildImg.skin = "Atower/" + buildStr + "_B.png";
                subBuildImg.visible = true;
            }
            else {
                buildImg.skin = "build/" + buildStr + ".png";
                let subSkin = DataManager.instance.build.GetSubSkin(buildstrArr[0]);
                if (subSkin == null) {
                    subBuildImg.visible = false;
                }
                else {
                    subBuildImg.visible = true;
                    subBuildImg.skin = subSkin;
                }
            }
            this._build.addChild(view);
            introduce.text = introduceStr + "\n提示：只有一次使用机会哦!!!";
            buildName.text = buildInfo[0];
            btn.skin = "load/doorAdvBtn.png";
            btn.on(Laya.Event.CLICK, this, this.MenuClickEvent_ADV, [buildStr]);
        }
        Dismantle(strName) {
            let strarr = strName.split("_");
            let buildInfo = DataManager.instance.build.GetBuildData(strarr[0], parseInt(strarr[1]));
            let view = this.getmenu();
            let buildImg = view.getChildByName("buildImg");
            let subBuildImg = view.getChildByName("subBuildImg");
            let btn = view.getChildByName("btn");
            let goldText1 = btn.getChildByName("goldText1");
            let goldText2 = btn.getChildByName("goldText2");
            let mod1 = btn.getChildByName("mod1");
            let mod2 = btn.getChildByName("mod2");
            let mod3 = btn.getChildByName("mod3");
            let mod4 = btn.getChildByName("mod4");
            mod1.visible = false;
            mod2.visible = false;
            mod3.visible = false;
            mod4.visible = false;
            let buildName = view.getChildByName("name");
            let introduce = view.getChildByName("introduce");
            let count = view.getChildByName("count").getChildByName("counttext");
            count.parent.visible = false;
            subBuildImg.visible = false;
            buildName.text = "拆除";
            introduce.text = "摧毁当前建筑，并返回一定的资源。";
            goldText1.visible = false;
            goldText2.visible = false;
            if (buildInfo[1] != 0 && buildInfo[2] != 0) {
                goldText1.visible = true;
                goldText2.visible = true;
                goldText1.text = "+ " + (buildInfo[1] / 2).toString();
                goldText2.text = "+ " + (buildInfo[2] / 2).toString();
                goldText1.y = 26;
                goldText2.y = 68;
            }
            else if (buildInfo[1] != 0) {
                goldText1.text = "+ " + (buildInfo[1] / 2).toString();
                goldText1.visible = true;
                goldText1.y = 50.625;
            }
            else if (buildInfo[2] != 0) {
                goldText2.text = "+ " + (buildInfo[2] / 2).toString();
                goldText2.visible = true;
                goldText2.y = 50.625;
            }
            buildImg.skin = "build/TearDown.png";
            btn.skin = "load/chBtn.png";
            this._build.addChild(view);
            btn.on(Laya.Event.CLICK, this, this.DismantleClickEvent);
        }
        SubOption(buildStr) {
            if (!this._room) {
                return;
            }
            let str = buildStr.split("_");
            let buildInfo = DataManager.instance.build.GetBuildData(str[0], parseInt(str[1]));
            if (buildInfo == undefined) {
                let buildInfo = DataManager.instance.build.GetBuildData(str[0], parseInt(str[1]) - 1);
                let introduceStr = DataManager.instance.build.GetIntroduce(str[0], parseInt(str[1]) - 1);
                this._upText.text = buildInfo[0] + "\n" + introduceStr;
                this._upText.fontSize = 21;
                return;
            }
            else {
                this._upText.text = "升级";
                this._upText.fontSize = 45;
            }
            let introduceStr = DataManager.instance.build.GetIntroduce(str[0], parseInt(str[1]));
            let buildstrArr = buildStr.split("_");
            let view = this.getmenu();
            let buildImg = view.getChildByName("buildImg");
            let subBuildImg = view.getChildByName("subBuildImg");
            let btn = view.getChildByName("btn");
            let goldText1 = btn.getChildByName("goldText1");
            let goldText2 = btn.getChildByName("goldText2");
            let mod1 = btn.getChildByName("mod1");
            let mod2 = btn.getChildByName("mod2");
            let mod3 = btn.getChildByName("mod3");
            let mod4 = btn.getChildByName("mod4");
            mod1.visible = false;
            mod2.visible = false;
            mod3.visible = false;
            mod4.visible = false;
            goldText1.visible = false;
            goldText2.visible = false;
            let buildName = view.getChildByName("name");
            let introduce = view.getChildByName("introduce");
            let count = view.getChildByName("count").getChildByName("counttext");
            let buildCount = DataManager.instance.player.GetBuileprintNum(str[0]);
            let buildNum = this._room.GetBuildNum(str[0]);
            let maxBuildNum = this.buildCount[str[0]];
            introduce.text = introduceStr;
            buildName.text = buildInfo[0];
            this._build.addChild(view);
            btn.on(Laya.Event.CLICK, this, this.MenuClickEvent, [buildStr]);
            if (buildstrArr[0] == "at") {
                buildImg.skin = "Atower/" + buildStr + ".png";
                subBuildImg.skin = "Atower/" + buildStr + "_B.png";
                subBuildImg.visible = true;
            }
            else {
                buildImg.skin = "build/" + buildStr + ".png";
                let subSkin = DataManager.instance.build.GetSubSkin(buildstrArr[0]);
                if (subSkin == null) {
                    subBuildImg.visible = false;
                }
                else {
                    subBuildImg.visible = true;
                    subBuildImg.skin = subSkin;
                }
            }
            if (buildNum != null) {
                if (buildCount == null || buildCount == 0) {
                    count.parent.visible = false;
                    mod1.visible = true;
                    btn.skin = "load/menuBtnNo.png";
                    btn.on(Laya.Event.CLICK, this, this.MenuClickEvent, [buildStr]);
                    return;
                }
                else {
                    count.parent.visible = true;
                    count.text = buildCount.toString();
                    if (buildNum == maxBuildNum) {
                        mod3.visible = true;
                        let text = mod3.getChildByName("textUp");
                        text.text = buildNum + "/" + maxBuildNum;
                        btn.skin = "load/menuBtnNo.png";
                        btn.on(Laya.Event.CLICK, this, this.MenuClickEvent, [buildStr]);
                        return;
                    }
                    else {
                        mod2.visible = true;
                        let text = mod2.getChildByName("text");
                        text.text = "可建造 " + buildNum + "/" + maxBuildNum;
                    }
                }
            }
            else {
                count.parent.visible = false;
            }
            if (buildInfo[1] != 0 && buildInfo[2] != 0) {
                goldText1.visible = true;
                goldText2.visible = true;
                goldText1.text = buildInfo[1];
                goldText2.text = buildInfo[2];
                goldText1.y = 26;
                goldText2.y = 68;
            }
            else if (buildInfo[1] != 0) {
                goldText1.text = buildInfo[1];
                goldText1.visible = true;
                goldText1.y = 50.625;
            }
            else if (buildInfo[2] != 0) {
                goldText2.text = buildInfo[2];
                goldText2.visible = true;
                goldText2.y = 50.625;
            }
            let gold = DataManager.instance.game.GetRoomPR(this._room.roomIndex);
            if (gold.gold1 >= buildInfo[1] && gold.gold2 >= buildInfo[2]) {
                btn.skin = "load/menuBtn.png";
            }
            else {
                btn.skin = "load/menuBtnNo.png";
                this._btnarr.push({ gold1: buildInfo[1], gold2: buildInfo[2], btn: btn });
            }
        }
        UpBtn() {
            if (this._btnarr.length > 0) {
                let gold = DataManager.instance.game.GetRoomPR(this._room.roomIndex);
                for (let i = this._btnarr.length - 1; i >= 0; i--) {
                    let btnInfo = this._btnarr[i];
                    if (gold.gold1 >= btnInfo.gold1 && gold.gold2 >= btnInfo.gold2) {
                        btnInfo.btn.skin = "load/menuBtn.png";
                        this._btnarr.splice(i, 1);
                    }
                }
            }
        }
        MenuShow() {
            if (this._build.numChildren > 0) {
                this._build.height = this._build.numChildren * this._buttonHeight;
                this._menu.height = this._bgHeight + this._build.height;
                this._menuBg.height = this._menu.height;
                let count = this._build.numChildren;
                for (let i = 0; i < count; i++) {
                    let view = this._build.getChildAt(i);
                    view.scale(0, 1);
                    Laya.Tween.to(view, { x: 270, y: i * this._buttonHeight + 70, scaleX: 1, scaleY: 1 }, 200, null, null, i * 100, true);
                }
            }
            this._sceen.addChild(this._menu);
            let x = this._head.x;
            let y = this._head.y;
            this._sceen.addChild(this._head);
            this._head.pos(x, y);
            this._menu.x = this._sceen.width / 2;
            let upHeight = this._head.y / this._sceen.height;
            let downHeight = 1 - upHeight;
            if (upHeight > downHeight) {
                this._menu.y = this._head.y - 45 - this._menu.height;
            }
            else {
                this._menu.y = this._head.y + 45;
            }
            this._menu.zOrder = 19;
            EventCenter.instance.Fire(EventCenter.instance.UIGM_HIDESKILL);
        }
        MenuHide() {
            if (this._menu.parent != Laya.stage.getChildAt(0).getChildAt(0)) {
                return;
            }
            this._menu.removeSelf();
            this._head.removeSelf();
            this.ClearMenu();
            EventCenter.instance.Fire(EventCenter.instance.BUILD_CLICKBLICK_INIT);
            EventCenter.instance.Fire(EventCenter.instance.UIGM_SHOWSKILL);
        }
        get head() {
            if (this._build.numChildren == 0) {
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "该建筑以达到最高级别");
                return null;
            }
            return this._head;
        }
        MenuClickEvent(buildType) {
            EventCenter.instance.Fire(EventCenter.instance.BUILD_BUILDORUP, buildType);
            this.MenuHide();
        }
        MenuClickEvent_ADV(buildType) {
            Platform.video.playVideo({
                success() {
                    // this._room.door.adv = true;
                    EventCenter.instance.Fire(EventCenter.instance.BUILD_BUILDORUP_ADV, buildType);
                    this.MenuHide();
                },
                fail() {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "视频未播放完成");
                }
            });
        }
        DismantleClickEvent() {
            Sound.instance.PlaySound(Sound.instance.Other_sound.CC);
            EventCenter.instance.Fire(EventCenter.instance.BUILD_BUILD_DISMANTLE);
            this.MenuHide();
        }
        ShowOff(str, pos = null) {
            if (str == "上床") {
                this.GameOver();
            }
            if (pos != null) {
                this._off.pos(pos.x, pos.y);
            }
            this._off.getChildByName("offImg").skin = "pipei/" + str + ".png";
            this._off.visible = true;
        }
        HideOff() {
            this._off.visible = false;
        }
        TwinkleHandle(array) {
            for (let i = 0; i < array.length; i++) {
                let element = array[i];
                let img = this.GetTwinkleImg();
                img.visible = true;
                img.pos(element.x, element.y);
                this._panel.addChild(img);
                this.ShowTwinkle(img);
                this._dashedBox.push(img);
            }
        }
        setTwinkleSkin(x, y, mod = 1) {
            let node = null;
            if (this._dashedBox.length > 0) {
                for (let i = 0; i < this._dashedBox.length; i++) {
                    let img = this._dashedBox[i];
                    if (img.x == x && img.y == y) {
                        node = img;
                        break;
                    }
                }
            }
            if (node != null) {
                node.skin = "UI/dashed_" + mod + ".png";
            }
        }
        ShowTwinkle(node) {
            node.alpha = 0;
            Laya.Tween.to(node, { alpha: 1 }, 2000, null, Laya.Handler.create(this, function () {
                Laya.Tween.to(node, { alpha: 0 }, 2000, null, Laya.Handler.create(this, function () {
                    this.ShowTwinkle(node);
                }), 0, true);
            }), 0, true);
        }
        GetTwinkleImg() {
            let img;
            if (this._boxArr.length > 0) {
                img = this._boxArr.shift();
            }
            else {
                img = new Laya.Image();
            }
            img.width = 90;
            img.height = 90;
            img.pivot(45, 45);
            img.skin = "UI/dashed_1.png";
            return img;
        }
        GameOver() {
            for (let i = 0; i < this._dashedBox.length; i++) {
                let img = this._dashedBox[i];
                img.removeSelf();
                Laya.Tween.clearAll(img);
                this._boxArr.push(img);
            }
            this._dashedBox.length = 0;
            this._btnarr.length = 0;
        }
        StartGame() {
            TimeManager.instance.AddTimeLoopEvent("UpBtn", this.UpBtn, this, 0.2);
        }
        set room(value) {
            this._room = value;
        }
    }

    class BlockMine extends BlockBase {
        Handel_UpData(block) {
            if (!block.room.die) {
                this.IncreasePR(block);
            }
        }
        BlockInfo(block, blockInfo) {
            block.pR = blockInfo[3];
        }
        IncreasePR(block) {
            let pr = block.pR * block.room.prLevel * block.room.doubleGold1;
            DataManager.instance.game.SetPR(block.room.roomIndex, pr, 0);
            let off = 0.01 * block.level;
            if (block.pREffect) {
                EffectTween.instance.Shake(block.build, off);
                EffectTween.instance.RFEffect("UI/gold1.png", block.pR, block.build);
            }
        }
        GetBlockInfo() {
            if (this._blockInfos.length > 0) {
                for (let i = this._blockInfos.length - 1; i >= 0; i--) {
                    if (!this._blockInfos[i].isUse) {
                        let block = this._blockInfos[i];
                        this._blockInfos.splice(i, 1);
                        return block;
                    }
                }
            }
            var info = new ResourcesBlock();
            return info;
        }
    }

    class BuildManager {
        constructor() {
            this.clickBlock = { x: null, y: null, blockC: null, roomIndex: null, block: null };
            this._buildInfo = {
                bed: new BlockBed(),
                door: new BlockDoor(),
                game: new BlockGame(),
                at: new BlockAtower(),
                mine: new BlockMine()
            };
            this._loadBuild = false;
            this._buildMenu = new BuildMenu();
            this._rooms = [];
            this._roomBuild = new Array();
            this.AddEvent();
            this.AddUPEvent();
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.CLICK_BUILD, this.ClickBuildEvent, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.COLLECTIVE_BUILD, this.CollectiveBuild, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_NEW, this.Build, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_BUILDORUP, this.BuildOrUp, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_BUILDORUP_ADV, this.BuildOrUpADV, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_CLICKBLICK_INIT, this.ClickBlockInit, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_UPBUILD, this.BuildUp, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_BUILD_DISMANTLE, this.BuildDismantle, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_HANDLEROOMBUFF, this.HandleRoomBuff, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_FINDDOOR, this.FindDoor, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_FINDBEDANDDOOR, this.FindBedAndDoor, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_FINDROOM, this.GetRoom, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_GOTOBED, this.GoToBed, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_GET_ROOMALLBLOCK, this.FindRoomBuild, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_FINDBLOCKPOS, this.FindBlockPos, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_PARALYSIS_ON, this.Paralysis_on, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_SKILLEVENT, this.SkillEvent, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_SETTWINKSKin, this.SetTwinkleSkin, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_SET_ROOM_DIE, this.SetRoomDie, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_GET_AT_BUILDCOUNT, this.GetBuildAtCount, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_GET_GAME_BUILDCOUNT, this.GetBuildGameCount, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.BUILD_REACHC, this.ReachConditions, this);
        }
        AddUPEvent() {
            UpEventHandle.instance.AddUPEvent("buildManager", this.UpData, this);
        }
        ClickBuildEvent(x, y, buildType, roomIndex) {
            if (this.clickBlock.x != null && this.clickBlock.y != null) {
                if (this.clickBlock.x == x && this.clickBlock.y == y) {
                    this._buildMenu.MenuHide();
                    return;
                }
            }
            this.clickBlock.x = x;
            this.clickBlock.y = y;
            this.clickBlock.blockC = null;
            this.clickBlock.block = null;
            this.clickBlock.roomIndex = roomIndex;
            var blockBuild = this._buildInfo[buildType];
            let room = this.GetRoom(roomIndex);
            let head = null;
            if (roomIndex != PlayerManager.instance.player.roomIndex) {
                if (!room.bed.isUse && buildType.length != 0) {
                    if (blockBuild) {
                        let pos = x + "_" + y;
                        var block = blockBuild.FindBlockInfo_Pos(pos);
                        if (block != null) {
                            this.clickBlock.block = block;
                            this.clickBlock.blockC = blockBuild;
                            this._buildMenu.BuildUpMenu(block, false);
                            head = this._buildMenu.head;
                        }
                    }
                    else {
                        let block = room.getBlock(buildType, { x: x, y: y });
                        if (block != null) {
                            this.clickBlock.block = block;
                            this.clickBlock.blockC = blockBuild;
                            this._buildMenu.BuildUpMenu(block);
                            head = this._buildMenu.head;
                        }
                    }
                }
            }
            else {
                if (blockBuild == undefined) {
                    if (buildType.length == 0) {
                        this._buildMenu.BuildMenu();
                        head = this._buildMenu.head;
                    }
                    else {
                        let block = room.getBlock(buildType, { x: x, y: y });
                        if (block != null) {
                            this.clickBlock.block = block;
                            this.clickBlock.blockC = blockBuild;
                            this._buildMenu.BuildUpMenu(block, true);
                            head = this._buildMenu.head;
                        }
                    }
                }
                else {
                    let pos = x + "_" + y;
                    var block = blockBuild.FindBlockInfo_Pos(pos);
                    if (block != null) {
                        this.clickBlock.block = block;
                        this.clickBlock.blockC = blockBuild;
                        this._buildMenu.BuildUpMenu(block);
                        head = this._buildMenu.head;
                    }
                }
            }
            if (head != null) {
                EventCenter.instance.Fire(EventCenter.instance.SET_POS_MENU, x, y, head);
            }
        }
        CollectiveBuild(builds) {
            if (builds.length < 0) {
                return;
            }
            for (let i = 0; i < builds.length; i++) {
                let build = builds[i];
                this.Build(build.pos, build.build, build.roomIndex);
            }
            this._loadBuild = true;
        }
        Build(pos, build, roomIndex) {
            let type = build.name.split("_")[0];
            let block = this._buildInfo[type];
            let room = this.GetRoom(roomIndex);
            if (!block) {
                if (PlayerManager.instance.player && roomIndex == PlayerManager.instance.player.roomIndex) {
                    let buildNum = DataManager.instance.player.GetBuileprintNum(type);
                    if (buildNum <= 0) {
                        EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "建筑蓝图不足，请到商店购买");
                        EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, build, null);
                        let gold = DataManager.instance.game.GetRoomPR(roomIndex);
                        let buildStr = build.name.split("_");
                        let buildInfo = DataManager.instance.build.GetBuildData(buildStr[0], parseInt(buildStr[1]));
                        gold.gold1 += buildInfo[1];
                        gold.gold2 += buildInfo[2];
                        EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_DISMANTLE, build, build.x, build.y);
                    }
                    else if (!room.Build(pos, build)) {
                        EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, build, null);
                        let gold = DataManager.instance.game.GetRoomPR(roomIndex);
                        let buildStr = build.name.split("_");
                        let buildInfo = DataManager.instance.build.GetBuildData(buildStr[0], parseInt(buildStr[1]));
                        gold.gold1 += buildInfo[1];
                        gold.gold2 += buildInfo[2];
                        EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_DISMANTLE, build, build.x, build.y);
                        EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "建筑数量已达上限");
                    }
                    else {
                        if (this._loadBuild) {
                            Sound.instance.PlaySound(Sound.instance.TB_sound.build_build, 1, build.x, build.y);
                            DataManager.instance.player.ModifiedBuileprintQuantity(type, -1);
                        }
                    }
                }
                else if (!room.Build(pos, build)) {
                    EventCenter.instance.Fire(EventCenter.instance.MAP_DEMOLISH, build, null);
                    let gold = DataManager.instance.game.GetRoomPR(roomIndex);
                    let buildStr = build.name.split("_");
                    let buildInfo = DataManager.instance.build.GetBuildData(buildStr[0], parseInt(buildStr[1]));
                    gold.gold1 += buildInfo[1];
                    gold.gold2 += buildInfo[2];
                    EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_DISMANTLE, build, build.x, build.y);
                }
                else {
                    if (this._loadBuild) {
                        Sound.instance.PlaySound(Sound.instance.TB_sound.build_build, 1, build.x, build.y);
                    }
                }
            }
            else {
                let s = block.Build(pos, build, room);
                this.AddRoomBuild(roomIndex, s);
                if (this._loadBuild) {
                    Sound.instance.PlaySound(Sound.instance.TB_sound.build_build, 1, build.x, build.y);
                    if (roomIndex == PlayerManager.instance.player.roomIndex) {
                        DataManager.instance.player.ModifiedBuileprintQuantity(type, -1);
                    }
                }
            }
        }
        BuildUp(pos, block) {
            let type = block.name.split("_")[0];
            let blockb = this._buildInfo[type];
            blockb.BuildUp(pos, block);
            Sound.instance.PlaySound(Sound.instance.TB_sound.build_up, 1, block.x, block.y);
        }
        BuildOrUp(buildType) {
            let gold = DataManager.instance.game.GetRoomPR(PlayerManager.instance.player.roomIndex);
            let buildStr = buildType.split("_");
            let buildInfo = DataManager.instance.build.GetBuildData(buildStr[0], parseInt(buildStr[1]));
            if (buildInfo[5].length != 0 && !this.ReachConditions(buildInfo[5], PlayerManager.instance.player.roomIndex)) {
                let strArr = buildInfo[5].split("_");
                let info = DataManager.instance.build.GetBuildData(strArr[0], parseInt(strArr[1]));
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "需要一个" + info[0]);
                return;
            }
            if (gold.gold1 >= buildInfo[1] && gold.gold2 >= buildInfo[2]) {
                let hack_gold1 = Laya.LocalStorage.getItem("gold1");
                let hack_gold2 = Laya.LocalStorage.getItem("gold1");
                console.log("hack_gold1=="+hack_gold1+"------hack_gold2=="+hack_gold1)
                if (hack_gold1==1) {  
                    gold.gold1 += buildInfo[1];
                }else{
                    gold.gold1 -= buildInfo[1]; 
                } 
                if (hack_gold2==1) {  
                    gold.gold2 += buildInfo[2];
                }else{
                    gold.gold2 -= buildInfo[2]; 
                }
                 
                if (this.clickBlock.blockC == null) {
                    EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_NEW, this.clickBlock.x, this.clickBlock.y, buildType);
                }
                else {
                    let block = this.clickBlock.blockC.FindBlockInfo_Pos(this.clickBlock.x + "_" + this.clickBlock.y);
                    if (block != null) {
                        Sound.instance.PlaySound(Sound.instance.TB_sound.build_up);
                        EventCenter.instance.Fire(EventCenter.instance.MAP_UPBUILD, block.build, buildType);
                        this.clickBlock.blockC.BuildUp(this.clickBlock.x + "_" + this.clickBlock.y);
                        EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.buildDownEffect, block.build.x, block.build.y);
                        this._buildMenu.MenuHide();
                    }
                    else {
                        EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "该建筑已被摧毁！！！");
                    }
                }
            }
            else {
                if (gold.gold1 < buildInfo[1] && gold.gold2 < buildInfo[2]) {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "金币、闪电不足，请升级床铺、闪电");
                }
                else if (gold.gold1 < buildInfo[1]) {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "金币不足，请提升床铺");
                }
                else {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "闪电不足，请提升游戏机");
                }
            }
        }
        BuildOrUpADV(buildType) {
            if (this.clickBlock.blockC == null) {
                EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_NEW, this.clickBlock.x, this.clickBlock.y, buildType);
            }
            else {
                let block = this.clickBlock.blockC.FindBlockInfo_Pos(this.clickBlock.x + "_" + this.clickBlock.y);
                if (block != null) {
                    Sound.instance.PlaySound(Sound.instance.TB_sound.build_up);
                    EventCenter.instance.Fire(EventCenter.instance.MAP_UPBUILD, block.build, buildType);
                    this.clickBlock.blockC.BuildUp(this.clickBlock.x + "_" + this.clickBlock.y);
                    EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.buildDownEffect, block.build.x, block.build.y);
                    this._buildMenu.MenuHide();
                }
                else {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "该建筑已被摧毁！！！");
                }
            }
        }
        ReachConditions(str, roomIndex) {
            let s = str.split("_");
            let level = parseInt(s[1]);
            let bs = this._buildInfo[s[0]];
            if (!bs.ReachConditions(level, roomIndex)) {
                DataManager.instance.build.GetBuildData(s[0], parseInt(s[1]));
                return false;
            }
            return true;
        }
        BuildDismantle() {
            if (this.clickBlock.blockC != null) {
                var block = this.clickBlock.blockC.FindBlockInfo_Pos(this.clickBlock.x + "_" + this.clickBlock.y);
            }
            else {
                block = this.clickBlock.block;
                let room = block.room;
                room.RemoveBuff(block.name);
                room.BuildDismantle(block);
            }
            let x = block.x;
            let y = block.y;
            let gold = DataManager.instance.game.GetRoomPR(PlayerManager.instance.player.roomIndex);
            if (gold) {
                let build = DataManager.instance.build.GetBuildData(block.name, block.level);
                let gold1 = Math.floor(build[1] / 2);
                let gold2 = Math.floor(build[2] / 2);
                gold.gold1 += gold1;
                gold.gold2 += gold2;
                if (build[1] != 0) {
                    EffectTween.instance.RFEffect("UI/gold1.png", gold1, block.build);
                }
                if (build[2] != 0) {
                    EffectTween.instance.RFEffect("UI/gold2.png", gold2, block.build);
                }
            }
            block.GameOver();
            EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_DISMANTLE, block.build, x, y);
            this._buildMenu.MenuHide();
        }
        ClickBlockInit() {
            this.clickBlock.x = null;
            this.clickBlock.y = null;
            this.clickBlock.blockC = null;
            this.clickBlock.roomIndex = null;
            this.clickBlock.block = null;
        }
        UpData() {
            for (let i = 0; i < this._rooms.length; i++) {
                let room = this._rooms[i];
                room.UpHandle();
            }
            this._buildInfo.mine.UpData();
            this._buildInfo.door.UpData();
            this._buildInfo.game.UpData();
            this._buildInfo.at.UpData();
            this._buildInfo.bed.UpData();
        }
        FindDoor(roomIndex) {
            var block = this._buildInfo.door.FindBlockInfo_RoomIndex(roomIndex);
            return block;
        }
        FindBedAndDoor(roomIndex) {
            let bed = this._buildInfo.bed.FindBlockInfo_RoomIndex(roomIndex);
            let door = this.FindDoor(roomIndex);
            return { bed: bed, door: door };
        }
        GoToBed(block, index, isShow = false) {
            block.build.skin = "build/bed_1.png";
            block.head = index;
            block.isOpen = true;
            let door = this.FindDoor(block.room.roomIndex);
            door.CloseDoor();
            EventCenter.instance.Fire(EventCenter.instance.MGM_SET_BLOCKDYNWALKABLE, door.x, door.y, door.isOpen);
            if (isShow) {
                let array = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_BLOCKPOSS, block.room.roomIndex);
                if (array != null) {
                    this._buildMenu.TwinkleHandle(array);
                    this._roomBlock = this.GetRoomBuild(block.room.roomIndex).block;
                    this._buildMenu.room = block.room;
                    TimeManager.instance.AddTimeLoopEvent("RoomBuildUp", this.RoomBuildUp, this, 0.02);
                }
            }
        }
        FindRoomBuild(roomIndex) {
            let blocks = [];
            for (let v in this._buildInfo) {
                let bs = this._buildInfo[v].GetRoomAllBlock(roomIndex);
                if (bs != null) {
                    blocks = blocks.concat(bs);
                }
            }
            if (blocks.length > 0) {
                return blocks;
            }
            else {
                return null;
            }
        }
        FindBlockPos(pos, roomIndex) {
            for (let key in this._buildInfo) {
                let bs = this._buildInfo[key].FindBlockInfo_Pos(pos);
                if (bs != null) {
                    return bs;
                }
            }
            if (roomIndex != -1) {
                let room = this.GetRoom(roomIndex);
                return room.PosFindBlock(pos);
            }
            return null;
        }
        GameOver() {
            BlockBuff.instence.GameOver();
            Room.GameOver();
            this.ClearRoom();
            this._buildMenu.GameOver();
            this._buildInfo.mine.GameOver();
            this._buildInfo.at.GameOver();
            this._buildInfo.bed.GameOver();
            this._buildInfo.door.GameOver();
            this._buildInfo.game.GameOver();
            this._buildMenu.MenuHide();
            this._buildMenu.HideOff();
            this.clickBlock = { x: null, y: null, blockC: null, roomIndex: null, block: null };
            this._roomBlock = null;
            this._roomBuild.length = 0;
            this._loadBuild = false;
        }
        ClearRoom() {
            for (let i = 0; i < this._rooms.length; i++) {
                let room = this._rooms[i];
                room.GameOver();
            }
        }
        GetRoom(roomIndex) {
            if (roomIndex >= 0 && roomIndex < this._rooms.length) {
                for (let i = 0; i < this._rooms.length; i++) {
                    let room = this._rooms[i];
                    if (roomIndex == room.roomIndex) {
                        return room;
                    }
                }
            }
            let room = new Room(roomIndex);
            this._rooms.push(room);
            this.SortRoom();
            return room;
        }
        StartGame() {
            if (this._rooms.length > 0) {
                for (let i = 0; i < this._rooms.length; i++) {
                    let room = this._rooms[i];
                    room.StartGame();
                }
            }
            this._buildMenu.StartGame();
        }
        Paralysis_on(builds) {
            if (builds.length > 0) {
                for (let i = 0; i < builds.length; i++) {
                    let pos = builds[i];
                    let at = this._buildInfo.at.FindBlockInfo_Pos(pos);
                    if (at && at.isUse) {
                        at.paralysis = true;
                        EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.build_vertigo, at.x, at.y, true, 3000);
                    }
                }
                this._paralyss = builds;
                TimeManager.instance.AddTimeOnceEvent("paralysis_off", this.paralysis_off, this, 3);
            }
        }
        paralysis_off() {
            let builds = this._paralyss;
            if (builds.length > 0) {
                for (let i = 0; i < builds.length; i++) {
                    let pos = builds[i];
                    let at = this._buildInfo.at.FindBlockInfo_Pos(pos);
                    if (at && at.isUse) {
                        at.paralysis = false;
                    }
                }
            }
            this._paralyss = null;
        }
        HandleRoomBuff(roomIndex, buffEvent) {
            if (roomIndex < this._rooms.length && roomIndex >= 0) {
                let room = this._rooms[roomIndex];
                room.HandleRoomBuff(buffEvent);
            }
        }
        SortRoom() {
            if (this._rooms.length > 1) {
                for (let i = 0; i < this._rooms.length - 1; i++) {
                    for (let j = i + 1; j < this._rooms.length; j++) {
                        if (this._rooms[i].roomIndex > this._rooms[j].roomIndex) {
                            let room = this._rooms[i];
                            this._rooms[i] = this._rooms[j];
                            this._rooms[j] = room;
                        }
                    }
                }
            }
        }
        SkillEvent(roomindex, skillIndex) {
            let room = this._rooms[roomindex];
            if (room) {
                room.SkillEvent(skillIndex);
            }
        }
        GetRoomBuild(roomIndex) {
            if (this._roomBuild.length > 0) {
                for (let i = 0; i < this._roomBuild.length; i++) {
                    let room = this._roomBuild[i];
                    if (room.roomIndex == roomIndex) {
                        return room;
                    }
                }
            }
            let room = { roomIndex: roomIndex, block: [] };
            this._roomBuild.push(room);
            return room;
        }
        AddRoomBuild(roomIndex, sblock) {
            let room = this.GetRoomBuild(roomIndex);
            for (let i = 0; i < room.block.length; i++) {
                let block = room.block[i];
                if (block == sblock) {
                    return;
                }
            }
            room.block.push(sblock);
        }
        RoomBuildUp() {
            if (this._roomBlock && this._roomBlock.length > 0) {
                for (let i = this._roomBlock.length - 1; i >= 0; i--) {
                    let block = this._roomBlock[i];
                    if (!block.isUse) {
                        this._roomBlock.splice(i, 1);
                        continue;
                    }
                    if (this.UpInspect(block.name, block.level + 1)) {
                        if (!block.isPromptUp) {
                            this.SetTwinkleSkin(block.x, block.y, 0);
                            block.isPromptUp = true;
                            block.ShowPromptUp();
                        }
                    }
                    else {
                        if (block.isPromptUp) {
                            this.SetTwinkleSkin(block.x, block.y);
                            block.isPromptUp = false;
                            block.HidePromptUp();
                        }
                    }
                }
            }
        }
        SetTwinkleSkin(x, y, mod = 1) {
            this._buildMenu.setTwinkleSkin(x, y, mod);
        }
        UpInspect(name, level) {
            let buildType = name + "_" + level;
            let gold = DataManager.instance.game.GetRoomPR(PlayerManager.instance.player.roomIndex);
            let buildStr = buildType.split("_");
            let buildInfo = DataManager.instance.build.GetBuildData(buildStr[0], parseInt(buildStr[1]));
            if (!buildInfo) {
                return false;
            }
            if (buildInfo[5].length != 0 && !this.ReachConditions(buildInfo[5], PlayerManager.instance.player.roomIndex)) {
                return false;
            }
            if (!(gold.gold1 >= buildInfo[1] && gold.gold2 >= buildInfo[2])) {
                return false;
            }
            return true;
        }
        SetRoomDie(roomIndex) {
            let room = this.GetRoom(roomIndex);
            room.die = true;
        }
        GetBuildAtCount(roomIndex) {
            return this._buildInfo.at.FindBlockInfo_RoomIndex_count(roomIndex);
        }
        GetBuildGameCount(roomIndex) {
            return this._buildInfo.game.FindBlockInfo_RoomIndex_count(roomIndex);
        }
    }

    class AStar {
        constructor() {
            this._straightCost = 1.0;
            this._diagCost = Math.SQRT2;
            this._slant = false;
            this._heuristic = this.euclidian;
        }
        findPath(grid) {
            this._grid = grid;
            this._open = [];
            this._closed = [];
            this._startNode = this._grid.startNode;
            this._endNode = this._grid.endNode;
            this._startNode.g = 0;
            this._startNode.h = this._heuristic(this._startNode);
            this._startNode.f = this._startNode.g + this._startNode.h;
            return this.search();
        }
        search() {
            var node = this._startNode;
            while (node != this._endNode) {
                var startX = Math.max(0, node.x - 1);
                var endX = Math.min(this._grid.numCols - 1, node.x + 1);
                var startY = Math.max(0, node.y - 1);
                var endY = Math.min(this._grid.numRows - 1, node.y + 1);
                for (var i = startX; i <= endX; i++) {
                    for (var j = startY; j <= endY; j++) {
                        if (!this._slant) {
                            if (i != node.x && j != node.y) {
                                continue;
                            }
                        }
                        var test = this._grid.getNode(i, j);
                        if (test == node ||
                            !test.walkable ||
                            !this._grid.getNode(node.x, test.y).walkable ||
                            !this._grid.getNode(test.x, node.y).walkable) {
                            continue;
                        }
                        var cost = this._straightCost;
                        if (!((node.x == test.x) || (node.y == test.y))) {
                            cost = this._diagCost;
                        }
                        var g = node.g + cost * test.costMultiplier;
                        var h = this._heuristic(test);
                        var f = g + h;
                        if (this.isOpen(test) || this.isClosed(test)) {
                            if (test.f > f) {
                                test.f = f;
                                test.g = g;
                                test.h = h;
                                test.parent = node;
                            }
                        }
                        else {
                            test.f = f;
                            test.g = g;
                            test.h = h;
                            test.parent = node;
                            this._open.push(test);
                        }
                    }
                }
                this._closed.push(node);
                if (this._open.length == 0) {
                    console.log("AStar >> no path found", i);
                    return false;
                }
                let openLen = this._open.length;
                for (let m = 0; m < openLen; m++) {
                    for (let n = m + 1; n < openLen; n++) {
                        if (this._open[m].f > this._open[n].f) {
                            let temp = this._open[m];
                            this._open[m] = this._open[n];
                            this._open[n] = temp;
                        }
                    }
                }
                node = this._open.shift();
            }
            this.buildPath();
            return true;
        }
        buildPath() {
            this._path = new Array();
            var node = this._endNode;
            this._path.push(node);
            while (node != this._startNode) {
                node = node.parent;
                this._path.unshift(node);
            }
        }
        get path() {
            return this._path;
        }
        isOpen(node) {
            for (var i = 0; i < this._open.length; i++) {
                if (this._open[i] == node) {
                    return true;
                }
            }
            return false;
        }
        isClosed(node) {
            for (var i = 0; i < this._closed.length; i++) {
                if (this._closed[i] == node) {
                    return true;
                }
            }
            return false;
        }
        manhattan(node) {
            return Math.abs(node.x - this._endNode.x) * this._straightCost + Math.abs(node.y + this._endNode.y) * this._straightCost;
        }
        euclidian(node) {
            var dx = node.x - this._endNode.x;
            var dy = node.y - this._endNode.y;
            return Math.sqrt(dx * dx + dy * dy) * this._straightCost;
        }
        diagonal(node) {
            var dx = Math.abs(node.x - this._endNode.x);
            var dy = Math.abs(node.y - this._endNode.y);
            var diag = Math.min(dx, dy);
            var straight = dx + dy;
            return this._diagCost * diag + this._straightCost * (straight - 2 * diag);
        }
        get visited() {
            return this._closed.concat(this._open);
        }
        set slant(value) {
            this._slant = value;
        }
    }

    class BlockNode {
        constructor(x, y) {
            this.walkable = true;
            this.dynWalkable = true;
            this.costMultiplier = 1.0;
            this.x = x;
            this.y = y;
        }
    }

    class Grid {
        constructor(numCols, numRows) {
            this._numCols = numCols;
            this._numRows = numRows;
            this._nodes = [];
            for (let i = 0; i < numCols; i++) {
                this._nodes[i] = [];
                for (let j = 0; j < numRows; j++) {
                    this._nodes[i][j] = new BlockNode(i, j);
                }
            }
        }
        set mapData(value) {
            this._mapData = value;
        }
        getNode(x, y) {
            if (x < 0 || x >= this.numCols || y < 0 || y >= this.numRows) {
                return null;
            }
            return this._nodes[x][y];
        }
        setEndNode(x, y) {
            this._endNode = this.getNode(x, y);
            if (this._endNode == null) {
                return true;
            }
            if (!this._endNode.walkable) {
                let arr = [];
                let node1 = this.getNode(x - 1, y);
                let node2 = this.getNode(x + 1, y);
                let node3 = this.getNode(x, y - 1);
                let node4 = this.getNode(x, y + 1);
                if (node1 != null && node1.walkable) {
                    arr.push(node1);
                }
                if (node2 != null && node2.walkable) {
                    arr.push(node2);
                }
                if (node3 != null && node3.walkable) {
                    arr.push(node3);
                }
                if (node4 != null && node4.walkable) {
                    arr.push(node4);
                }
                if (arr.length > 0) {
                    let node = arr[Math.floor(Math.random() * arr.length)];
                    this._endNode = node;
                }
            }
            return false;
        }
        setStartNode(x, y) {
            this._startNode = this._nodes[x][y];
        }
        setWalkable(x, y, value) {
            this._nodes[x][y].walkable = value;
        }
        setDynWalkable(x, y, value) {
            this._nodes[x][y].dynWalkable = value;
        }
        get endNode() {
            return this._endNode;
        }
        get numCols() {
            return this._numCols;
        }
        get numRows() {
            return this._numRows;
        }
        get startNode() {
            return this._startNode;
        }
        SetAllWalkable() {
            for (let i = 0; i < this.numCols; i++) {
                for (let j = 0; j < this._numRows; j++) {
                    this.setWalkable(i, j, this._mapData.IsWalkable(i, j));
                    this.setDynWalkable(i, j, this._mapData.IsWalkable(i, j));
                }
            }
        }
    }

    class GameMap {
        constructor() {
            this._mapW = 90;
            this._showDataCoordinate = { startX: -1, endX: -1, startY: -1, endY: -1 };
            this._resShowMap = false;
            this._screen = Laya.stage.getChildAt(0).getChildAt(0);
            this._sceneWidth = Laya.stage.width;
            this._sceneHeight = Laya.stage.height;
            this._screen.width = this._sceneWidth;
            this._screen.height = this._sceneHeight;
            this._showCols = Math.floor((this._sceneHeight + 180) / this._mapW);
            this._showRows = Math.floor((this._sceneWidth + 180) / this._mapW);
            this._images = new Array();
            this._showArea = new Array();
            this._blackArr = new Array();
            this._panelMap = new Laya.Sprite();
            this._landMap = new Laya.Sprite();
            this._inMap = new Laya.Sprite();
            this._activityMap = new Laya.Sprite();
            this._panelMap.addChild(this._landMap);
            this._panelMap.addChild(this._inMap);
            this._panelMap.addChild(this._activityMap);
            this._screen.addChild(this._panelMap);
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.CLICK_MAP, this.BlockClickEvent, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.SET_POS_MENU, this.SetBuildMenuPos, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_BUILD_NEW, this.NewBuild, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_UPBUILD, this.BuildUp, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_BUILD_DISMANTLE, this.BuildDismantle, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_ADD_ACTIVITY, this.AddAtivity, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_MAPMOVE, this.MoveMap, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_DISTANCE, this.ReturnDistance, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_GET_ACTIVITYMAP, this.GetActivityMap, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MAP_DEMOLISH, this.Demolish, this);
        }
        SetMapData(mapData) {
            this._mapData = mapData;
            this.readMapCR();
            this.Init();
        }
        Init() {
            this._landMap.width = this._numRows * this._mapW;
            this._landMap.height = this._numCols * this._mapW;
            this._inMap.width = this._numRows * this._mapW;
            this._inMap.height = this._numCols * this._mapW;
            this._activityMap.width = this._numRows * this._mapW;
            this._activityMap.height = this._numCols * this._mapW;
            this._panelMap.width = this._numRows * this._mapW;
            this._panelMap.height = this._numCols * this._mapW;
            this._landMap.pos(0, 0);
            this._inMap.pos(0, 0);
        }
        readMapCR() {
            let cr = this._mapData.GetMapColsOrRows();
            this._numCols = cr[0];
            this._numRows = cr[1];
        }
        get numCols() {
            return this._numCols;
        }
        get numRows() {
            return this._numRows;
        }
        GetImage() {
            var img;
            if (this._images.length > 0) {
                img = this._images.shift();
            }
            if (img == null) {
                img = this.CreateImage();
            }
            img.visible = true;
            img.width = 90;
            img.height = 90;
            img.pivot(45, 45);
            img.rotation = 0;
            img.name = "";
            return img;
        }
        CreateImage() {
            let img = new Laya.Image();
            return img;
        }
        ClearMap() {
            for (let i = this._landMap.numChildren - 1; i >= 0; i--) {
                let img = this._landMap.getChildAt(i);
                img.visible = false;
                this._images.push(img);
                this._landMap.removeChild(img);
            }
        }
        Demolish(build, sub) {
            if (build != null) {
                this._images.push(build);
                build.visible = false;
                this._inMap.removeChild(build);
            }
            if (sub != null) {
                this._images.push(sub);
                sub.visible = false;
            }
        }
        get panelMap() {
            return this._panelMap;
        }
        SetShowPoint(x, y, posX, posY) {
            this._showX = x;
            this._showY = y;
            this._posX = posX;
            this._posY = posY;
            this.CalculationShowRangeX();
            this.CalculationShowRangeY();
        }
        ShowPoint() {
            for (let i = this._showDataCoordinate.startX; i < this._showDataCoordinate.endX + 1; i++) {
                var showArea = [];
                for (let j = this._showDataCoordinate.startY; j < this._showDataCoordinate.endY + 1; j++) {
                    showArea.push(this.ShowLandImag(i, j));
                }
                this._showArea.push(showArea);
            }
            this.MoveMapReachPos(this._posX, this._posY, this._showX, this._showY);
            this.BuildIn();
        }
        MoveMapReachPos(x, y, dataX, dataY) {
            var scenePosTMapPos = this.ScreenPosTMapPos(x, y);
            var dataPosTMapPos = this.DataPosTMapPos(dataX, dataY);
            var mapPos = [scenePosTMapPos.x - dataPosTMapPos.x, scenePosTMapPos.y - dataPosTMapPos.y];
            this._panelMap.x += mapPos[0];
            this._panelMap.y += mapPos[1];
        }
        ShowLandImag(x, y) {
            let mapinfo = this._mapData.readMap(x, y);
            let posx = y * 90 + 45;
            let posy = x * 90 + 45;
            let landImg = this.GetImage();
            this._landMap.addChild(landImg);
            landImg.pos(posx, posy);
            landImg.rotation = 90 * mapinfo.landRot;
            this.SetMapSkin(landImg, null, mapinfo.landBlock, null);
            landImg.name = x + "_" + y;
            return landImg;
        }
        ShowInImag(x, y) {
            let mapinfo = this._mapData.readMap(x, y);
            let posx = y * 90 + 45;
            let posy = x * 90 + 45;
            let inimg = this.GetImage();
            this._inMap.addChild(inimg);
            inimg.pos(posx, posy);
            inimg.rotation = 90 * mapinfo.inRot;
            this.SetMapSkin(null, inimg, null, mapinfo.inBlock);
            return inimg;
        }
        SetMapSkin(land, inimg, landskin, inSkin) {
            var skinS = this._mapData.GetImageSkin(landskin, inSkin);
            if (land != null) {
                land.skin = "map/" + skinS.landSkin + ".png";
                land.name = skinS.landSkin;
            }
            if (inimg != null) {
                this.SkinSelect(inimg, skinS.inSkin);
            }
        }
        SkinSelect(inImg, skin) {
            var skinName = skin.split("_")[0];
            inImg.name = skin;
            if (skinName == "at") {
                inImg.skin = "Atower/" + skin + ".png";
                let inimgn;
                if (inImg.numChildren > 0) {
                    inimgn = inImg.getChildAt(0);
                }
                else {
                    inimgn = this.GetImage();
                    inImg.addChild(inimgn);
                    inimgn.pos(45, 45);
                }
                inimgn.skin = "Atower/" + skin + "_B.png";
            }
            else {
                inImg.skin = "build/" + skin + ".png";
            }
        }
        CalculationShowRangeY() {
            var posx = this._posX;
            var startY, endY;
            var offx1 = this._sceneWidth - posx + 45;
            var offx2 = posx + 45;
            var offcount1 = Math.floor(offx1 / 90);
            var offcount2 = Math.floor(offx2 / 90);
            startY = this._showY - offcount2;
            endY = this._showY + offcount1;
            startY = Math.max(0, startY);
            endY = Math.min(endY, this._numRows);
            this._showDataCoordinate.startY = startY;
            this._showDataCoordinate.endY = endY;
        }
        CalculationShowRangeX() {
            var posy = this._posY;
            var startX, endX;
            var offy1 = this._sceneHeight - posy + 45;
            var offy2 = posy + 45;
            var offcount1 = Math.floor(offy1 / 90);
            var offcount2 = Math.floor(offy2 / 90);
            startX = this._showX - offcount2;
            endX = this._showX + offcount1;
            startX = Math.max(0, startX);
            endX = Math.min(endX, this._numCols);
            this._showDataCoordinate.startX = startX;
            this._showDataCoordinate.endX = endX;
        }
        BlockClickEvent(x, y, roomIndex) {
            var mapPos = this.ScreenPosTMapPos(x, y);
            var dataPos = this.MapPosTDataPos(mapPos.x, mapPos.y);
            var blockType = this._mapData.RoomFindBlock(dataPos.x, dataPos.y);
            if (blockType.roomIndex != -1) {
                EventCenter.instance.Fire(EventCenter.instance.CLICK_BUILD, dataPos.x, dataPos.y, blockType.inSkin, blockType.roomIndex);
            }
            else {
                EventCenter.instance.Fire(EventCenter.instance.HIDE_MENU);
            }
        }
        ScreenPosTMapPos(x, y) {
            var mapx = x - this._panelMap.x;
            var mapy = y - this._panelMap.y;
            return { x: mapx, y: mapy };
        }
        MapPosTScreenPos(x, y) {
            var screenx = x + this._panelMap.x;
            var screeny = y + this._panelMap.y;
            return { x: screenx, y: screeny };
        }
        MapPosTDataPos(x, y) {
            var datax = Math.floor(y / this._mapW);
            var datay = Math.floor(x / this._mapW);
            return { x: datax, y: datay };
        }
        DataPosTMapPos(x, y) {
            var mapx = y * this._mapW + 45;
            var mapy = x * this._mapW + 45;
            return { x: mapx, y: mapy };
        }
        MoveMap(x, y) {
            if (x == 0 && y == 0) {
                return;
            }
            if (x > 0) {
                if (this._panelMap.x < -80) {
                    this._panelMap.x += x;
                }
                else {
                    x = 0;
                }
            }
            else {
                if (this._panelMap.x > -(this._panelMap.width - this._sceneWidth - 80)) {
                    this._panelMap.x += x;
                }
                else {
                    x = 0;
                }
            }
            if (y > 0) {
                if (this._panelMap.y < -80) {
                    this._panelMap.y += y;
                }
                else {
                    y = 0;
                }
            }
            else {
                if (this._panelMap.y > -(this._panelMap.height - this._sceneHeight - 80)) {
                    this._panelMap.y += y;
                }
                else {
                    y = 0;
                }
            }
            if (x == 0 && y == 0) {
                return;
            }
            this.VisibleCoordinateTraversal();
        }
        VisibleCoordinateTraversal() {
            if (this._resShowMap) {
                return;
            }
            var mapPos = this.DataPosTMapPos(this._showDataCoordinate.startX, this._showDataCoordinate.startY);
            var screenPos = this.MapPosTScreenPos(mapPos.x, mapPos.y);
            var dataOff = this.DetectionDisplayArea(screenPos.x, screenPos.y);
            if (dataOff.dataX == 0 && dataOff.dataY == 0) {
                return;
            }
            this._resShowMap = true;
            this.RecyclingResourcesOutsideTheArea(dataOff.dataX, dataOff.dataY);
            this.ShowDisplayableArea();
            this.InMapOptimization();
        }
        InMapOptimization() {
            if (this._inMap.numChildren > 0) {
                for (let i = 0; i < this._inMap.numChildren; i++) {
                    this.ImgShowOrHide(this._inMap.getChildAt(i));
                }
            }
        }
        ImgShowOrHide(img) {
            let name = img.name.split("_")[0];
            if (!this.IsScreenRange(img.x, img.y)) {
                if (name == "bed" || name == "mine") {
                    img.visible = false;
                }
            }
            else {
                img.visible = true;
            }
        }
        IsScreenRange(x, y) {
            let dataPos = this.MapPosTDataPos(x, y);
            return dataPos.x >= this._showDataCoordinate.startX && dataPos.x <= this._showDataCoordinate.endX && dataPos.y >= this._showDataCoordinate.startY && dataPos.y <= this._showDataCoordinate.endY;
        }
        DetectionDisplayArea(x, y) {
            var offx = 0, offy = 0;
            if (x > 40) {
                offx = -1;
            }
            else if (x < -80) {
                offx = 1;
            }
            if (y > 40) {
                offy = -1;
            }
            else if (y < -80) {
                offy = 1;
            }
            return { dataX: offy, dataY: offx };
        }
        RecyclingResourcesOutsideTheArea(dataX, dataY) {
            var arrx = null;
            if (dataX > 0) {
                arrx = this._showArea.shift();
                this._showArea.push(arrx);
            }
            else if (dataX < 0) {
                arrx = this._showArea.pop();
                this._showArea.unshift(arrx);
            }
            if (arrx != null) {
                for (let i = 0; i < arrx.length; i++) {
                    var img = arrx[i];
                    this._images.push(img);
                    arrx[i] = null;
                }
            }
            if (dataY > 0) {
                for (let i = 0; i < this._showArea.length; i++) {
                    for (let j = 0; j < this._showArea[i].length; j++) {
                        var img = this._showArea[i][j];
                        if (img == null) {
                            break;
                        }
                        if (j == 0) {
                            this._images.push(img);
                        }
                        else {
                            this._showArea[i][j - 1] = img;
                            if (j == this._showArea[i].length - 1) {
                                this._showArea[i][j] = null;
                            }
                        }
                    }
                }
            }
            else if (dataY < 0) {
                for (let i = 0; i < this._showArea.length; i++) {
                    for (let j = this._showArea[i].length - 1; j >= 0; j--) {
                        var img = this._showArea[i][j];
                        if (img == null) {
                            break;
                        }
                        if (j == this._showArea[i].length - 1) {
                            this._images.push(img);
                        }
                        else {
                            this._showArea[i][j + 1] = img;
                            if (j == 0) {
                                this._showArea[i][j] = null;
                            }
                        }
                    }
                }
            }
            this._showDataCoordinate.startX += dataX;
            this._showDataCoordinate.endX += dataX;
            this._showDataCoordinate.startY += dataY;
            this._showDataCoordinate.endY += dataY;
        }
        ShowDisplayableArea() {
            for (let i = this._showDataCoordinate.startX; i < this._showDataCoordinate.endX + 1; i++) {
                for (let j = this._showDataCoordinate.startY; j < this._showDataCoordinate.endY + 1; j++) {
                    var img = this._showArea[i - this._showDataCoordinate.startX][j - this._showDataCoordinate.startY];
                    if (img == null) {
                        img = this.ShowLandImag(i, j);
                        this._showArea[i - this._showDataCoordinate.startX][j - this._showDataCoordinate.startY] = img;
                    }
                }
            }
            this._resShowMap = false;
        }
        BuildIn() {
            var build = this._mapData.build;
            if (build.length <= 0) {
                return;
            }
            var buildarr = new Array();
            for (let i = 0; i < build.length; i++) {
                let pos = build[i];
                let roomIndex = this._mapData.BlockFindRoom(pos.x, pos.y);
                buildarr.push({
                    pos: pos.x + "_" + pos.y,
                    build: this.ShowInImag(pos.x, pos.y),
                    roomIndex: roomIndex
                });
            }
            EventCenter.instance.Fire(EventCenter.instance.COLLECTIVE_BUILD, buildarr);
        }
        NewBuild(x, y, buildType) {
            this._mapData.SetMap(x, y, buildType);
            let build = this.ShowInImag(x, y);
            let roomIndex = this._mapData.BlockFindRoom(x, y);
            EventCenter.instance.Fire(EventCenter.instance.BUILD_NEW, x + "_" + y, build, roomIndex);
            EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.buildDownEffect, build.x, build.y);
            this.ImgShowOrHide(build);
        }
        BuildUp(build, buildType) {
            this.SkinSelect(build, buildType);
        }
        BuildDismantle(build, x, y) {
            if (build != null) {
                this._inMap.removeChild(build);
                build.visible = false;
                if (build.numChildren > 0) {
                    for (let i = build.numChildren - 1; i >= 0; i--) {
                        let img = build.getChildAt(i);
                        img.visible = false;
                        build.removeChild(img);
                        this._images.push(img);
                    }
                }
            }
            let pos = this.MapPosTDataPos(x, y);
            this._mapData.SetMap(pos.x, pos.y, "");
        }
        SetBuildMenuPos(x, y, head) {
            let mapPos = this.DataPosTMapPos(x, y);
            let screenPos = this.MapPosTScreenPos(mapPos.x, mapPos.y);
            head.pos(screenPos.x, screenPos.y);
            EventCenter.instance.Fire(EventCenter.instance.SHOW_MENU);
        }
        ReturnDistance(start, troll) {
            let startx = start.x;
            let starty = start.y;
            let disx = Math.abs(startx - troll.x);
            let disy = Math.abs(starty - troll.y);
            let dis = disx * disx + disy * disy;
            return dis;
        }
        AddAtivity(node, x, y) {
            this._activityMap.addChild(node);
            let mapPos = this.DataPosTMapPos(x, y);
            node.pos(mapPos.x, mapPos.y);
        }
        GetActivityMap() {
            return this._activityMap;
        }
        GetPathMapPos(path) {
            if (!path) {
                return null;
            }
            let pos = [];
            for (let i = 1; i < path.length; i++) {
                let node = path[i];
                let mapPos = this.DataPosTMapPos(node.x, node.y);
                pos.push([mapPos.x, mapPos.y]);
            }
            return pos;
        }
        GameOver() {
            this._showArea.length = 0;
            this._showDataCoordinate = { startX: -1, startY: -1, endX: -1, endY: -1 };
            this.ClearMap();
            this.SelfTest();
            this.ClearRoomblack();
        }
        SelfTest() {
            if (this._images.length > 0) {
                for (let i = this._images.length - 1; i >= 0; i--) {
                    let img = this._images[i];
                    for (let j = i - 1; j >= 0; j--) {
                        let img2 = this._images[j];
                        if (img == img2) {
                            this._images.splice(j, 1);
                        }
                    }
                }
            }
        }
        RoomBlack(buildPoss) {
            if (buildPoss.length > 0) {
                for (let i = 0; i < buildPoss.length; i++) {
                    let pos = buildPoss[i];
                    let img = this.GetImage();
                    this._activityMap.addChild(img);
                    img.pos(pos.x, pos.y);
                    img.skin = "UI/zhezhao.png";
                    img.alpha = 0;
                    this._blackArr.push(img);
                    EffectTween.instance.Alpha(img, 1, 1);
                }
            }
        }
        ClearRoomblack() {
            if (this._blackArr.length > 0) {
                for (let i = 0; i < this._blackArr.length; i++) {
                    let img = this._blackArr[i];
                    img.removeSelf();
                    img.visible = false;
                    this._images.push(img);
                }
                this._blackArr = [];
            }
        }
        get MapPanelMaxPos() {
            let x = this._panelMap.width - 80;
            let y = this._panelMap.height - 80;
            return { x: x, y: y };
        }
    }

    class MapData {
        constructor() {
            this._index = null;
            this._maps = {
                map0: [
                    ["9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "6_3_0_0", "0_0_0_0", "6_3_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "0_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "5_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_1_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_1_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_2_3", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "1_0_2_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_1_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "1_0_2_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "1_0_2_2", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "2_0_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "4_2_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "3_2_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_1_0", "3_2_0_0", "2_2_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "3_2_0_0", "1_0_2_2", "2_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "2_0_0_0", "3_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_1_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_1_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "7_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "5_0_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "1_0_2_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "4_0_0_0", "4_0_0_0"],
                    ["4_2_0_0", "4_2_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0"],
                    ["4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "4_0_0_0", "4_0_0_0"],
                    ["4_2_0_0", "4_2_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "1_0_2_2", "6_3_0_0", "3_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "1_0_2_2", "3_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "5_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "4_0_0_0", "4_2_0_0", "1_0_1_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "1_0_2_1", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "4_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_1_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "4_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_1_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "4_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "7_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "7_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "3_2_0_0", "2_2_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "5_0_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "2_0_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "6_3_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "1_0_2_2", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_1_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_1_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "3_2_0_0", "7_0_0_0", "1_0_0_0", "1_0_0_0", "2_0_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "3_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_1_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "3_2_0_0", "3_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "2_0_0_0", "2_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_2_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "1_0_0_0", "4_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "1_0_2_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "1_0_2_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "4_2_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "0_0_0_0", "4_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "3_2_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "0_0_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "2_2_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "6_1_0_0", "0_0_0_0", "6_1_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0"],
                    ["9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "6_1_0_0", "6_1_0_0", "6_1_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0", "9_0_0_0"],
                ],
            };
            this._gameMapData = new Array();
            this._rooms = new Array();
            this._build = new Array();
            this._landSkin = ["floor_1", "floor_2", "wall_1", "wall_2", "wall_3", "wall_4", "wall_5", "wall_6", "empty_1", "HSZZ0_1"];
            this._inSkin = ["", "bed_1", "door_1", "repair_1", "game_1", "at_1", "ice_1", "barb_1", "particlea_1", "spell_1", "entrapment_1", "guillotine_1", "energyhood_1", "smoney_1", "longrange_1", "solenoid_1", "mine_1", "mine_2", "mine_3", "mine_4"];
        }
        SelectMap(index) {
            this._index = index;
            this._map = this._maps["map" + index];
            if (this._map == undefined) {
                this._index = null;
                return false;
            }
            else {
                this.MapConversion();
                return true;
            }
        }
        IsWalkable(x, y) {
            let mapinfo = this.readMap(x, y);
            let mapi = this._landSkin[mapinfo.landBlock];
            let s = mapi.split("_")[0];
            if (s == "floor") {
                return true;
            }
            return false;
        }
        GetMapColsOrRows() {
            if (this._index != null) {
                this._numClos = this._map.length;
                this._numRows = this._map[0].length;
                return [this._numClos, this._numRows];
            }
            else {
                return null;
            }
        }
        readMap(x, y) {
            let mapInfo = this._gameMapData[x][y];
            return mapInfo;
        }
        SetMap(x, y, buildType) {
            if (buildType.length == 0) {
                this.readMap(x, y).inBlock = 0;
            }
            else {
                for (let i = 0; i < this._inSkin.length; i++) {
                    if (buildType == this._inSkin[i]) {
                        this.readMap(x, y).inBlock = i;
                        return;
                    }
                }
            }
        }
        GetImageSkin(land, inS) {
            var landSkin = this._landSkin[land];
            var inSkin = this._inSkin[inS];
            if (landSkin == undefined) {
                landSkin = "";
            }
            if (inSkin == undefined) {
                inSkin = "";
            }
            return { landSkin: landSkin, inSkin: inSkin };
        }
        MapConversion() {
            for (let i = 0; i < this._map.length; i++) {
                var mapinfos = new Array();
                for (let j = 0; j < this._map[i].length; j++) {
                    let mapInfo = this._map[i][j];
                    let mapinfoArr = mapInfo.split("_");
                    let mapInfoT = {
                        landBlock: parseInt(mapinfoArr[0]),
                        landRot: parseInt(mapinfoArr[1]),
                        inBlock: parseInt(mapinfoArr[2]),
                        inRot: parseInt(mapinfoArr[3])
                    };
                    mapinfos.push(mapInfoT);
                    let inbuild = this._inSkin[mapInfoT.inBlock].split("_")[0];
                    if (inbuild == "bed") {
                        this._rooms.push({
                            pos: i + "_" + j,
                            door: "",
                            room: []
                        });
                    }
                    if (inbuild != "") {
                        this._build.push({ x: i, y: j });
                    }
                }
                this._gameMapData.push(mapinfos);
            }
            this.SearchRooms();
        }
        SearchRooms() {
            for (let i = 0; i < this._rooms.length; i++) {
                var listRoom = [];
                var listClose = [];
                let pos = this._rooms[i];
                let posarr = pos.pos.split("_");
                this.SearchRoom(parseInt(posarr[0]), parseInt(posarr[1]), listRoom, listClose);
                pos.room = listRoom;
                pos.door = listRoom[0];
            }
        }
        SearchRoom(x, y, listRoom, listClose) {
            var pos = x + "_" + y;
            if (this.SearchArray(pos, listRoom) || this.SearchArray(pos, listClose)) {
                return;
            }
            let mapInfo = this.readMap(x, y);
            let landSkin = this._landSkin[mapInfo.landBlock].split("_")[0];
            let inSkin = this._inSkin[mapInfo.inBlock].split("_")[0];
            if (landSkin == "floor") {
                if (inSkin == "door") {
                    listRoom.unshift(pos);
                    return;
                }
                listRoom.push(pos);
                this.SearchRoom(x + 1, y, listRoom, listClose);
                this.SearchRoom(x - 1, y, listRoom, listClose);
                this.SearchRoom(x, y + 1, listRoom, listClose);
                this.SearchRoom(x, y - 1, listRoom, listClose);
            }
            else {
                listClose.push(pos);
                return;
            }
        }
        SearchArray(pos, arr) {
            if (arr.length != 0) {
                for (let i = 0; i < arr.length; i++) {
                    if (pos == arr[i]) {
                        return true;
                    }
                }
            }
            return false;
        }
        RoomFindBlock(x, y) {
            let mapinfo = this.readMap(x, y);
            let landSkin = this._landSkin[mapinfo.landBlock].split("_")[0];
            let inSkin = this._inSkin[mapinfo.inBlock].split("_")[0];
            if (landSkin != "floor") {
                return { inSkin: inSkin, roomIndex: -1 };
            }
            else {
                return { inSkin: inSkin, roomIndex: this.BlockFindRoom(x, y) };
            }
        }
        BlockFindRoom(x, y) {
            let mapinfo = this.readMap(x, y);
            let landSkin = this._landSkin[mapinfo.landBlock].split("_")[0];
            if (landSkin != "floor") {
                return -1;
            }
            else {
                for (let i = 0; i < this._rooms.length; i++) {
                    let room = this._rooms[i];
                    let pos = x + "_" + y;
                    if (this.BlockIsRoom(room.room, pos)) {
                        return i;
                    }
                }
                return -1;
            }
        }
        BlockIsRoom(room, pos) {
            for (let i = 0; i < room.length; i++) {
                if (room[i] == pos) {
                    return true;
                }
            }
            return false;
        }
        get build() {
            return this._build;
        }
        GetDoorFloor(roomIndex) {
            let room = this._rooms[roomIndex];
            let door = room.door.split("_");
            let up = this.readMap(parseInt(door[0]), parseInt(door[1]) + 1);
            let left = this.readMap(parseInt(door[0]) + 1, parseInt(door[1]));
            let down = this.readMap(parseInt(door[0]), parseInt(door[1]) - 1);
            let right = this.readMap(parseInt(door[0]) - 1, parseInt(door[1]));
            if (this.DoorAroundBlock(up, room.room, parseInt(door[0]) + "_" + (parseInt(door[1]) + 1))) {
                return [parseInt(door[0]), parseInt(door[1]) + 1];
            }
            else if (this.DoorAroundBlock(left, room.room, (parseInt(door[0]) + 1) + "_" + parseInt(door[1]))) {
                return [parseInt(door[0]) + 1, parseInt(door[1])];
            }
            else if (this.DoorAroundBlock(down, room.room, parseInt(door[0]) + "_" + (parseInt(door[1]) - 1))) {
                return [parseInt(door[0]), parseInt(door[1]) - 1];
            }
            else if (this.DoorAroundBlock(right, room.room, (parseInt(door[0]) - 1) + "_" + parseInt(door[1]))) {
                return [parseInt(door[0]) - 1, parseInt(door[1])];
            }
        }
        DoorAroundBlock(info, room, pos) {
            if (info.landBlock != 0) {
                if (info.inBlock == 0) {
                    return false;
                }
            }
            return !this.BlockIsRoom(room, pos);
        }
        GetAroundBuild(x, y, range) {
            let r = range * 90;
            r *= r;
            let listBuild = [];
            let listClose = [];
            this.AroundBuild(x, y, listBuild, listClose, r);
            return listBuild;
        }
        AroundBuild(x, y, listBuild, listClose, range) {
            if (this.SearchArrayAround(x, y, listBuild) || this.SearchArrayAround(x, y, listClose)) {
                return;
            }
            let r = x * x + y * y;
            if (r > range) {
                listClose.push([x, y]);
                return;
            }
            if (this.PosIsBuild(x, y)) {
                listBuild.push([x, y]);
                this.AroundBuild(x, y + 1, listBuild, listClose, range);
                this.AroundBuild(x, y - 1, listBuild, listClose, range);
                this.AroundBuild(x + 1, y, listBuild, listClose, range);
                this.AroundBuild(x - 1, y, listBuild, listClose, range);
            }
            else {
                listClose.push([x, y]);
            }
        }
        SearchArrayAround(x, y, array) {
            if (array.length > 0) {
                for (let i = 0; i < array.length; i++) {
                    let pos = array[i];
                    if (pos[0] == x && pos[1] == y) {
                        return true;
                    }
                }
            }
            return false;
        }
        PosIsBuild(x, y) {
            let mapInfo = this.readMap(x, y);
            if (mapInfo.inBlock == 0) {
                return false;
            }
            else {
                return true;
            }
        }
        GetRoomCount() {
            return this._rooms.length;
        }
        GetOpenSpace(roomIndex, isAt) {
            let room = this._rooms[roomIndex];
            let posarr = [];
            for (let i = 0; i < room.room.length; i++) {
                let blockPos = room.room[i].split("_");
                let x = parseInt(blockPos[0]);
                let y = parseInt(blockPos[1]);
                let blockInfo = this.readMap(x, y);
                if (blockInfo.inBlock == 0) {
                    posarr.push({ x: x, y: y });
                }
            }
            if (posarr.length == 0) {
                return null;
            }
            else {
                let pos = null;
                if (isAt) {
                    let doorStrArr = this._rooms[roomIndex].door.split("_");
                    let doorPos = { x: parseInt(doorStrArr[0]), y: parseInt(doorStrArr[1]) };
                    pos = posarr[0];
                    for (let index = 1; index < posarr.length; index++) {
                        let pos1 = posarr[index];
                        let x1 = Math.abs(pos.x - doorPos.x);
                        let y1 = Math.abs(pos.y - doorPos.y);
                        let x2 = Math.abs(pos1.x - doorPos.x);
                        let y2 = Math.abs(pos1.y - doorPos.y);
                        if ((x1 * x1 + y1 * y1) > (x2 * x2 + y2 * y2)) {
                            pos = pos1;
                        }
                    }
                }
                else {
                    let ran = Math.floor(Math.random() * posarr.length);
                    pos = posarr[ran];
                }
                return pos;
            }
        }
        FindPlayerAround(x, y) {
            let startX = Math.max(x - 1, 0);
            let startY = Math.max(y - 1, 0);
            let endX = Math.min(x + 1, this._numClos);
            let endY = Math.min(y + 1, this._numRows);
            let arr = [];
            for (let x = startX; x <= endX; x++) {
                for (let y = startY; y <= endY; y++) {
                    let build = this.FindPlayerAroundDoorOrBed(x, y);
                    if (build != null) {
                        arr.push(build);
                    }
                }
            }
            if (arr.length == 0) {
                return null;
            }
            else if (arr.length == 1) {
                return arr[0];
            }
            else {
                let b1 = arr[0];
                for (let i = 1; i < arr.length; i++) {
                    let b2 = arr[i];
                    let a = this.Distance(b1.x, b1.y, x, y);
                    let b = this.Distance(b2.x, b2.y, x, y);
                    if (a > b) {
                        b1 = b2;
                    }
                }
                return b1;
            }
        }
        Distance(x1, y1, x2, y2) {
            let x = x1 - x2;
            let y = y1 - y2;
            return x * x + y * y;
        }
        FindPlayerAroundDoorOrBed(x, y) {
            let a = this.readMap(x, y);
            let s = this._inSkin[a.inBlock].split("_")[0];
            if (s == "door") {
                return { build: "door", x: x, y: y };
            }
            else if (s == "bed") {
                return { build: "bed", x: x, y: y };
            }
            return null;
        }
        GetRoom(roomIndex) {
            return this._rooms[roomIndex];
        }
        GameOver() {
            this._gameMapData = new Array();
            this._rooms = new Array();
            this._build = new Array();
            this._index = null;
            this._map = undefined;
        }
        GetPosAroundBuild(x, y, build, r) {
            let builds = new Array();
            let startx = Math.max(0, x - r);
            let starty = Math.max(0, y - r);
            let endx = Math.min(this._numClos, x + r);
            let endy = Math.min(this._numRows, y + r);
            for (let x = startx; x < endx; x++) {
                for (let y = starty; y < endy; y++) {
                    let mapInfo = this.readMap(x, y);
                    let inSkin = this._inSkin[mapInfo.inBlock].split("_")[0];
                    if (inSkin == build) {
                        let pos = x + "_" + y;
                        builds.push(pos);
                    }
                }
            }
            return builds;
        }
    }

    class GGAPI {
        constructor() {
            this._screenWidth = 0;
            this._screenHeight = 0;
            this._ppH = 630 / 1920;
            this._ppL = 300 / 1920;
            this._gg = Laya.Browser.window.qg;
            this._voide = null;
            this._voideID = "2a8b08b5ae1e46e887297fccf3c12945";
            this._boxBanner = null;
            this._boxBannerID = "e57091eba7984c96a4f2a864e2f08a85";
            this._interstitialID = "26dfd2c6bb1347ba86777c53d1786b57";
            this._custom = null;
            this._customIDH = "41571984c8594d2699e94cabab549488";
            this._customIDL = "1272acabe13d4a0f943a38277f26ee9d";
            this._banner = null;
            this._bannerID = "";
            this._advFunc = {
                success: null,
                fail: null
            };
            this.GetScreenInfo();
            this.CreateADV();
            this.CreateBoxBannerAd();
        }
        CreateADV() {
            this._voide = this._gg.createRewardedVideoAd({
                posId: this._voideID
            });
            this._voide.onLoad(() => {
                console.log("视频加载成功");
            });
            this._voide.onError((res) => {
                console.log("视频加载错误:", "1.错误信息——", res.errMsg, "2.错误码——", res.errCode);
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "视频加载失败，请稍后再试");
            });
            this._voide.onClose((res) => {
                if (res.isEnded) {
                    if (this._advFunc.success != null) {
                        this._advFunc.success();
                    }
                }
                else {
                    if (this._advFunc.fail != null) {
                        this._advFunc.fail();
                    }
                }
            });
        }
        ShowAdv(value) {
            this._advFunc = value;
            this._voide.show().catch(() => {
                this._voide.load()
                    .then(() => this._voide.show())
                    .catch(err => {
                    console.log('激励视频 广告显示失败');
                });
            });
        }
        CreateBoxBannerAd() {
            if (this._gg.createBoxBannerAd) {
                this._boxBanner = this._gg.createBoxBannerAd({
                    posId: this._boxBannerID
                });
                this._boxBanner.onLoad(() => {
                    console.log("加载成功 横幅盒子广告");
                });
            }
        }
        BoxBannerShow() {
            this._boxBanner.show().then(function () {
                console.log('show success BoxBanner');
            }).catch(function (error) {
                console.log('show fail with BoxBanner:' + error.errCode + ',' + error.errMsg);
            });
        }
        BoxBannerHide() {
            this._boxBanner.hide().then(function () {
                console.log('hide success BoxBanner');
            }).catch(function (error) {
                console.log('hide fail with BoxBanner:' + error.errCode + ',' + error.errMsg);
            });
        }
        InterstitialAdShow() {
            let interstitial = this._gg.createInterstitialAd({
                posId: this._interstitialID
            });
            interstitial.show().then(() => {
                console.log('插屏广告展示完成');
            }).catch((err) => {
                console.log('插屏广告展示失败', JSON.stringify(err));
            });
        }
        CustomAdShow(pp) {
            if (this._gg.createCustomAd) {
                let id = "";
                let mod = this.HandlePP(pp);
                switch (mod) {
                    case -1: return;
                    case 0:
                        id = this._customIDH;
                        break;
                    case 1:
                        id = this._customIDL;
                        break;
                }
                this._custom = this._gg.createCustomAd({
                    adUnitId: id,
                    style: {}
                });
                this._custom.show();
            }
        }
        HandlePP(pp) {
            let mod = -1;
            if (pp >= this._ppH) {
                mod = 0;
            }
            else if (pp >= this._ppL) {
                mod = 1;
            }
            return mod;
        }
        CustomAdHide() {
            if (this._custom && this._custom.isShow()) {
                this._custom.hide();
            }
        }
        GetScreenInfo() {
            let screen = this._gg.getSystemInfoSync();
            this._screenWidth = screen.screenWidth;
            this._screenHeight = screen.screenHeight;
            console.log("screen", screen);
        }
        GameExit() {
            this._gg.exitApplication();
        }
    }

    class ADV {
        constructor() {
            this._browserOn = false;
            if (this._browserOn) {
                this._gg = new GGAPI();
            }
        }
        static get instance() {
            return this._instance;
        }
        ShowADV(value) {
            if (this._browserOn) {
                this._gg.ShowAdv(value);
            }
            else {
                value.success && value.success();
            }
        }
        CustomAdShow(height) {
            if (this._browserOn) {
                this._gg.CustomAdShow(height);
            }
        }
        CustomAdHide() {
            if (this._browserOn) {
                this._gg.CustomAdHide();
            }
        }
        BoxBannerShow() {
            if (this._browserOn) {
                this._gg.BoxBannerShow();
            }
        }
        BoxBannerHied() {
            if (this._browserOn) {
                this._gg.BoxBannerHide();
            }
        }
        InterstitialAdShow() {
            if (this._browserOn) {
                this._gg.InterstitialAdShow();
            }
        }
        GameExit() {
            if (this._browserOn) {
                this._gg.GameExit();
            }
        }
    }
    ADV._instance = new ADV();

    class TaskLogic {
        AddUpEvent() {
            TimeManager.instance.AddTimeLoopEvent("UpTask", this.UpTask, this, 0.1);
        }
        RemoveUpEvent() {
            TimeManager.instance.RemoveListLoopEvent("UpTask");
        }
        UpTask() {
            if (this._player && this._player.bed) {
                this.taskFunc && this.taskFunc();
            }
        }
        Task1() {
            if (this._player.bed != null) {
                this.room = this._player.bed.room;
                this.TaskCompelet();
            }
        }
        Task2() {
            if (this._player.bed.level >= 2) {
                this.TaskCompelet();
            }
        }
        Task3() {
            if (this.room.door.level >= 2) {
                this.TaskCompelet();
            }
        }
        Task4() {
            if (this.room.bed.level >= 3) {
                this.TaskCompelet();
            }
        }
        Task5() {
            if (this.room.bed.level >= 4) {
                this.TaskCompelet();
            }
        }
        Task6() {
            let count = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_GET_AT_BUILDCOUNT, this._player.roomIndex);
            if (count > 1) {
                this.TaskCompelet();
            }
        }
        Task7() {
            if (this.room.bed.level >= 5) {
                this.TaskCompelet();
            }
        }
        Task8() {
            let count = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_GET_GAME_BUILDCOUNT, this._player.roomIndex);
            if (count > 1) {
                this.TaskCompelet();
            }
        }
        Task9() {
            if (this.room.bed.level >= 7) {
                this.TaskCompelet();
            }
        }
        Task10() {
            let c = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_REACHC, "at_5", this._player.roomIndex);
            if (c) {
                this.TaskCompelet();
            }
        }
        Task11() {
            let c = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_REACHC, "mine_1", this._player.roomIndex);
            if (c) {
                this.TaskCompelet();
            }
        }
        set task(value) {
            switch (value) {
                case 0:
                    this.taskFunc = this.Task1;
                    break;
                case 1:
                    this.taskFunc = this.Task2;
                    break;
                case 2:
                    this.taskFunc = this.Task3;
                    break;
                case 3:
                    this.taskFunc = this.Task4;
                    break;
                case 4:
                    this.taskFunc = this.Task5;
                    break;
                case 5:
                    this.taskFunc = this.Task6;
                    break;
                case 6:
                    this.taskFunc = this.Task7;
                    break;
                case 7:
                    this.taskFunc = this.Task8;
                    break;
                case 8:
                    this.taskFunc = this.Task9;
                    break;
                case 9:
                    this.taskFunc = this.Task10;
                    break;
                case 10:
                    this.taskFunc = this.Task11;
                    break;
                default:
                    this.taskFunc = null;
                    break;
            }
        }
        TaskCompelet() {
            EventCenter.instance.Fire(EventCenter.instance.BATTLEUI_TASKCOMPLETE);
            this.taskFunc = null;
        }
        set player(value) {
            this._player = value;
        }
    }

    class UIBase {
        constructor() {
            this._zOrder = 0;
        }
        LoadPanel(isShow = false) {
            let info = Laya.loader.getRes(this._path);
            this.panel = new Laya.View();
            this.panel.createView(info);
            if (isShow) {
                this.scene.addChild(this.panel);
            }
            this.panel.zOrder = this._zOrder;
            this.ReadUIInfo();
        }
        Init() { }
        ReadUIInfo() { }
        set path(value) {
            this._path = value;
        }
        get path_Str() {
            return this._path;
        }
        set zOrder(value) {
            this._zOrder = value;
        }
        get scene() {
            if (UIBase.scene == null) {
                UIBase.scene = Laya.stage.getChildAt(0).getChildAt(0);
            }
            return UIBase.scene;
        }
        AddUpData() {
        }
        Show(...param) {
            this.scene.addChild(this.panel);
            this._Show(...param);
        }
        Hide(...param) {
            this.scene.removeChild(this.panel);
            this._Hide(...param);
        }
        _Show(...param) { }
        _Hide(...param) { }
    }
    UIBase.strArr = {
        battleUI: "battleUI",
        startGameUI: "startGameUI",
        gameOverUI: "gameOverUI",
        macthingUI: "macthingUI",
        skillUI: "skillUI",
        shopUI: "shopUI",
        treasureChestUI: "treasureChestUI"
    };

    class BattleUI extends UIBase {
        constructor() {
            super();
            this.timernum = 30;
            this.taskIndex = 0;
            this.path = "Prefabs/BattleUI.json";
            this.zOrder = 3;
        }
        ReadUIInfo() {
            this.gold1 = this.panel.getChildByName("Gold1");
            this.gold2 = this.panel.getChildByName("Gold2");
            this.gold3 = this.panel.getChildByName("Gold3");
            this.timepanel = this.panel.getChildByName("timePanel");
            this.timer = this.timepanel.getChildByName("timer");
            this.head = this.panel.getChildByName("head");
            this.backBtn = this.panel.getChildByName("back");
            this.backPanel = this.panel.getChildByName("BattleBackUI");
            this.cGame = this.backPanel.getChildByName("cGame");
            this.rGame = this.backPanel.getChildByName("rGame");
            this.backPanel.width = this.scene.width;
            this.backPanel.height = this.scene.height;
            this.backPanel.visible = false;
            this.backBtn.on(Laya.Event.CLICK, this, this.BackBtnClickEvent);
            this.cGame.on(Laya.Event.CLICK, this, this.CGameClickEvent);
            this.rGame.on(Laya.Event.CLICK, this, this.RGameClickEvent);
            let arr = [this.cGame, this.rGame, this.backBtn];
            EffectTween.instance.AddBtnEvent(arr);
        }
        Init() {
            this.gold1.text = "0";
            this.gold2.text = "0";
            this.timernum = 30;
            this.timer.text = this.timernum.toString();
            this.timepanel.visible = true;
            this.HeadInit();
            this.TaskInit();
            TimeManager.instance.AddTimeLoopEvent("StartTimer", this.StartTimer, this, 1);
        }
        UpGold() {
            let roomIndex = PlayerManager.instance.player.roomIndex;
            let gold = DataManager.instance.game.GetRoomPR(roomIndex);
            if (gold == null) {
                return;
            }
            this.gold1.text = gold.gold1.toString();
            this.gold2.text = gold.gold2.toString();
        }
        AddUpData() {
            TimeManager.instance.AddTimeLoopEvent("UpGpld", this.UpGold, this, 0.25);
        }
        StartTimer() {
			let StartTime = Laya.LocalStorage.getItem("StartTimer");
            console.log("mod_js 加快猛鬼进场="+StartTime);
            if(StartTime==1){
                this.timernum-=5;
            }else{
				this.timernum--;
			} 
            this.timer.text = this.timernum.toString();
            if (this.timernum == 0) {
                TimeManager.instance.RemoveListLoopEvent("StartTimer");
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼进入了宿舍楼");
                Sound.instance.PlaySound(Sound.instance.Other_sound.ermt_0);
                this.timepanel.visible = false;
                EventCenter.instance.Fire(EventCenter.instance.MAINLG_TROLLUPDATA);
            }
            if (this.timernum < 10) {
                Sound.instance.PlaySound(Sound.instance.Other_sound.timer);
            }
        }
        HeadInit() {
            if (this.head.numChildren > 0) {
                let headarr = PlayerManager.instance.head;
                let arr = [];
                for (let i = 0; i < headarr.length; i++) {
                    let head = this.head.getChildAt(i);
                    let headImg = head.getChildByName("head");
                    let red = head.getChildByName("red");
                    red.alpha = 0;
                    let x = head.getChildByName("x");
                    x.visible = false;
                    let headSkin = headarr[i];
                    headImg.skin = "pipei/pGame_" + headSkin + ".png";
                    head.on(Laya.Event.CLICK, this, this.HeadClickEvent, [i]);
                    arr.push(head);
                }
                let head = this.head.getChildAt(headarr.length);
                let headImg = head.getChildByName("head");
                headImg.skin = "pipei/pGame_" + DataManager.instance.player.playerSelectIndex + ".png";
                head.on(Laya.Event.CLICK, this, this.HeadClickEvent, [headarr.length]);
                arr.push(head);
                EffectTween.instance.AddBtnEvent(arr);
            }
        }
        playerHit(index) {
            if (index < 0 || index > 5) {
                return;
            }
            let headImg = this.head.getChildAt(index);
            if (headImg) {
                let x = headImg.getChildByName("x");
                x.visible = true;
                x.scale(1.5, 1.5);
                x.alpha = 0;
                Laya.Tween.to(x, { scaleX: 1, scaleY: 1, alpha: 1 }, 300, null, null, 0, true);
            }
        }
        playerHitEffect(index) {
            if (index < 0 || index > 5) {
                return;
            }
            let headImg = this.head.getChildAt(index);
            if (headImg) {
                let red = headImg.getChildByName("red");
                let head = headImg.getChildByName("head");
                EffectTween.instance.Breathing(red, 0, 4);
                EffectTween.instance.ShakeHead(head, 0, 6);
            }
        }
        HeadClickEvent(index) {
            PlayerManager.instance.LookPos(index);
        }
        TaskInit() {
            if (DataManager.instance.player.DZCount < DataManager.instance.cdn.cdn.taskOpenCount) {
                if (!this.taskPanel) {
                    this.taskPanel = this.panel.getChildByName("task");
                    this.taskText = this.taskPanel.getChildByName("taskText");
                    this.taskBtn = this.taskPanel.getChildByName("taskBtn");
                    EventCenter.instance.AddListEvent(EventCenter.instance.BATTLEUI_TASKCOMPLETE, this.CompleteTask, this);
                    this.taskPanel.visible = true;
                }
                this.taskIndex = 0;
                this.tasklg.player = PlayerManager.instance.player;
                this.tasklg.task = this.taskIndex;
                this.tasklg.AddUpEvent();
                this.TaskPanel();
            }
            else {
                if (this.taskPanel) {
                    this.taskPanel.visible = false;
                }
            }
        }
        CompleteTask() {
            this.taskBtn.text = "领取";
            this.taskBtn.color = "#23af00";
            this.taskBtn.underlineColor = "#23af00";
            this.taskBtn.on(Laya.Event.CLICK, this, this.TaskBtnClickEvent);
        }
        TaskBtnClickEvent() {
            this.taskIndex++;
            this.TaskPanel();
            this.tasklg.task = this.taskIndex;
        }
        TaskPanel() {
            let taskText = DataManager.instance.task.GetTaskText(this.taskIndex);
            if (taskText) {
                if (this.taskIndex > DataManager.instance.player.taskIndex) {
                    DataManager.instance.player.taskIndex++;
                    DataManager.instance.player.gold += 5;
                    this.gold3.y = 225.5;
                    EffectTween.instance.Gold3Effwct(this.gold3);
                }
                this.taskText.text = taskText;
                this.taskBtn.text = "未完成";
                this.taskBtn.color = "#675a59";
                this.taskBtn.underlineColor = "#675a59";
                this.taskBtn.offAll();
            }
            else {
                this.TaskOver();
                this.tasklg.RemoveUpEvent();
            }
        }
        TaskOver() {
            this.taskPanel.visible = false;
            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "您以完成所有任务，请开始尽情体验游戏");
            DataManager.instance.player.taskOk = true;
        }
        get tasklg() {
            if (!this._tasklg || this._tasklg == null) {
                this._tasklg = new TaskLogic();
            }
            return this._tasklg;
        }
        BackBtnClickEvent() {
            this.backPanel.visible = true;
            this.panel.height = this.scene.height;
            ADV.instance.BoxBannerShow();
        }
        CGameClickEvent() {
            this.backPanel.visible = false;
            this.panel.height = 320;
            ADV.instance.BoxBannerHied();
        }
        RGameClickEvent() {
            EventCenter.instance.Fire(EventCenter.instance.GM_GAMEOVER, null);
            this.CGameClickEvent();
            ADV.instance.InterstitialAdShow();
        }
        _Show() {
            this.panel.height = 320;
            this.backPanel.visible = false;
        }
        _Hide() {
            this.panel.height = 320;
            let arr = [];
            for (let i = 0; i < this.head.numChildren; i++) {
                let head = this.head.getChildAt(i);
                arr.push(head);
            }
            EffectTween.instance.RemoveBtnEvent(arr);
        }
    }

    class GameOverUI extends UIBase {
        constructor() {
            super();
            this._timegold = 10;
            this._wingold = 10;
            this._killgold = 20;
            this.rewardGold = 10;
            this._rewardTimeMin = 210;
            this._rewardTimeMax = 330;
            this.path = "Prefabs/GameOverUI.json";
            this.zOrder = 10;
        }
        ReadUIInfo() {
            this.panel.width = this.scene.width;
            this.panel.height = this.scene.height;
            this.bg = this.panel.getChildByName("bg");
            this.bg.width = this.scene.width;
            this.bg.height = this.scene.height;
            this.redPanel = this.panel.getChildByName("red");
            this.redPanel.y = (this.scene.height - this.redPanel.height) / 2;
            this.rewardBtn_1 = this.redPanel.getChildByName("rewardBtn_1");
            this.rewardBtn_3 = this.redPanel.getChildByName("rewardBtn_3");
            this._advImg = this.rewardBtn_3.getChildByName("a");
            this._rtext = this.rewardBtn_3.getChildByName("t");
            this.loseImg = this.redPanel.getChildByName("loseImg");
            this.winImg = this.redPanel.getChildByName("winImg");
            this.win = this.redPanel.getChildByName("win");
            this.loser = this.redPanel.getChildByName("loser");
            this.mvp = this.redPanel.getChildByName("mvp");
            this.allGold = this.redPanel.getChildByName("gold");
            this.gg = this.redPanel.getChildByName("gg");
            this.tips = this.redPanel.getChildByName("ttt");
            this.win.visible = false;
            this.loser.visible = false;
            this.rewardBtn_1.on(Laya.Event.CLICK, this, this.RewardBtn_1_ClickEvent);
            this.rewardBtn_3.on(Laya.Event.CLICK, this, this.RewardBtn_3_ClickEvent);
            let arr = [this.rewardBtn_1, this.rewardBtn_3];
            EffectTween.instance.AddBtnEvent(arr);
        }
        StartGame() {
            EffectTween.instance.Shake(this.rewardBtn_1, 0.05);
            Laya.timer.once(100, this, function () {
                EventCenter.instance.FireReturn(EventCenter.instance.UIGM_SHOW, UIBase.strArr.shopUI);
                let s = EventCenter.instance.FireReturn(EventCenter.instance.UIGM_SHOW, UIBase.strArr.startGameUI);
                if (s) {
                    this.Hide();
                }
            });
        }
        _Show() {
            this.OpenTreasureChest();
            this.loser.visible = !DataManager.instance.game.isWin;
            this.win.visible = DataManager.instance.game.isWin;
            Sound.instance.PlaySound(Sound.instance.Other_sound.game_fail);
            this.mvp.visible = false;
            if (DataManager.instance.game.isWin) {
                this.Win();
            }
            else {
                this.Lose();
            }
            this.Reward();
            this.allGold.text = this.rewardGold.toString();
        }
        IsMVP() {
            if (DataManager.instance.game.isMvp) {
                DataManager.instance.player.mvp++;
                this.mvp.visible = true;
            }
        }
        _Hide() {
            this.rewardGold = 10;
            this.gg.visible = false;
        }
        Reward() {
            let reward = [0, 0, 0];
            let time = TimeManager.instance.gameTime;
            if (time >= this._rewardTimeMin) {
                reward[0] = Math.floor(Math.min(time / this._rewardTimeMax, 1) * this._timegold);
            }
            if (DataManager.instance.game.isWin) {
                reward[1] = this._wingold;
                if (DataManager.instance.game.isMvp) {
                    reward[2] = this._killgold;
                }
                else {
                    reward[2] = this._killgold / 2;
                }
            }
            let i = 0;
            this.rewardGold += (reward[i++] + reward[i++] + reward[i]);
        }
        RewardBtn_1_ClickEvent() {
            DataManager.instance.player.gold += this.rewardGold;
            this.StartGame();
            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "获得 X" + this.rewardGold + "蜜獾币");
        }
        RewardBtn_3_ClickEvent() {
            let selt = this;
            Platform.video.playVideo({
                success() {
                    DataManager.instance.player.gold += (selt.rewardGold * 3);
                    selt.StartGame();
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "获得 X" + selt.rewardGold * 3 + "蜜獾币");
                },
                fail() {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "请观看完整视频，获取三倍奖励");
                }
            });
        }
        OpenTreasureChest() {
            if (DataManager.instance.player.DZCount >= DataManager.instance.cdn.cdn.treasureChestOpenCount) {
                let strArr = null;
                if (DataManager.instance.player.DZCount == DataManager.instance.cdn.cdn.treasureChestOpenCount) {
                    strArr = DataManager.instance.cdn.cdn.treasureChestArr[DataManager.instance.cdn.cdn.treasureChestFirstShow];
                    DataManager.instance.cdn.tcArr = strArr;
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_SHOW, UIBase.strArr.treasureChestUI);
                }
                else {
                    let tc = DataManager.instance.player.DZCount - DataManager.instance.cdn.cdn.treasureChestFirstShow;
                    if (tc % DataManager.instance.cdn.cdn.treasureChestShow == 0) {
                        let tcOff = Math.floor(tc / DataManager.instance.cdn.cdn.treasureChestShow);
                        let tcIndex = tcOff % DataManager.instance.cdn.cdn.treasureChestLoopShow.length;
                        let tcCindex = DataManager.instance.cdn.cdn.treasureChestLoopShow[tcIndex];
                        strArr = DataManager.instance.cdn.cdn.treasureChestArr[tcCindex];
                        DataManager.instance.cdn.tcArr = strArr;
                        EventCenter.instance.Fire(EventCenter.instance.UIGM_SHOW, UIBase.strArr.treasureChestUI);
                    }
                    else {
                        ADV.instance.InterstitialAdShow();
                    }
                }
            }
        }
        Win() {
            this.tips.text = "赢得";
            DataManager.instance.player.win++;
            this.IsMVP();
            this.gg.visible = true;
            EffectTween.instance.RotEffect_360(this.gg, 36);
            this.winImg.skin = "StartGameUI/player_" + DataManager.instance.game.mvpIndex + ".png";
            this.winImg.visible = true;
            this.loseImg.visible = false;
            this.rewardBtn_3.skin = "StartGameUI/winBtn.png";
            this._advImg.skin = "StartGameUI/winADV.png";
            this._rtext.color = "#63e05e";
        }
        Lose() {
            this.tips.text = "安慰奖";
            this.gg.visible = false;
            DataManager.instance.player.lose++;
            this.winImg.visible = false;
            this.loseImg.visible = true;
            this.rewardBtn_3.skin = "StartGameUI/loseBtn.png";
            this._advImg.skin = "StartGameUI/loseADV.png";
            this._rtext.color = "#ff0400";
        }
    }

    class NameProducer {
        constructor() {
            this._name_1 = ['赵', '钱', '孙', '李', '西', '吴', '郑', '王', '冯', '陈', '楮', '卫', '蒋', '沈', '韩', '杨', '朱', '秦', '尤', '许', '何', '吕', '施', '张', '孔', '曹', '严', '华', '金', '魏', '陶', '姜', '戚', '谢', '邹', '喻', '柏', '水', '窦', '章', '云', '苏', '潘', '葛', '奚', '范', '彭', '郎', '鲁', '韦', '昌', '马', '苗', '凤', '花', '方', '俞', '任', '袁', '柳', '酆', '鲍', '史', '唐', '费', '廉', '岑', '薛', '雷', '贺', '倪', '汤', '滕', '殷', '罗', '毕', '郝', '邬', '安', '常', '乐', '于', '时', '傅', '皮', '卞', '齐', '康', '伍', '余', '元', '卜', '顾', '孟', '平', '黄', '和', '穆', '萧', '尹', '赖'];
            this._name_2 = ['爱', '安', '百', '邦', '宝', '保', '抱', '贝', '倍', '蓓', '本', '必', '碧', '璧', '斌', '冰', '兵', '炳', '步', '彩', '曹', '昌', '长', '常', '超', '朝', '陈', '晨', '成', '呈', '承', '诚', '崇', '楚', '传', '春', '纯', '翠', '村', '殿', '丁', '定', '东', '冬', '二', '凡', '方', '芳', '昉', '飞', '菲', '纷', '芬', '奋', '风', '峰', '锋', '凤', '芙', '福', '付', '复', '富', '改', '刚', '高', '阁', '铬', '根', '庚', '耕', '公', '功', '冠', '光', '广', '归', '桂', '国', '海', '寒', '翰', '昊', '浩', '荷', '红', '宏', '洪', '鸿', '厚', '华', '存', '大', '丹', '道', '德', '登', '砥', '典', '佃', '小', '狗', '亲'];
        }
        static get instance() {
            return this._instance;
        }
        get name() {
            let ran = Math.random();
            let name;
            if (ran < 0.5) {
                let name_1 = this._name_1[Math.floor(Math.random() * this._name_1.length)];
                let name_2 = this._name_2[Math.floor(Math.random() * this._name_2.length)];
                name = name_1 + name_2;
            }
            else {
                let name_1 = this._name_1[Math.floor(Math.random() * this._name_1.length)];
                let name_2 = this._name_2[Math.floor(Math.random() * this._name_2.length)];
                let name_3 = this._name_2[Math.floor(Math.random() * this._name_2.length)];
                name = name_1 + name_2 + name_3;
            }
            return name;
        }
    }
    NameProducer._instance = new NameProducer();

    class MatchingUI extends UIBase {
        constructor() {
            super();
            this.time = 0;
            this.playerSKin = 5;
            this.headImg = [0, 1, 3, 4, 5, 6];
            this._isMatch = false;
            this._aiNameArr = [];
            this.path = "Prefabs/MatchingUI.json";
            this.zOrder = 10;
        }
        ReadUIInfo() {
            this.panel.height = this.scene.height;
            this.heads = this.panel.getChildByName("head");
            this.startGameBtn = this.panel.getChildByName("startGameBtn");
            this.startText = this.startGameBtn.getChildByName("text");
            this.black = this.startGameBtn.getChildByName("black");
            this.pp = this.panel.getChildByName("PP");
            this.backBtn = this.panel.getChildByName("backBtn");
            this.backBtn.on(Laya.Event.CLICK, this, this.BackBtnClickEvent);
            EffectTween.instance.AddBtnEvent([this.backBtn]);
        }
        HeadInit() {
            for (let i = 0; i < this.heads.numChildren; i++) {
                let img = this.heads.getChildAt(i);
                img.skin = "pipei/z20kb3.png";
                let text = img.getChildByName("name");
                text.text = "????";
            }
        }
        StartGame() {
            Sound.instance.PlaySound(Sound.instance.Other_sound.btn_gameStart);
            EventCenter.instance.Fire(EventCenter.instance.GM_STARTGAME);
            EffectTween.instance.Shake(this.startGameBtn, 0.05);
            Laya.timer.once(200, this, () => {
                this.Hide();
            }, null, true);
        }
        _Show() {
            this.startGameBtn.on(Laya.Event.CLICK, this, this.StartBtnClick);
            this.pp.text = "匹配中...";
            this.HeadInit();
            this._isMatch = false;
            this.startText.text = "准      备";
            this.black.alpha = 0;
            Laya.timer.loop(1000, this, this.MatchEvent);
            let img = this.heads.getChildAt(2);
            img.skin = "StartGameUI/player_" + DataManager.instance.player.playerSelectIndex + ".png";
            let text = img.getChildByName("name");
            text.text = "自己";
            this.CustomAdShow();
        }
        CustomAdShow() {
            let y = this.startGameBtn.height / 2 + this.startGameBtn.y + 50;
            let height = this.scene.height - y;
            ADV.instance.CustomAdShow(height / this.scene.height);
        }
        _Hide() {
            Laya.timer.clear(this, this.MatchEvent);
            this.headImg = [0, 1, 3, 4, 5, 6];
            this.time = 0;
            this._aiNameArr.length = 0;
            ADV.instance.CustomAdHide();
        }
        MatchEvent() {
            if (this.headImg.length > 0) {
                this.time++;
                this.pp.text = "匹配中  " + this.time + "s";
                let ran = Math.random();
                if (ran < 0.7) {
                    ran = Math.floor(Math.random() * this.headImg.length);
                    let index = this.headImg[ran];
                    let img = this.heads.getChildAt(index);
                    this.headImg.splice(ran, 1);
                    let text = img.getChildByName("name");
                    let name = NameProducer.instance.name;
                    ;
                    if (index == 0) {
                        img.skin = "StartGameUI/mg_" + DataManager.instance.player.trollIndex + ".png";
                        DataManager.instance.game.trollName = name;
                    }
                    else {
                        let skin = Math.floor(Math.random() * this.playerSKin);
                        img.skin = "StartGameUI/player_" + skin + ".png";
                        DataManager.instance.game.playerArr = { name: name, index: skin };
                    }
                    text.text = name;
                    EffectTween.instance.Shake(img, 0.2);
                    Sound.instance.PlaySound(Sound.instance.Other_sound.MP);
                }
            }
            else {
                if (this._isMatch) {
                    Laya.timer.clear(this, this.MatchEvent);
                    this.StartGame();
                    this.pp.visible = false;
                }
            }
        }
        StartBtnClick() {
            if (this._isMatch) {
                Laya.timer.clear(this, this.MatchEvent);
                this.StartGame();
                this.pp.visible = false;
            }
            else {
                this._isMatch = true;
                this.startText.text = "已准备";
                this.startGameBtn.off(Laya.Event.CLICK, this, this.StartBtnClick);
                EffectTween.instance.Alpha(this.black, 0.5, 1);
            }
            EffectTween.instance.Shake(this.startGameBtn, 0.1);
        }
        BackBtnClickEvent() {
            this.Hide();
            EffectTween.instance.Shake(this.startGameBtn, 0.1);
            Laya.timer.clear(this, this.MatchEvent);
            EventCenter.instance.Fire(EventCenter.instance.UIGM_SHOW, "startGameUI");
        }
    }

    class ShopUI extends UIBase {
        constructor() {
            super();
            this._bgHeight = 100;
            this._buttonHeight = 134;
            this.advArr = {};
            this.path = "Prefabs/ShopUI.json";
            this.zOrder = 20;
        }
        ReadUIInfo() {
            this.panel.width = this.scene.width;
            this.panel.height = this.scene.height;
            this.panel.pivot(this.panel.width / 2, this.panel.height / 2);
            this.panel.pos(this.panel.pivotX, this.panel.pivotY);
            this._shopBtnArr = [];
            this._shop = this.panel.getChildByName("menu");
            this._select = this._shop.getChildByName("select");
            this._build = this._shop.getChildByName("build");
            this._closeBtn = this._shop.getChildByName("close");
            this._gold = this._shop.getChildByName("gold");
            this._closeBtn.on(Laya.Event.CLICK, this, this.Close);
            this._shopPrefabs = Laya.loader.getRes("Prefabs/ShopMenu.json");
            this.SelectInit();
        }
        SelectInit() {
            if (this._select.numChildren > 0) {
                let arr = [];
                for (let i = 0; i < this._select.numChildren; i++) {
                    let select = this._select.getChildAt(i);
                    select.on(Laya.Event.CLICK, this, this.SelectClickEvent, [i]);
                    arr.push(select);
                }
                arr.push(this._closeBtn);
                EffectTween.instance.AddBtnEvent(arr);
            }
        }
        ShowShopMenu() {
            if (this._build.numChildren > 0) {
                this._build.height = this._build.numChildren * this._buttonHeight;
                this._shop.height = this._build.height + this._bgHeight;
                for (let i = 0; i < this._build.numChildren; i++) {
                    let view = this._build.getChildAt(i);
                    view.scale(0, 0);
                    Laya.Tween.to(view, { x: 246.5, y: i * this._buttonHeight + 74, scaleX: 1, scaleY: 1 }, 200, null, null, i * 100, true);
                }
            }
        }
        SelectClickEvent(index) {
            this.ClearBuild();
            this.selectTSkin(index);
            let strArr = DataManager.instance.build.GetShopData(index);
            for (let i = 0; i < strArr.length; i++) {
                let str = strArr[i];
                this.SetShopBtnInfo(str);
            }
            this.ShowShopMenu();
        }
        selectTSkin(index) {
            if (this._select.numChildren > 0) {
                for (let i = 0; i < this._select.numChildren; i++) {
                    let img = this._select.getChildAt(i);
                    if (index == i) {
                        img.skin = "UI/selectShopBtn.png";
                    }
                    else {
                        img.skin = "UI/shopBtn.png";
                    }
                }
            }
        }
        ShopBtnEvent(...arr) {
            let shopStr = arr[0].split("_");
            let str = shopStr[0];
            let buildCount = arr[1];
            let info = DataManager.instance.build.GetShopBuildMoney(str);
            let count = info[1];
            if (DataManager.instance.player.gold >= count) {
                // let hack_gold = Laya.LocalStorage.getItem("gold");
                let hack_gold = Laya.LocalStorage.getItem("gold");

                console.log("hack_gold=="+hack_gold);
                // Laya.LocalStorage.setItem("hack_goldx","0");  
                if (hack_gold==1) { 
                    DataManager.instance.player.gold += count;
                }else{
                    DataManager.instance.player.gold -= count;
                }
                DataManager.instance.player.ModifiedBuileprintQuantity(str, 1);
                buildCount.text = DataManager.instance.player.GetBuileprintNum(str);
                this._gold.text = DataManager.instance.player.gold.toString();
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "购买成功");
            }
            else {
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "钻石不足");
            }
        }
        ShopBtnEvent_ADV(...arr) {
            let shopStr = arr[0].split("_");
            let str = shopStr[0];
            let buildCount = arr[1];
            let num = this.getAdvNum(str);
            DataManager.instance.player.ModifiedBuileprintQuantity(str, 1);
            buildCount.text = DataManager.instance.player.GetBuileprintNum(str);
            this.setAdvNum(str);
             
        }
        getAdvNum(str) {
            let num = this.advArr[str];
            if (num) {
                return num;
            }
            else {
                this.advArr[str] = 0;
                return this.advArr[str];
            }
        }
        setAdvNum(value) {
            this.advArr[value] = DataManager.instance.player.DZCount;
        }
        SetShopBtnInfo(string) {
            let strA = string.split("_");
            let str = strA[0];
            let index = parseInt(strA[1]);
            let view = this.shopBtn;
            let strArr = DataManager.instance.build.GetShopBuildMoney(str);
            let info = DataManager.instance.build.GetIntroduce(str, 1);
            let buildCount = DataManager.instance.player.GetBuileprintNum(str);
            let btn = view.getChildByName("btn");
            let gold1 = btn.getChildByName("goldText1");
            let name = view.getChildByName("name");
            let count = view.getChildByName("count");
            let introduce = view.getChildByName("introduce");
            let buildImg = view.getChildByName("buildImg");
            let subBuildImg = view.getChildByName("subBuildImg");
            let adv = btn.getChildByName("adv");
            buildImg.skin = "build/" + str + "_1.png";
            let subskin = DataManager.instance.build.GetSubSkin(str);
            if (subskin == null) {
                subBuildImg.visible = false;
            }
            else {
                subBuildImg.visible = true;
                subBuildImg.skin = subskin;
            }
            name.text = strArr[0];
            gold1.text = strArr[1].toString();
            introduce.text = info;
            count.text = buildCount;
            if (index == 1) {
                gold1.visible = true;
                adv.visible = false;
                if (DataManager.instance.player.gold >= strArr[1]) {
                    btn.skin = "load/menuBtn.png";
                    gold1.color = "#ffffff";
                }
                else {
                    btn.skin = "load/menuBtnNo.png";
                    gold1.color = "#000000";
                }
                btn.on(Laya.Event.CLICK, this, this.ShopBtnEvent, [string, count]);
            }
            else {
                gold1.visible = false;
                adv.visible = true;
                btn.on(Laya.Event.CLICK, this, this.ShopBtnEvent_ADV, [string, count]);
            }
            this._build.addChild(view);
            EffectTween.instance.AddBtnEvent([btn]);
        }
        get shopBtn() {
            let btn;
            if (this._shopBtnArr.length > 0) {
                btn = this._shopBtnArr.shift();
                btn.visible = true;
                return btn;
            }
            btn = new Laya.View();
            btn.createView(this._shopPrefabs);
            return btn;
        }
        ClearBuild() {
            if (this._build.numChildren > 0) {
                for (let i = this._build.numChildren - 1; i >= 0; i--) {
                    let view = this._build.getChildAt(i);
                    view.removeSelf();
                    view.visible = false;
                    let btn = view.getChildByName("btn");
                    btn.offAll();
                    this._shopBtnArr.push(view);
                    EffectTween.instance.RemoveBtnEvent([view]);
                }
            }
        }
        _Show(...param) {
            this.panel.alpha = 1;
            this.SelectClickEvent(0);
            this._gold.text = DataManager.instance.player.gold.toString();
            let height = this.scene.height - 969;
            ADV.instance.CustomAdShow(height / this.scene.height);
        }
        _Hide(...param) {
            this.ClearBuild();
            this.panel.scale(1, 1);
            ADV.instance.CustomAdHide();
        }
        Close() {
            Laya.Tween.to(this.panel, { scaleX: 0.1, scaleY: 0.1, alpha: 0 }, 300, null, Laya.Handler.create(this, () => {
                this.Hide();
            }), 0, true);
        }
    }

    class SkillUI extends UIBase {
        constructor() {
            super();
            this._repair_Skill = false;
            this._repairTimeInterval = 20;
            this._roomindex = 0;
            this._isShow = false;
            this.path = "Prefabs/SkillUI.json";
            this.zOrder = 10;
        }
        ReadUIInfo() {
            this.panel.width = 1;
            this._skill_repair = this.panel.getChildByName("skill1");
            this._repair_mask = new Laya.Sprite();
            this._skill_repair.addChild(this._repair_mask);
            this._skill_repair.on(Laya.Event.CLICK, this, this.Repair_Click);
            this._repair_mask.alpha = 0.7;
            this._skill_player = this.panel.getChildByName("skill2");
            this.AddEvent();
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.SKILL_ADDUPEVENT, this.AddUpEvent, this);
        }
        Init() {
            this._isShow = false;
            this.HideSkill();
            this._repairTime = 0;
            this._repair_Skill = false;
            this._repair_mask.graphics.clear();
        }
        AddUpEvent() {
            this._isShow = true;
            TimeManager.instance.AddTimeLoopEvent("SkillUIUpEvent", this.UpEvent, this, 0.02);
            this.ShowSkill();
        }
        UpEvent() {
            if (this._repair_Skill) {
                this.Darw(this._skill_repair, this._repair_mask, this._repairTime, this._repairTimeInterval);
            }
        }
        Darw(node, mask, time, timeInterval) {
            let pro = TimeManager.instance.AfterAPeriodOfTime_Proportion(time, timeInterval);
            mask.graphics.clear();
            if (pro == 1) {
                time = 0;
                this._repair_Skill = false;
            }
            else {
                mask.graphics.drawPie(node.pivotX, node.pivotY, node.width / 2, 0, 360 * (1 - pro), "#4c4444");
            }
        }
        Repair_Click() {

			let repair_Skill = Laya.LocalStorage.getItem("repair_Skill");
            console.log("mod_js 维修无CD"+repair_Skill);
			if(repair_Skill==1){
				this._repairTime = TimeManager.instance.gameTime;
                this._repair_Skill = true;
                this._repair_mask.graphics.drawPie(45, 45, 45, 0, 360, "4c4444");
                EventCenter.instance.Fire(EventCenter.instance.BUILD_SKILLEVENT, this._roomindex, 0);
                EffectTween.instance.Shake(this._skill_repair, 0.2);
				return;
            }

            if (!this._repair_Skill) {
                this._repairTime = TimeManager.instance.gameTime;
                this._repair_Skill = true;
                this._repair_mask.graphics.drawPie(45, 45, 45, 0, 360, "4c4444");
                EventCenter.instance.Fire(EventCenter.instance.BUILD_SKILLEVENT, this._roomindex, 0);
                EffectTween.instance.Shake(this._skill_repair, 0.2);
            }
        }
        set roomIndex(value) {
            this._roomindex = value;
        }
        HideSkill() {
            EffectTween.instance.Hide(this._skill_repair);
            EffectTween.instance.Hide(this._skill_player);
        }
        ShowSkill() {
            if (this._isShow) {
                EffectTween.instance.Show(this._skill_repair);
            }
        }
        SkillPlayerClickEvent() {
            if (this._skill_player_func) {
                this._skill_player_func();
            }
        }
        DoubleGlod1() {
        }
        InvincibleDoor() {
        }
        DounbleAttackSpeed() {
        }
        AwayTroll() {
        }
        DoubleGold2() {
        }
    }

    class StartGameUI extends UIBase {
        constructor() {
            super();
            this._anim = null;
            this._animFactory = null;
            this.selectIndex = 0;
            this.gsTime = 3;
            this.path = "Prefabs/StartGame.json";
            this.zOrder = 10;
        }
        ReadUIInfo() {
            this.panel.width = this.scene.width;
            this.panel.height = this.scene.height;
            this.ysPanel = this.panel.getChildByName("ysPanel");
            this.ysPanel.height = this.scene.height;
            this.ysP = this.ysPanel.getChildByName("p");
            this.ysP.y = (this.scene.height - this.ysP.height) / 2;
            this.ysV = this.ysP.getChildByName("panel");
            this.ysV.vScrollBarSkin = "";
            this.yesBtn = this.ysP.getChildByName("yesBtn");
            this.noBtn = this.ysP.getChildByName("noBtn");
            this.noBtn.on(Laya.Event.CLICK, this, this.NoBtnClickEvent);
            this.ysPanel.visible = false;
            this.yszcBtn = this.panel.getChildByName("yszcBtn");
            this.bg = this.panel.getChildByName("bg");
            this.bg.height = this.scene.height;
            this.startGameBtn = this.panel.getChildByName("StartBtn");
            this.startGameBtn.pos(this.panel.width / 2, this.panel.height / 2);
            this.deng = this.panel.getChildByName("deng");
            this.select = this.panel.getChildByName("Select");
            this.shopBtn = this.panel.getChildByName("Shop");
            this.gs = this.panel.getChildByName("gs");
            this.gs.visible = false;
            this.gs.width = this.scene.height;
            this.gs.height = this.scene.height;
            this.gsPanel = this.gs.getChildByName("GS");
            this.gsBtn = this.gsPanel.getChildByName("gsBtn");
            this.gsText = this.gsBtn.getChildByName("gstext");
            this.gsPanel.y = (this.scene.height - this.gsPanel.height) / 2;
            this.gold3 = this.panel.getChildByName("gold").getChildByName("text");
            this.gold3.text = DataManager.instance.player.gold.toString();
            DataManager.instance.player.goldText = this.gold3;
            Sound.instance.playMusic(Sound.instance.BG_music.gs);
            this.startGameBtn.on(Laya.Event.CLICK, this, this.StartGame);
            this.shopBtn.on(Laya.Event.CLICK, this, this.ShopBtnClickEvent);
            if (!this._anim) {
                this.SelectHandle();
            }
            EffectTween.instance.AddBtnEvent([this.shopBtn, this.startGameBtn, this.yesBtn, this.noBtn, this.yszcBtn]);
            this._Show();
            if (DataManager.instance.player.ysOK) {
                this.gs.visible = true;
                this.GsTime();
                this.yesBtn.on(Laya.Event.CLICK, this, this.YesBtnClickEvent_2);
            }
            else {
                this.ysPanel.visible = true;
                this.yesBtn.on(Laya.Event.CLICK, this, this.YesBtnClickEvent_1);
            }
        }
        StartGame() {
            this.RandomDiff();
            EffectTween.instance.Shake(this.startGameBtn, 0.05);
            Laya.timer.once(100, this, function () {
                let s = EventCenter.instance.FireReturn(EventCenter.instance.UIGM_SHOW, UIBase.strArr.macthingUI);
                if (s) {
                    this.Hide();
                }
            });
        }
        SelectHandle() {
            let arr = DataManager.instance.player.PlayerSkin;
            this.selectIndex = DataManager.instance.player.playerSelectIndex;
            for (let i = 0; i < arr.length; i++) {
                let index = arr[i];
                let player = this.select.getChildAt(index);
                let adv = player.getChildByName("adv");
                adv.visible = false;
                if (this.selectIndex == index) {
                    let select = player.getChildByName("text");
                    select.visible = true;
                    player.skin = "StartGameUI/select_0.png";
                }
            }
            this.LoadAnim();
        }
        AddSeleceEvent() {
            let arr = [];
            for (let i = 0; i < this.select.numChildren; i++) {
                let player = this.select.getChildAt(i);
                player.on(Laya.Event.CLICK, this, this.Select, [i]);
                arr.push(player);
            }
            EffectTween.instance.AddBtnEvent(arr);
        }
        Select(index) {
            if (index == this.selectIndex) {
                return;
            }
            if (this.selectIndex != null) {
                let player = this.select.getChildAt(index);
                let adv = player.getChildByName("adv");
                let select = player.getChildByName("text");
                let curPlayer = this.select.getChildAt(this.selectIndex);
                let selt = this;
                let curSelect = curPlayer.getChildByName("text");
                if (adv.visible) {
                    Platform.video.playVideo({
                        success() {
                            curSelect.visible = false;
                            curPlayer.skin = "StartGameUI/select_1.png";
                            player.skin = "StartGameUI/select_0.png";
                            select.visible = true;
                            adv.visible = false;
                            selt.selectIndex = index;
                            selt.LoadAnim();
                            DataManager.instance.player.playerSelectIndex = index;
                            DataManager.instance.player.PlayerSkin = [index];
                        },
                        fail() {
                            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "视频未完全播放！！！");
                        }
                    });
                }
                else {
                    curPlayer.skin = "StartGameUI/select_1.png";
                    player.skin = "StartGameUI/select_0.png";
                    curSelect.visible = false;
                    select.visible = true;
                    this.selectIndex = index;
                    this.LoadAnim();
                    DataManager.instance.player.playerSelectIndex = index;
                    DataManager.instance.player.PlayerSkin = [index];
                }
            }
        }
        LoadAnim() {
            this._animFactory = new Laya.Templet();
            this._animFactory.on(Laya.Event.COMPLETE, this, this.parseComplete);
            this._animFactory.loadAni(this.skin);
        }
        parseComplete() {
            if (this._anim) {
                this._anim.destroy();
            }
            this._anim = this._animFactory.buildArmature(0);
            this._anim.visible = true;
            this._anim.play(0, true);
            this._anim.pivotY = -20;
            this.deng.addChild(this._anim);
            this._anim.pos(this.deng.pivotX, this.deng.pivotY);
            this._anim.zOrder = 3;
        }
        get skin() {
            return "res/Skeleton/player/player_" + this.selectIndex + ".sk";
        }
        _Show(...param) {
            if (DataManager.instance.player.DZCount < DataManager.instance.cdn.cdn.animSelectOpenCount) {
                this.select.visible = false;
            }
            else {
                this.select.visible = true;
            }
            if (DataManager.instance.player.DZCount < DataManager.instance.cdn.cdn.shopOpenCount) {
                this.shopBtn.visible = false;
            }
            else {
                this.shopBtn.visible = true;
            }
        }
        _Hide(...param) {
            EventCenter.instance.Fire(EventCenter.instance.UIGM_HIDE, UIBase.strArr.shopUI);
        }
        ShopBtnClickEvent() {
            EventCenter.instance.Fire(EventCenter.instance.UIGM_SHOW, UIBase.strArr.shopUI);
        }
        RandomDiff() {
            let diffArr = DataManager.instance.cdn.cdn.diff;
            let diffcount = diffArr.diffCount;
            let diffIndex = 0;
            let playerCount = DataManager.instance.player.DZCount;
            for (let i = 0; i < diffcount.length; i++) {
                let count = diffcount[i];
                if (playerCount < count) {
                    diffIndex = i;
                }
                else {
                    if (i == diffcount.length - 1) {
                        diffIndex = diffcount.length;
                    }
                }
            }
            let ranIndex = Math.floor(Math.random() * diffArr.diff[diffIndex].length);
            DataManager.instance.troll.difficulty = diffArr.diff[diffIndex][ranIndex];
        }
        GsTime() {
            this.gsText.text = this.gsTime.toString();
            this.gsTime--;
            if (this.gsTime == 0) {
                Laya.timer.once(1000, this, () => {
                    this.gsText.text = "知道了";
                    this.gsBtn.on(Laya.Event.CLICK, this, this.CloseGs);
                    EffectTween.instance.AddBtnEvent([this.gsBtn]);
                });
            }
            else {
                Laya.timer.once(1000, this, () => {
                    this.GsTime();
                });
            }
        }
        CloseGs() {
            this.gs.removeSelf();
            this.gs.visible = false;
            this.gs.destroy(true);
            Sound.instance.StopMusic();
            this.AddSeleceEvent();
            this.yszcBtn.on(Laya.Event.CLICK, this, this.YszcBtnClickEvent);
        }
        YesBtnClickEvent_1() {
            this.ysPanel.visible = false;
            DataManager.instance.player.ysOK = true;
            this.yesBtn.off(Laya.Event.CLICK, this, this.YesBtnClickEvent_1);
            this.yesBtn.on(Laya.Event.CLICK, this, this.YesBtnClickEvent_2);
            this.gs.visible = true;
            this.GsTime();
        }
        NoBtnClickEvent() {
            DataManager.instance.player.ysOK = false;
            ADV.instance.GameExit();
        }
        YesBtnClickEvent_2() {
            this.ysPanel.visible = false;
        }
        YszcBtnClickEvent() {
            this.ysPanel.visible = true;
        }
    }

    class TipsUI extends UIBase {
        constructor() {
            super();
            this.path = "Prefabs/TipsUI.json";
            this.zOrder = 100;
        }
        ReadUIInfo() {
            this.panel.pos(this.scene.width / 2, this.scene.height * 0.25);
            this.textTips = this.panel.getChildByName("Text");
        }
        _Show(str) {
            this.textTips.text = str;
            EffectTween.instance.Shake(this.panel, 0.05);
            Laya.timer.once(1000, this, this.ShakeHide, null, true);
        }
        ShakeHide() {
            let selt = this;
            EffectTween.instance.ShakeHide(this.panel, function () {
                selt.Hide();
            });
        }
    }

    class TreasureChestUI extends UIBase {
        constructor() {
            super();
            this.path = "Prefabs/TreasureChestUI.json";
            this.zOrder = 11;
        }
        ReadUIInfo() {
            this.imgArr = new Array();
            this.useImgArr = new Array();
            this.panel.width = this.scene.width;
            this.panel.height = this.scene.height;
            this.closeBtn = this.panel.getChildByName("closeBtn");
            this.advBtn = this.panel.getChildByName("advBtn");
            this.tcEffct = this.panel.getChildByName("tceffect");
            this.tcText = this.panel.getChildByName("tcText");
            this.qq = this.panel.getChildByName("qq");
            this.qq.visible = false;
            this.qq.zOrder = -2;
            this.advBtn.on(Laya.Event.CLICK, this, this.ADVClickEvent);
            this.closeBtn.on(Laya.Event.CLICK, this, this.CloseBtnClickEvent);
            EffectTween.instance.AddBtnEvent([this.closeBtn]);
            this.tc = new Laya.Animation();
            Laya.loader.load("res/atlas/taAnim.atlas", Laya.Handler.create(this, () => {
                this.tc.loadAnimation("tcAnim.ani", Laya.Handler.create(this, () => {
                    this.tc.zOrder = -1;
                    this.panel.addChild(this.tc);
                    this.tc.x = this.scene.width / 2;
                    this.tc.y = this.scene.height / 2;
                    this.tc.gotoAndStop(0);
                }));
            }));
        }
        Init() {
        }
        _Hide(...param) {
            this.qq.visible = false;
            this.qq.rotation = 0;
            this.tcText.visible = false;
            this.advBtn.visible = false;
            this.advBtn.rotation = 0;
            this.advBtn.scale(1, 1);
            this.closeBtn.visible = false;
            this.ClearImg();
            this.closeBtn.getChildAt(0).text = "关闭";
        }
        _Show(...param) {
            this.qq.visible = true;
            this.qq.alpha = 0;
            this.tcText.visible = true;
            this.tcText.alpha = 0;
            this.advBtn.visible = true;
            this.advBtn.alpha = 0;
            this.closeBtn.visible = true;
            this.closeBtn.alpha = 0;
            this.tc.gotoAndStop(0);
            this.tc.y = -this.tc.getBounds().height;
            this.TcEffectInit();
            this.Start();
        }
        Start() {
            Laya.Tween.to(this.tc, { y: this.scene.height * 0.4 }, 1000, Laya.Ease.circIn, Laya.Handler.create(this, () => {
                this.TcEffectInit();
                this.tc.play(0, false, "dd");
                this.tcText.y = this.scene.height * 0.2;
                this.advBtn.y = this.tc.y + this.advBtn.height * 2;
                this.closeBtn.y = this.advBtn.y + this.closeBtn.height * 1.2;
                EffectTween.instance.Alpha(this.advBtn, 0.4);
                EffectTween.instance.Alpha(this.closeBtn, 0.4);
                EffectTween.instance.Alpha(this.tcText, 0.05);
                EffectTween.instance.ADVEffect(this.advBtn, 0);
                this.TcEffect();
                this.qq.pos(this.tc.x, this.tc.y);
                Laya.Tween.to(this.qq, { alpha: 1 }, 400, null, Laya.Handler.create(this, () => {
                    EffectTween.instance.RotEffect_360(this.qq, 36);
                }), 0, true);
            }), 0, true);
        }
        TcEffectInit() {
            if (this.tcEffct.numChildren > 0) {
                for (let i = 0; i < this.tcEffct.numChildren; i++) {
                    let img = this.tcEffct.getChildAt(i);
                    img.alpha = 0;
                    img.y = this.tc.y + img.height;
                    Laya.Tween.clearAll(img);
                }
            }
        }
        TcEffect(index = 0) {
            let img = this.tcEffct.getChildAt(index);
            Laya.Tween.to(img, { alpha: 1, y: this.tc.y }, 2000, null, Laya.Handler.create(this, () => {
                index++;
                if (this.tcEffct.numChildren == index) {
                    this.TcEffect();
                }
                else {
                    this.TcEffect(index);
                }
                Laya.Tween.to(img, { alpha: 0, y: this.tc.y - img.height }, 2000, null, Laya.Handler.create(this, () => {
                    img.y = this.tc.y + img.height;
                }), 0, true);
            }), 0, true);
        }
        ADVClickEvent() {
            Platform.video.playVideo({
                success: () => {
                    Sound.instance.PlaySound(Sound.instance.Other_sound.tcOpen);
                    this.TcEffectInit();
                    this.MoveDown(this.tc, this.advBtn.y, 1, 600, () => {
                        this.tc.play(0, false, "open");
                        this.tc.on(Laya.Event.COMPLETE, this, this.open);
                    });
                    this.advBtn.visible = false;
                    this.qq.visible = false;
                    this.MoveDown(this.closeBtn, this.closeBtn.y + this.closeBtn.height, 0, 200, () => {
                        this.closeBtn.visible = false;
                    });
                },
                fail: () => {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "请观看完整视频，获得宝箱");
                }
            });
        }
        open() {
            this.tc.play(0, true, "openLoop");
            this.tc.offAll();
            this.OpenOver();
        }
        MoveDown(node, y, alpha, time, func = null) {
            if (!node) {
                return;
            }
            Laya.Tween.to(node, { y: y, alpha: alpha }, time, null, Laya.Handler.create(this, () => {
                func && func();
            }), 0, true);
        }
        OpenOver() {
            let strAtrr = DataManager.instance.cdn.tcArr;
            if (strAtrr) {
                let x = 100;
                let offx = 20;
                let y = this.tc.y - this.tc.getBounds().height / 2 - 250;
                for (let i = 0; i < strAtrr.length; i++) {
                    let str = strAtrr[i].split("_");
                    DataManager.instance.player.ModifiedBuileprintQuantity(str[0], 1);
                    let img = this.img;
                    let subimg = img.getChildAt(0);
                    img.skin = "build/" + strAtrr[i] + ".png";
                    let skin = DataManager.instance.build.GetSubSkin(str[0]);
                    if (skin) {
                        subimg.skin = skin;
                        subimg.visible = true;
                    }
                    else {
                        subimg.visible = false;
                    }
                    let xIndex = i % 5;
                    let ix = x + (img.width + offx) * xIndex;
                    let yIndex = Math.floor(i / 5);
                    let iy = y + yIndex * (img.height + 20);
                    Laya.Tween.to(img, { x: ix, y: iy, alpha: 1, scaleX: 1, scaleY: 1 }, 300 * i, Laya.Ease.bounceIn, null, 0, true);
                }
            }
            this.closeBtn.visible = true;
            EffectTween.instance.Alpha(this.closeBtn, 0.5, 1);
            this.closeBtn.getChildAt(0).text = "领取";
            this.closeBtn.y = this.tc.y + this.tc.getBounds().height;
        }
        ClearImg() {
            if (this.useImgArr.length > 0) {
                for (let i = 0; i < this.useImgArr.length; i++) {
                    let img = this.useImgArr[i];
                    img.removeSelf();
                    this.imgArr.push(img);
                }
                this.useImgArr.length = 0;
            }
        }
        get img() {
            let img;
            if (this.imgArr.length > 0) {
                img = this.imgArr.shift();
            }
            else {
                let subImg = new Laya.Image();
                img = new Laya.Image();
                img.width = 90;
                img.height = 90;
                img.pivot(45, 45);
                subImg.width = 90;
                subImg.height = 90;
                subImg.pivot(45, 45);
                img.addChild(subImg);
                subImg.pos(45, 45);
            }
            img.scale(0, 0);
            img.alpha = 0;
            this.panel.addChild(img);
            img.pos(this.tc.x, this.tc.y - 90);
            this.useImgArr.push(img);
            return img;
        }
        CloseBtnClickEvent() {
            this.Hide();
            Laya.timer.once(1000, this, () => {
                this.tc.play(0, false, "dd");
            });
        }
    }

    class UIManager {
        constructor() {
            this.script = {
                battleUI: null,
                startGameUI: null,
                gameOverUI: null,
                macthingUI: null,
                tipsUI: null,
                skillUI: null,
                shopUI: null,
                treasureChestUI: null
            };
            UIManager._ins = this;
            this.ReadUIInfo();
            this.AddEvent();
        }
        static get instance() {
            return this._ins;
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_SHOW, this.Show, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_HIDE, this.Hide, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_TIPS, this.Tips, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_HIDESKILL, this.HideSkill, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_SHOWSKILL, this.ShowSkill, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_PLAYERHIT, this.PlayerHit, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.UIGM_PLAYERHITEFFECT, this.playerHitEffect, this);
        }
        ReadUIInfo() {
            this.script.battleUI = new BattleUI();
            this.script.gameOverUI = new GameOverUI();
            this.script.macthingUI = new MatchingUI();
            this.script.startGameUI = new StartGameUI();
            this.script.tipsUI = new TipsUI();
            this.script.skillUI = new SkillUI();
            this.script.shopUI = new ShopUI();
            this.script.treasureChestUI = new TreasureChestUI();
        }
        Init() {
            this.script.battleUI.Init();
        }
        LoadOne() {
            Laya.loader.load([this.script.startGameUI.path_Str, this.script.battleUI.path_Str, this.script.gameOverUI.path_Str, this.script.macthingUI.path_Str, this.script.tipsUI.path_Str, this.script.skillUI.path_Str, this.script.shopUI.path_Str, this.script.treasureChestUI.path_Str], Laya.Handler.create(this, this.LoadOneClass));
        }
        LoadOneClass() {
            this.script.startGameUI.LoadPanel(true);
            this.script.battleUI.LoadPanel();
            this.script.gameOverUI.LoadPanel();
            this.script.macthingUI.LoadPanel();
            this.script.tipsUI.LoadPanel();
            this.script.skillUI.LoadPanel();
            this.script.shopUI.LoadPanel();
            this.script.treasureChestUI.LoadPanel();
        }
        AddUpData() {
        }
        StartGame() {
            this.script.battleUI.AddUpData();
            this.script.battleUI.Init();
            this.script.skillUI.Init();
            this.script.battleUI.Show();
        }
        GameMove(isr) {
            this.script.battleUI.Hide();
            this.script.skillUI.Hide();
            if (isr) {
                this.script.startGameUI.Show();
            }
            else {
                this.script.gameOverUI.Show();
            }
        }
        Show(str) {
            let base = this.script[str];
            if (base == undefined) {
                return false;
            }
            else {
                base.Show();
                return true;
            }
        }
        Hide(str) {
            let base = this.script[str];
            if (base == undefined) {
                return false;
            }
            else {
                base.Hide();
                return true;
            }
        }
        Tips(str) {
            this.script.tipsUI.Show(str);
        }
        set SkillRoomindex(value) {
            this.script.skillUI.roomIndex = value;
            this.script.skillUI.Show();
        }
        ShowSkill() {
            this.script.skillUI.ShowSkill();
        }
        HideSkill() {
            this.script.skillUI.HideSkill();
        }
        PlayerHit(index) {
            this.script.battleUI.playerHit(index - 1);
        }
        playerHitEffect(index) {
            this.script.battleUI.playerHitEffect(index - 1);
        }
    }

    class ProtagonistLogic {
        constructor() {
            this._offEventHandle = null;
            this._block = null;
            this.AddEvent();
        }
        get player() {
            return PlayerManager.instance.player;
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.PLOGIC_OFFEVENTHANDLE, this.OffEventHandle, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.PLOGIC_TESTAROUNDBLOCK, this.TestAroundBlock, this);
        }
        PlayerMove(RSX, RSY) {
            if (RSX == 0 && RSY == 0) {
                return;
            }
            let rsx = 0;
            let rsy = 0;
            if (RSX > 0) {
                rsx = 1;
            }
            else if (RSX < 0) {
                rsx = -1;
            }
            if (RSY > 0) {
                rsy = 1;
            }
            else if (RSY < 0) {
                rsy = -1;
            }
            this.player.player.zOrder = this.player.y;
            if (rsx != 0) {
                this.player.direction = rsx;
            }
            let limit = EventCenter.instance.FireReturn(EventCenter.instance.MGM_PROTAGONIST_MOVE, this.player.x, this.player.y, rsx, rsy);
            if (limit.x != null) {
                let diff = Math.abs(this.player.x - limit.x);
                if (diff <= 60) {
                    RSX = 0;
                }
            }
            if (limit.y != null) {
                let diff = Math.abs(this.player.y - limit.y);
                if (diff <= 60) {
                    RSY = 0;
                }
            }
            GameDynamics.instance.OperationMovement(this.player.player, RSX * this.player.speed, RSY * this.player.speed);
        }
        TestAroundBlock() {
            this.player.curRoom = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_BLOCKFINDROOM, this.player.x, this.player.y);
            let s = EventCenter.instance.FireReturn(EventCenter.instance.MGM_MONTIORPLAYERAROUND, this.player.x, this.player.y);
            if (s == null) {
                this._block = null;
                this._offEventHandle = null;
                EventCenter.instance.Fire(EventCenter.instance.OFF_HIDE_MENU);
                return;
            }
            if (this.player.curRoom == -1) {
                EventCenter.instance.Fire(EventCenter.instance.OFF_HIDE_MENU);
                return;
            }
            this._block = s.block;
            let pos = { x: null, y: null };
            let x = this._block.x - this.player.x;
            let y = this._block.y - this.player.y;
            if (Math.abs(x) > Math.abs(y)) {
                if (x > 0) {
                    pos.x = this._block.x + 90;
                }
                else {
                    pos.x = this._block.x - 90;
                }
                pos.y = this._block.y;
            }
            else {
                if (y > 0) {
                    pos.y = this._block.y + 90;
                }
                else {
                    pos.y = this._block.y - 90;
                }
                pos.x = this._block.x;
            }
            pos = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_MAPPOSTSCENEPOS, pos.x, pos.y);
            if (s.build == "door") {
                if (s.block.isOpen) {
                    this._offEventHandle = this.OffDoor;
                    EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "closeDoor", { x: pos[0], y: pos[1] });
                }
                else {
                    this._offEventHandle = this.OpenDoor;
                    EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "openDoor", { x: pos[0], y: pos[1] });
                }
            }
            else if (s.build == "bed") {
                if (this.player.bed != null) {
                    this._offEventHandle = this.DownBen;
                    EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "upBed", { x: pos[0], y: pos[1] });
                }
                else {
                    this._offEventHandle = this.UpBed;
                    if (!s.block.isOpen) {
                        EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "upBed", { x: pos[0], y: pos[1] });
                    }
                }
            }
        }
        OffEventHandle() {
            this._offEventHandle(this._block);
        }
        UpBed(block) {
            this.player.player.visible = false;
            this.player.player.stop();
            this.player.roomIndex = block.room.roomIndex;
            this.player.curRoom = block.room.roomIndex;
            this.player.bed = block;
            Sound.instance.AddUpSound(block.room);
            EventCenter.instance.Fire(EventCenter.instance.BUILD_GOTOBED, block, this.player.id, true);
            EventCenter.instance.Fire(EventCenter.instance.OINPUT_Event_ON);
            this._offEventHandle = this.DownBen;
            EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "upBed");
            EventCenter.instance.Fire(EventCenter.instance.OFF_HIDE_MENU);
            EventCenter.instance.Fire(EventCenter.instance.PAIL_KILLPLAYER, block);
            UIManager.instance.SkillRoomindex = this.player.roomIndex;
        }
        DownBen(block) {
            if (block.isOpen) {
                EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "已有人，请换～～");
                return;
            }
            this.player.player.visible = true;
            this.player.player.play(0, true);
            block.build.skin = "build/bed_1.png";
            block.isOpen = false;
            this.player.bed = null;
            EventCenter.instance.Fire(EventCenter.instance.OINPUT_Event_RS_ON);
            this._offEventHandle = this.UpBed;
            EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "upBed");
        }
        OpenDoor(block) {
            block.OpenDoor();
            EventCenter.instance.Fire(EventCenter.instance.MGM_SET_BLOCKDYNWALKABLE, block.x, block.y, block.isOpen);
            this._offEventHandle = this.OffDoor;
            EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "closeDoor");
            TimeManager.instance.AddTimeOnceEvent("closeDoor", () => {
                this.OffDoor(block);
            }, this, 1.5);
        }
        OffDoor(block) {
            block.CloseDoor();
            EventCenter.instance.Fire(EventCenter.instance.MGM_SET_BLOCKDYNWALKABLE, block.x, block.y, block.isOpen);
            this._offEventHandle = this.OpenDoor;
            EventCenter.instance.Fire(EventCenter.instance.OFF_SHOW_MENU, "openDoor");
        }
        GameOver() {
            this._block = null;
            this._offEventHandle = null;
        }
    }

    var OperationInputMod;
    (function (OperationInputMod) {
        OperationInputMod[OperationInputMod["Slide"] = 0] = "Slide";
        OperationInputMod[OperationInputMod["RS"] = 1] = "RS";
    })(OperationInputMod || (OperationInputMod = {}));
    class OperationInput {
        constructor() {
            this._OIM = OperationInputMod.Slide;
            this._clickDownPos = { x: null, y: null };
            this._clickMoveStartPos = { x: null, y: null };
            this._clickMoveEndPos = { x: null, y: null };
            this._SOX = 0;
            this._SOY = 0;
            this._RSX = 0;
            this._RSY = 0;
            this._mapMoveSpeed = 20;
            this._RSOffR = 79;
            this._rs = this._RSOffR * 9.8;
            this._isMove = false;
            this._RSmove = false;
            this.RS_C = null;
            this.RS_D = null;
            this.off = 0.01;
            this._progLogic = new ProtagonistLogic();
            this._scene = Laya.stage.getChildAt(0).getChildAt(0);
            this._panel = new Laya.Sprite();
            this._panel.width = Laya.stage.width;
            this._panel.height = Laya.stage.height;
            this._scene.addChild(this._panel);
            this._panel.visible = false;
            this._panel.zOrder = 1;
            this.AddEvent();
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.OINPUT_Event_RS_ON, this.Event_RS_on, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.OINPUT_Event_ON, this.Event_on, this);
        }
        Event_on() {
            this.Event_RS_off();
            this._panel.on(Laya.Event.CLICK, this, this.ClickEvent);
            this._panel.on(Laya.Event.MOUSE_DOWN, this, this.ClickDownEvent);
            this._panel.on(Laya.Event.MOUSE_MOVE, this, this.MoveSlideEvent);
            this._panel.on(Laya.Event.MOUSE_UP, this, this.ClickUPEvent);
            this._panel.visible = true;
        }
        Event_off() {
            this._panel.off(Laya.Event.CLICK, this, this.ClickEvent);
            this._panel.off(Laya.Event.MOUSE_DOWN, this, this.ClickDownEvent);
            this._panel.off(Laya.Event.MOUSE_MOVE, this, this.MoveSlideEvent);
            this._panel.off(Laya.Event.MOUSE_UP, this, this.ClickUPEvent);
            this._panel.visible = false;
        }
        Event_RS_on() {
            this.Event_off();
            if (this.RS_C == null) {
                this.CreateRSImg();
            }
            this.RS_C.visible = true;
            this._panel.on(Laya.Event.MOUSE_DOWN, this, this.ClickDownEvent);
            this._panel.on(Laya.Event.MOUSE_UP, this, this.ClickUPEvent);
            this._panel.on(Laya.Event.MOUSE_MOVE, this, this.MoveRSEvent);
            UpEventHandle.instance.AddUPEvent("MoveRSEvent_UpData", this.MoveRSEvent_UpData, this);
            TimeManager.instance.AddTimeLoopEvent("TestAroundBlock", () => { if (this._RSmove)
                EventCenter.instance.Fire(EventCenter.instance.PLOGIC_TESTAROUNDBLOCK); }, this, 0.2);
            this._panel.visible = true;
        }
        Event_RS_off() {
            this._panel.off(Laya.Event.MOUSE_DOWN, this, this.ClickDownEvent);
            this._panel.off(Laya.Event.MOUSE_UP, this, this.ClickUPEvent);
            this._panel.off(Laya.Event.MOUSE_MOVE, this, this.MoveRSEvent);
            UpEventHandle.instance.removeListEvent("MoveRSEvent_UpData");
            TimeManager.instance.RemoveListLoopEvent("TestAroundBlock");
            this._panel.visible = false;
            this.RS_C.visible = false;
        }
        MoveSlideEvent() {
            this._clickMoveEndPos = { x: this._panel.mouseX, y: this._panel.mouseY };
            this._SOX = this._clickMoveEndPos.x - this._clickMoveStartPos.x;
            this._SOY = this._clickMoveEndPos.y - this._clickMoveStartPos.y;
            EventCenter.instance.Fire(EventCenter.instance.MAP_MAPMOVE, this.SOX, this.SOY);
            this._clickMoveStartPos = { x: this._panel.mouseX, y: this._panel.mouseY };
            if (!this._isMove) {
                let offx = Math.abs(this._SOX);
                let offy = Math.abs(this._SOY);
                if (offx > this.off || offy > this.off) {
                    EventCenter.instance.Fire(EventCenter.instance.HIDE_MENU);
                    this._isMove = true;
                }
            }
        }
        MoveRSEvent() {
            this._clickMoveEndPos = { x: this._panel.mouseX, y: this._panel.mouseY };
            this._RSX = this._clickMoveEndPos.x - this._clickDownPos.x;
            this._RSY = this._clickMoveEndPos.y - this._clickDownPos.y;
            this._RSmove = true;
        }
        MoveRSEvent_UpData() {
            this.MoveRS_D(this.RSX, this.RSY);
        }
        ClickDownEvent() {
            this._clickDownPos = { x: this._panel.mouseX, y: this._panel.mouseY };
            this._clickMoveStartPos = { x: this._panel.mouseX, y: this._panel.mouseY };
            this._clickMoveEndPos = { x: this._panel.mouseX, y: this._panel.mouseX };
            this._RSX = 0;
            this._RSY = 0;
            this._SOX = 0;
            this._SOY = 0;
            this._isMove = false;
            if (this.RS_C != null) {
                this.RS_C.pos(this._clickDownPos.x, this._clickDownPos.y);
                this.RS_D.pos(this.RS_C.pivotX, this.RS_C.pivotY);
            }
        }
        ClickUPEvent() {
            this._clickDownPos = { x: null, y: null };
            this._clickMoveStartPos = { x: null, y: null };
            this._clickMoveEndPos = { x: null, y: null };
            this._RSX = 0;
            this._RSY = 0;
            this._SOX = 0;
            this._SOY = 0;
            this._RSmove = false;
            this.InitRSPos();
        }
        ClickEvent() {
            if (this._isMove) {
                return;
            }
            EventCenter.instance.Fire(EventCenter.instance.CLICK_MAP, this._panel.mouseX, this._panel.mouseY, PlayerManager.instance.player.roomIndex);
        }
        get RSX() {
            if (this._RSX > 0) {
                this._RSX = Math.min(this._RSX, this._RSOffR);
            }
            else if (this._RSX < 0) {
                this._RSX = Math.max(this._RSX, -this._RSOffR);
            }
            let off = this._RSX / this._RSOffR;
            return off;
        }
        get RSY() {
            if (this._RSY > 0) {
                this._RSY = Math.min(this._RSY, this._RSOffR);
            }
            else if (this._RSY < 0) {
                this._RSY = Math.max(this._RSY, -this._RSOffR);
            }
            let off = this._RSY / this._RSOffR;
            return off;
        }
        getOIMod(mod) {
            return this._OIM == mod;
        }
        get SOX() {
            if (this._SOX > 0) {
                return Math.min(this._SOX, this._mapMoveSpeed);
            }
            else if (this._SOX < 0) {
                return Math.max(this._SOX, -this._mapMoveSpeed);
            }
            return this._SOX;
        }
        get SOY() {
            if (this._SOY > 0) {
                return Math.min(this._SOY, this._mapMoveSpeed);
            }
            else if (this._SOY < 0) {
                return Math.max(this._SOY, -this._mapMoveSpeed);
            }
            return this._SOY;
        }
        GameOver() {
            this.Event_off();
            this.Event_RS_off();
            this.ClickUPEvent();
        }
        CreateRSImg() {
            this.InitRS_C();
            this.InitRS_D();
            this._scene.addChild(this.RS_C);
            this.RS_C.addChild(this.RS_D);
            this.InitRSPos();
        }
        InitRSPos() {
            let x = this._scene.width / 2;
            let y = (1 - this.RS_C.height / this._scene.height) * this._scene.height;
            this.RS_C.pos(x, y);
            this.RS_D.pos(this.RS_C.pivotX, this.RS_C.pivotY);
        }
        InitRS_C() {
            this.RS_C = this.CreateImg();
            this.RS_C.skin = "UI/RS_C.png";
            this.RS_C.width = 242;
            this.RS_C.height = 242;
            this.RS_C.pivot(121, 121);
        }
        InitRS_D() {
            this.RS_D = this.CreateImg();
            this.RS_D.skin = "UI/RS_D.png";
            this.RS_D.width = 84;
            this.RS_D.height = 84;
            this.RS_D.pivot(42, 42);
        }
        CreateImg() {
            let img = new Laya.Image();
            return img;
        }
        MoveRS_D(x, y) {
            if (x == 0 && y == 0) {
                this.RS_D.pos(121, 121);
            }
            else {
                let offx = x * this._rs;
                let offy = y * this._rs;
                let o = Math.atan2(offy, offx);
                let x1 = 121, y1 = 121;
                let rsx = 0;
                let rsy = 0;
                if (offx > 0) {
                    x1 = Math.min(Math.cos(o) * this._RSOffR, offx);
                }
                else if (offx < 0) {
                    x1 = Math.max(Math.cos(o) * this._RSOffR, offx);
                }
                else {
                    x1 = 0;
                }
                if (offy > 0) {
                    y1 = Math.min(Math.sin(o) * this._RSOffR, offy);
                }
                else if (offy < 0) {
                    y1 = Math.max(Math.sin(o) * this._RSOffR, offy);
                }
                else {
                    y1 = 0;
                }
                rsx = x1 / this._RSOffR;
                rsy = y1 / this._RSOffR;
                this.RS_D.pos(x1 + 121, y1 + 121);
                this._progLogic.PlayerMove(rsx, rsy);
            }
        }
    }

    class MapGridManager {
        constructor() {
            this._map = new GameMap();
            this._mapData = new MapData();
            this._operInput = new OperationInput();
            this.AddEvent();
            this.screen = Laya.stage.getChildAt(0).getChildAt(0);
        }
        AddEvent() {
            this._map.AddEvent();
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_START_END_PATH, this.GetStartPos_EndPos_Path, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_PROTAGONIST_MOVE, this.ProtagonistMove, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_AIORTROLLIS_MOVE, this.AIOrTrollIsMove, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_FIND_AROUND_BUILD, this.FindTheTarget, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_BUILDDIE, this.BuildDie, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_ROOMCOUNT, this.GetRoomCount, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_BLOCKFINDROOM, this.GetBlockIsRoom, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_SET_BLOCKWALKABLE, this.SetBlockWalkable, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_SET_BLOCKDYNWALKABLE, this.SetBlockDynWalkable, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_OPENSPACE, this.GetOpenSpace, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_MONTIORPLAYERAROUND, this.MonitorPlayerAround, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_FINDPOSBLOCK, this.FindPosBLock, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_DATAPOSTMAPPOS, this.GetDataPosTMapPos, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_MAPPOSTSCENEPOS, this.GetMapPosTScenePos, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_BLOCKPOSS, this.GetRoomBlockPos, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_GET_POSAROUND, this.GetPosAroundBuild, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_IS_SCREENRANGE, this.IsScreenRange, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_ROOMBLACK, this.RoomBlock, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.MGM_LOOKPOS, this.LookPos, this);
        }
        SelectMap(index = 0) {
            this._mapData.SelectMap(index);
            this._map.SetMapData(this._mapData);
            this._grid = new Grid(this._map.numCols, this._map.numRows);
            this._grid.mapData = this._mapData;
            this._grid.SetAllWalkable();
        }
        ShowMap() {
            this.SetScnenShowPos(20, 21);
            this._operInput.Event_RS_on();
        }
        SetScnenShowPos(x, y) {
            this._map.SetShowPoint(x, y, this.screen.width / 2, this.screen.height / 2);
            this._map.ShowPoint();
        }
        LookPos(x, y) {
            let screenMapPos = this._map.ScreenPosTMapPos(this.screen.width / 2, this.screen.height / 2);
            let screenZeroPos = this._map.ScreenPosTMapPos(0, 0);
            let screenMaxPos = this._map.ScreenPosTMapPos(this.screen.width, this.screen.height);
            let mapPanelMaxPos = this._map.MapPanelMaxPos;
            let screenMaxX = screenMaxPos.x - mapPanelMaxPos.x;
            let screenMaxY = screenMaxPos.y - mapPanelMaxPos.y;
            let offx = screenMapPos.x - x;
            let offy = screenMapPos.y - y;
            console.log("位移", screenMaxPos, mapPanelMaxPos);
            if (offx > 5) {
                if (offx >= screenZeroPos.x) {
                    offx = screenZeroPos.x - 90;
                }
            }
            else if (offx < -5) {
                if (offx < screenMaxX) {
                    offx = screenMaxX;
                }
            }
            if (offy > 5) {
                if (offy >= screenZeroPos.y) {
                    offy = screenZeroPos.y - 90;
                }
            }
            else if (offy < -5) {
                if (offy < screenMaxY) {
                    offy = screenMaxY;
                }
            }
            this._map.MoveMap(offx, offy);
            this.MoveMapLoop(0);
        }
        MoveMapLoop(index) {
            if (index > 20) {
                return;
            }
            Laya.timer.once(20, this, this.MoveMapLoop, [index + 1]);
            this._map.MoveMap(0.1, .01);
        }
        GetStartPos_EndPos_Path(startX, startY, endX, endY) {
            let startDataPos = this._map.MapPosTDataPos(startX, startY);
            let endDataPos = this._map.MapPosTDataPos(endX, endY);
            this._grid.setStartNode(startDataPos.x, startDataPos.y);
            let s = this._grid.setEndNode(endDataPos.x, endDataPos.y);
            if (s) {
                return;
            }
            let astar = new AStar();
            astar.findPath(this._grid);
            let dataPos = astar.path;
            let mapPos = this._map.GetPathMapPos(dataPos);
            return mapPos;
        }
        ProtagonistMove(x, y, RSX, RSY) {
            this.ProtagonistMapMove(x, y);
            let playerPos = this._map.MapPosTDataPos(x, y);
            let RSXBlock = this._grid.getNode(playerPos.x, playerPos.y + RSX);
            let RSYBlock = this._grid.getNode(playerPos.x + RSY, playerPos.y);
            let limit = { x: null, y: null };
            if (!RSXBlock.dynWalkable) {
                let x = this._map.DataPosTMapPos(RSXBlock.x, RSXBlock.y).x;
                limit.x = x;
            }
            if (!RSYBlock.dynWalkable) {
                let y = this._map.DataPosTMapPos(RSYBlock.x, RSYBlock.y).y;
                limit.y = y;
            }
            return limit;
        }
        MonitorPlayerAround(x, y) {
            let dataMap = this._map.MapPosTDataPos(x, y);
            let s = this._mapData.FindPlayerAround(dataMap.x, dataMap.y);
            if (s == null) {
                return null;
            }
            else {
                let block = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDBLOCKPOS, (s.x + "_" + s.y));
                if (block == null) {
                    return null;
                }
                else {
                    return { build: s.build, block: block };
                }
            }
        }
        AIOrTrollIsMove(x, y) {
            let dataPos = this._map.MapPosTDataPos(x, y);
            let node = this._grid.getNode(dataPos.x, dataPos.y);
            let roomIndex = this._mapData.BlockFindRoom(dataPos.x, dataPos.y);
            if (node.dynWalkable) {
                return null;
            }
            else {
                return EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDBLOCKPOS, (dataPos.x + "_" + dataPos.y), roomIndex);
            }
        }
        FindPosBLock(x, y) {
            let dataPos = this._map.MapPosTDataPos(x, y);
            let pos = dataPos.x + "_" + dataPos.y;
            return EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDBLOCKPOS, pos);
        }
        ProtagonistMapMove(x, y) {
            let playerScreenPos = this._map.MapPosTScreenPos(x, y);
            let moveSpeed_X = 0;
            let moveSpeed_Y = 0;
            let countWidth = this.screen.width / 2;
            let countHeight = this.screen.height / 2;
            moveSpeed_X = countWidth - playerScreenPos.x;
            moveSpeed_Y = countHeight - playerScreenPos.y;
            this._map.MoveMap(moveSpeed_X, moveSpeed_Y);
        }
        FindTheTarget(x, y) {
            let trolldataPos = this._map.MapPosTDataPos(x, y);
            let buildArr = this._mapData.GetAroundBuild(trolldataPos.x, trolldataPos.y, 6);
            return buildArr;
        }
        GetRoomCount() {
            return this._mapData.GetRoomCount();
        }
        GetBlockIsRoom(x, y) {
            let dataMap = this._map.MapPosTDataPos(x, y);
            let room = this._mapData.BlockFindRoom(dataMap.x, dataMap.y);
            return room;
        }
        SetBlockWalkable(x, y, walkable) {
            let dataMap = this._map.MapPosTDataPos(x, y);
            this._grid.setWalkable(dataMap.x, dataMap.y, walkable);
        }
        SetBlockDynWalkable(x, y, walkable) {
            let dataMap = this._map.MapPosTDataPos(x, y);
            this._grid.setDynWalkable(dataMap.x, dataMap.y, walkable);
        }
        GetOpenSpace(roomIndex, isAt = false) {
            let blockPos = this._mapData.GetOpenSpace(roomIndex, isAt);
            return blockPos;
        }
        BuildDie(x, y, build) {
            let dataMap = this._map.MapPosTDataPos(x, y);
            this._mapData.readMap(dataMap.x, dataMap.y).inBlock = 0;
            this.SetBlockDynWalkable(x, y, true);
        }
        GetDataPosTMapPos(x, y) {
            let mapPos = this._map.DataPosTMapPos(x, y);
            return [mapPos.x, mapPos.y];
        }
        GetMapPosTScenePos(x, y) {
            let scene = this._map.MapPosTScreenPos(x, y);
            return [scene.x, scene.y];
        }
        GetRoomBlockPos(roomIndex) {
            let room = this._mapData.GetRoom(roomIndex);
            if (room != undefined) {
                let roomblocks = room.room;
                let poss = [];
                for (let i = 0; i < roomblocks.length; i++) {
                    let element = roomblocks[i].split("_");
                    let arr = this._map.DataPosTMapPos(parseInt(element[0]), parseInt(element[1]));
                    poss.push(arr);
                }
                return poss;
            }
            return null;
        }
        GameOver() {
            this._operInput.GameOver();
            this._mapData.GameOver();
            this._map.GameOver();
            delete this._grid;
        }
        GetPosAroundBuild(x, y, build, r) {
            let pos = this._map.MapPosTDataPos(x, y);
            let arr = this._mapData.GetPosAroundBuild(pos.x, pos.y, build, r);
            return arr;
        }
        IsScreenRange(x, y) {
            return this._map.IsScreenRange(x, y);
        }
        RoomBlock(roomIndex) {
            let roomBuildPoss = this.GetRoomBlockPos(roomIndex);
            if (roomBuildPoss == null) {
                return;
            }
            this._map.RoomBlack(roomBuildPoss);
        }
    }

    class CoupleController_Player {
        Move(player, path) {
            let moveoff = player.speed;
            let pos = path;
            let xdiff = player.x - pos[0];
            let ydiff = player.y - pos[1];
            var diffCount = Math.abs(xdiff) + Math.abs(ydiff);
            if (xdiff > 0) {
                player.x -= moveoff * (Math.abs(xdiff) / diffCount);
                player.direction = -1;
            }
            else if (xdiff < 0) {
                player.x += moveoff * (Math.abs(xdiff) / diffCount);
                player.direction = 1;
            }
            if (ydiff > 0) {
                player.y -= moveoff * (Math.abs(ydiff) / diffCount);
                player.player.zOrder = player.y;
            }
            else if (ydiff < 0) {
                player.y += moveoff * (Math.abs(ydiff) / diffCount);
                player.player.zOrder = player.y;
            }
            if (Math.abs(xdiff) < moveoff) {
                player.x = pos[0];
            }
            if (Math.abs(ydiff) < moveoff) {
                player.y = pos[1];
            }
            if (player.x == pos[0] && player.y == pos[1]) {
                return true;
            }
            else {
                return false;
            }
        }
        GoToBed(player, block) {
            player.player.visible = false;
            player.player.stop();
            player.player.pos(block.x, block.y);
            player.bed = block;
            EventCenter.instance.Fire(EventCenter.instance.BUILD_GOTOBED, block, player.id);
        }
    }

    class PlayerAILogic {
        constructor() {
            this._build = [["game_1", "at_1"], ["ice_1", "barb_1", "particlea_1", "spell_1", "entrapment_1", "guillotine_1", "energyhood_1", "smoney_1", "longrange_1", "solenoid_1", "repair_1", "mine_1", "mine_2", "mine_3", "mine_4"]];
            this._bed_4 = ["game_1", "at_1"];
            this._AILevelNum = 4;
            this._AILevelArr = [
                [1.6, 1.7, 1.8, 1.9, 2.0],
                [1.3, 1.4, 1.5, 1.6, 1.7],
                [1.2, 1.3, 1.4, 1.5, 1.6],
                [1.1, 1.2, 1.3, 1.4, 1.5],
                [1, 1.05, 1.1, 1.15, 1.2]
            ];
            this._AI = {
                player: [],
                room: [],
                bed: [],
                target: [],
                path: [],
                build: [],
                nextBuild: [],
                weight: []
            };
            this._noTarget = [];
            this.CC_Player = new CoupleController_Player();
        }
        StartGame() {
            this.FindRoom();
            this.RetestAI();
            this.GetPath();
            this.AddMoveHandle();
            this.AIGoTobedOver();
            TimeManager.instance.AddTimeLoopEvent("GoldCoinDetection", this.GoldCoinDetection, this, 1);
            this.RandomAILevel();
        }
        RandomAILevel() {
            this._AILevelNum = Math.floor(Math.random() * this._AILevelArr.length);
        }
        AddMoveHandle() {
            UpEventHandle.instance.AddUPEvent("AIMove", this.PlayerMoveHandle, this);
        }
        RemoveMoveHandle() {
            UpEventHandle.instance.removeListEvent("AIMove");
            TimeManager.instance.RemoveListLoopEvent("GoldCoinDetection");
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.PAIL_FILTERDIEAI, this.FilterDieAI, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.PAIL_KILLPLAYER, this.KillPlayer, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.PAIL_SET_ATTACKEDAI, this.setAttackedAI, this);
        }
        FindRoom() {
            let roomCount = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_ROOMCOUNT);
            let indexArr = [];
            for (let i = 0; i < roomCount; i++) {
                indexArr.push(i);
            }
            for (let i = 0; i < this._AI.player.length; i++) {
                let ran = Math.floor(Math.random() * indexArr.length);
                let roomindex = indexArr[ran];
                indexArr.splice(ran, 1);
                let room = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDBEDANDDOOR, roomindex);
                if (room != null && !room.bed.isOpen) {
                    this._AI.bed.push(room.bed);
                    if (room.door.isOpen) {
                        this._AI.target.push(room.bed);
                    }
                    else {
                        this._AI.target.push(room.door);
                    }
                }
                else {
                    this._AI.bed.push(null);
                    this._AI.target.push(null);
                    this._noTarget.push(i);
                }
                this._AI.path.push(null);
            }
        }
        GetPath() {
            for (let i = 0; i < this._AI.player.length; i++) {
                this.SetPath(i);
            }
        }
        SetPath(index) {
            let player = this._AI.player[index];
            let target = this._AI.target[index];
            if (target != null) {
                let path = EventCenter.instance.FireReturn(EventCenter.instance.MGM_START_END_PATH, player.x, player.y, target.x, target.y);
                this._AI.path[index] = path;
            }
            else {
                this._AI.path[index] = null;
            }
        }
        RetestAI() {
            let count = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_ROOMCOUNT);
            for (let i = 0; i < count; i++) {
                let room = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDBEDANDDOOR, i);
                if (!room.bed && room.bed == null) {
                    continue;
                }
                if (!room.bed.isOpen && room.bed.isUse) {
                    if (this._noTarget.length > 0) {
                        let playerindex = this._noTarget.shift();
                        this._AI.bed[playerindex] = room.bed;
                        if (room.door.isOpen) {
                            this._AI.target[playerindex] = room.bed;
                        }
                        else {
                            this._AI.target[playerindex] = room.door;
                        }
                    }
                    else {
                        return;
                    }
                }
            }
        }
        PlayerMoveHandle() {
            for (let i = 0; i < this._AI.player.length; i++) {
                let player = this._AI.player[i];
                let paths = this._AI.path[i];
                if (!player.isDie) {
                    continue;
                }
                if (paths != null && paths.length > 0) {
                    if (this.CC_Player.Move(player, paths[0])) {
                        paths.shift();
                        if (paths.length == 0) {
                            if (this._AI.bed[i].isOpen && this._AI.bed[i].isUse) {
                                this._AI.bed[i] = null;
                                this._AI.target[i] = null;
                                this._noTarget.push(i);
                                this.RetestAI();
                                this.SetPath(i);
                            }
                            else {
                                this.CC_Player.GoToBed(player, this._AI.bed[i]);
                                player.roomIndex = player.curRoom;
                                this._AI.room[i] = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDROOM, player.roomIndex);
                                player.isbed = true;
                                this.UpOrBuild(i);
                            }
                        }
                        else {
                            player.curRoom = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_BLOCKFINDROOM, player.x, player.y);
                            if (player.curRoom == -1) {
                                player.isRoom = false;
                            }
                            else {
                                player.isRoom = true;
                            }
                            if (this._AI.bed[i].isOpen && this._AI.bed[i].isUse) {
                                this._AI.bed[i] = null;
                                this._AI.target[i] = null;
                                this._noTarget.push(i);
                                this.RetestAI();
                                this.SetPath(i);
                            }
                        }
                    }
                }
            }
        }
        set players(value) {
            this._AI.player = value;
        }
        FilterDieAI() {
            for (let i = this._AI.player.length - 1; i >= 0; i--) {
                let player = this._AI.player[i];
                if (!player.isDie) {
                    this._AI.player.splice(i, 1);
                }
            }
        }
        GoldCoinDetection() {
            this.AttackedAIEventHandle();
            for (let i = 0; i < this._AI.player.length; i++) {
                let player = this._AI.player[i];
                if (!player.isDie) {
                    continue;
                }
                if (!player.isbed) {
                    continue;
                }
                let gold = DataManager.instance.game.GetRoomPR(player.roomIndex);
                let str = "";
                if (this._AI.nextBuild[i].build == null) {
                    if (this._AI.nextBuild[i].upbuild == null || !this._AI.nextBuild[i].upbuild.isUse) {
                        str = "";
                    }
                    else {
                        let level = this._AI.nextBuild[i].upbuild.level + 1;
                        str = this._AI.nextBuild[i].upbuild.name + "_" + level;
                    }
                }
                else {
                    str = this._AI.nextBuild[i].build;
                }
                let strs = str.split("_");
                let buildInfo = DataManager.instance.build.GetBuildData(strs[0], parseInt(strs[1]));
                if (buildInfo != undefined) {
                    if (gold.gold1 >= buildInfo[1] && gold.gold2 >= buildInfo[2]) {
                        if (this._AI.nextBuild[i].build == null) {
                            gold.gold1 -= buildInfo[1];
                            gold.gold2 -= buildInfo[2];
                            EventCenter.instance.Fire(EventCenter.instance.MAP_UPBUILD, this._AI.nextBuild[i].upbuild.build, str);
                            let pos = this._AI.nextBuild[i].upbuild.build.x + "_" + this._AI.nextBuild[i].upbuild.build.y;
                            EventCenter.instance.Fire(EventCenter.instance.BUILD_UPBUILD, pos, this._AI.nextBuild[i].upbuild);
                            if (parseInt(strs[1]) > 5) {
                                let room = this._AI.room[i];
                                if (room.prLevel == 1) {
                                    let ran = Math.floor(Math.random() * this._AILevelArr[this._AILevelNum].length);
                                    room.prLevel = this._AILevelArr[this._AILevelNum][ran];
                                }
                            }
                        }
                        else {
                            let blockPos = null;
                            if (strs[0] == "at") {
                                blockPos = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_OPENSPACE, player.roomIndex, true);
                            }
                            else {
                                blockPos = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_OPENSPACE, player.roomIndex);
                            }
                            if (blockPos != null) {
                                gold.gold1 -= buildInfo[1];
                                gold.gold2 -= buildInfo[2];
                                EventCenter.instance.Fire(EventCenter.instance.MAP_BUILD_NEW, blockPos.x, blockPos.y, str);
                            }
                        }
                        this._AI.nextBuild[i].build = null;
                        this._AI.nextBuild[i].mod = null;
                        this._AI.nextBuild[i].upbuild = null;
                        this.UpOrBuild(i);
                    }
                    else {
                        let ran = Math.random();
                        if (ran < 0.2) {
                            this._AI.nextBuild[i].build = null;
                            this._AI.nextBuild[i].mod = null;
                            this._AI.nextBuild[i].upbuild = null;
                            this.UpOrBuild(i);
                        }
                    }
                }
                else {
                    this._AI.nextBuild[i].build = null;
                    this._AI.nextBuild[i].mod = null;
                    this._AI.nextBuild[i].upbuild = null;
                    this.UpOrBuild(i);
                }
            }
        }
        UpOrBuild(index) {
            if (this._AI.nextBuild[index].mod == null) {
                this.GetAiBuild(index);
                let builds = [[], [], [], []];
                for (let i = 0; i < this._AI.build[index].length; i++) {
                    let build = this._AI.build[index][i];
                    let str = build.name;
                    if (str == "bed") {
                        builds[0].push(build);
                    }
                    else if (str == "at") {
                        builds[1].push(build);
                    }
                    else if (str == "door") {
                        builds[2].push(build);
                    }
                    else if (str == "game") {
                        builds[3].push(build);
                    }
                }
                if (!(builds[0].length > 0 && builds[2].length > 0)) {
                    return;
                }
                let bed = builds[0][0];
                let door = builds[2][0];
                if (bed.level < 5) {
                    // console.log("五级钱");
                    let ran = Math.random();
                    if (ran < 0.7) {
                        if (bed.level == 10) {
                            this._AI.nextBuild[index].mod = 1;
                            this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                        }
                        else {
                            this._AI.nextBuild[index].upbuild = builds[0][0];
                        }
                    }
                    else if (ran < 0.75) {
                        if (builds[1].length > 0) {
                            let buildRan = Math.floor(Math.random() * builds[1].length);
                            this._AI.nextBuild[index].upbuild = builds[1][buildRan];
                        }
                        else {
                            this._AI.nextBuild[index].mod = 1;
                            this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                        }
                    }
                    else {
                        if (door.level == 13) {
                            this._AI.nextBuild[index].mod = 0;
                            this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                        }
                        else {
                            this._AI.nextBuild[index].upbuild = builds[2][0];
                        }
                    }
                }
                else {
                    console.log("五级厚");
                    let ranUp = Math.random();
                    if (ranUp < 0.65) {
                        let ran = Math.random();
                        if (ran < 0.4) {
                            if (bed.level == 10) {
                                this._AI.nextBuild[index].mod = 1;
                                this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                            }
                            else {
                                this._AI.nextBuild[index].upbuild = builds[0][0];
                            }
                        }
                        else if (ran < 0.7) {
                            if (builds[1].length > 0) {
                                let buildRan = Math.floor(Math.random() * builds[1].length);
                                this._AI.nextBuild[index].upbuild = builds[1][buildRan];
                            }
                            else {
                                this._AI.nextBuild[index].mod = 1;
                                this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                            }
                        }
                        else if (ran < 0.85) {
                            if (door.level == 13) {
                                this._AI.nextBuild[index].mod = 0;
                                this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                            }
                            else {
                                this._AI.nextBuild[index].upbuild = builds[2][0];
                            }
                        }
                        else {
                            if (builds[3].length > 0) {
                                let buildRan = Math.floor(Math.random() * builds[3].length);
                                this._AI.nextBuild[index].upbuild = builds[3][buildRan];
                            }
                            else {
                                this._AI.nextBuild[index].mod = 0;
                                this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                            }
                        }
                    }
                    else {
                        let buildMod = Math.random();
                        let ran = 1;
                        if (builds[3].length > 0) {
                            for (let i = 0; i < builds.length; i++) {
                                let game = builds[3][i];
                                if (game) {
                                    if (game.level >= 2) {
                                        ran = 0.5;
                                        break;
                                    }
                                }
                            }
                        }
                        if (buildMod < ran) {
                            let ranBuild = Math.floor(Math.random() * this._build[0].length);
                            if (builds[3].length > 7) {
                                ranBuild = 1;
                            }
                            this._AI.nextBuild[index].mod = ranBuild;
                            this._AI.nextBuild[index].build = this._build[0][this._AI.nextBuild[index].mod];
                        }
                        else {
                            let ranBuild = Math.floor(Math.random() * this._build[1].length);
                            this._AI.nextBuild[index].mod = ranBuild;
                            this._AI.nextBuild[index].build = this._build[1][this._AI.nextBuild[index].mod];
                        }
                    }
                }
            }
        }
        AIGoTobedOver() {
            this._AI.build = [];
            for (let i = 0; i < this._AI.player.length; i++) {
                this._AI.build.push(null);
                this._AI.nextBuild.push({ mod: null, upbuild: null, build: null });
            }
        }
        GetAiBuild(index) {
            let player = this._AI.player[index];
            let builds = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_GET_ROOMALLBLOCK, player.roomIndex);
            if (builds.length > 0) {
                this._AI.build[index] = builds;
            }
        }
        GameOver() {
            this._AI = {
                player: [],
                room: [],
                bed: [],
                target: [],
                path: [],
                build: [],
                nextBuild: [],
                weight: []
            };
            this._noTarget = [];
            this._attackedAI = null;
        }
        KillPlayer(block) {
            if (this._AI.player.length > 0) {
                for (let i = 0; i < this._AI.player.length; i++) {
                    let player = this._AI.player[i];
                    if (player.isbed && player.roomIndex == block.room.roomIndex) {
                        player.Hit(500);
                        return;
                    }
                }
            }
        }
        setAttackedAI(roomIndex) {
            if (this._AI.room.length > 0) {
                for (let i = 0; i < this._AI.room.length; i++) {
                    let room = this._AI.room[i];
                    if (room && room.roomIndex == roomIndex) {
                        this._attackedAI = i;
                        return;
                    }
                }
            }
            this._attackedAI = null;
        }
        AttackedAIEventHandle() {
            if (this._attackedAI == null) {
                return;
            }
            let room = this._AI.room[this._attackedAI];
            let door = room.door;
            if (this._AI.nextBuild[this._attackedAI].upbuild != door && door.hp < 0.5) {
                this._AI.nextBuild[this._attackedAI].build = null;
                this._AI.nextBuild[this._attackedAI].mod = null;
                this._AI.nextBuild[this._attackedAI].upbuild = door;
            }
        }
    }

    class CoupleController_Troll {
        constructor() {
            this._path = null;
        }
        FindTheTarget() {
        }
        AddUpEvent() {
        }
        Move() {
            if (this._path == null) {
                return;
            }
            if (!this._troll.StateDetection(trollState.move) && !this._troll.StateDetection(trollState.escape)) {
                return;
            }
            if (this._troll.StateDetection(trollState.vertigo)) {
                return;
            }
            if (this._path.length > 0) {
                let block = EventCenter.instance.FireReturn(EventCenter.instance.MGM_AIORTROLLIS_MOVE, this._path[0][0], this._path[0][1]);
                if (block != null) {
                    EventCenter.instance.Fire(EventCenter.instance.TL_STARTATTACK, block);
                    this._path = null;
                    return;
                }
                let moveoff = this._troll.speed;
                let pos = this._path[0];
                let xdiff = this._troll.x - pos[0];
                let ydiff = this._troll.y - pos[1];
                var diffCount = Math.abs(xdiff) + Math.abs(ydiff);
                let hps = this._troll.gethpStrip();
                if (xdiff > 0) {
                    this._troll.x -= moveoff * (Math.abs(xdiff) / diffCount);
                    this._troll.troll.scaleX = -1;
                    if (hps != null) {
                        hps.scaleX = -1;
                    }
                }
                else if (xdiff < 0) {
                    this._troll.x += moveoff * (Math.abs(xdiff) / diffCount);
                    this._troll.troll.scaleX = 1;
                    if (hps != null) {
                        hps.scaleX = 1;
                    }
                }
                if (xdiff > 0) {
                    this._troll.x -= moveoff * (Math.abs(xdiff) / diffCount);
                }
                else if (xdiff < 0) {
                    this._troll.x += moveoff * (Math.abs(xdiff) / diffCount);
                }
                if (ydiff > 0) {
                    this._troll.y -= moveoff * (Math.abs(ydiff) / diffCount);
                    this._troll.troll.zOrder = this._troll.y;
                }
                else if (ydiff < 0) {
                    this._troll.y += moveoff * (Math.abs(ydiff) / diffCount);
                    this._troll.troll.zOrder = this._troll.y;
                }
                if (Math.abs(xdiff) < moveoff) {
                    this._troll.x = pos[0];
                }
                if (Math.abs(ydiff) < moveoff) {
                    this._troll.y = pos[1];
                }
                if (this._troll.x == pos[0] && this._troll.y == pos[1]) {
                    Sound.instance.PlaySound(Sound.instance.TB_sound.troll_Wll, 1, this._troll.x, this._troll.y);
                    if (this._path.length == 1) {
                        this._path = null;
                        EventCenter.instance.Fire(EventCenter.instance.TL_MOVEOVER_HANDLE);
                    }
                    else {
                        this._path.shift();
                        EventCenter.instance.Fire(EventCenter.instance.TL_MOVESELECT_HANDLE);
                    }
                }
            }
        }
        set troll(value) {
            this._troll = value;
        }
        set path(value) {
            this._path = value;
        }
        get path() {
            return this._path;
        }
    }

    var TrollLogicState;
    (function (TrollLogicState) {
        TrollLogicState[TrollLogicState["justfierce"] = 0] = "justfierce";
        TrollLogicState[TrollLogicState["healthy"] = 1] = "healthy";
        TrollLogicState[TrollLogicState["weak"] = 2] = "weak";
        TrollLogicState[TrollLogicState["counselled"] = 3] = "counselled";
    })(TrollLogicState || (TrollLogicState = {}));
    class TrollLogic {
        constructor() {
            this._aroundBuild = [];
            this.logicState = TrollLogicState.justfierce;
            this._Uptime = null;
            this._moveOverHandle = null;
            this._moveSelectHandle = null;
            this._UpDatahandle = null;
            this._homeTime = 0;
            this._eTime = 0;
            this._aeTime = 0;
            this._eTimePro = 0.5;
            this._eHpPro = 0.3;
            this.CC_troll = new CoupleController_Troll();
            this.AddEvent();
        }
        GameOver() {
            Laya.timer.clearAll(this);
            this._aroundBuild = [];
            this._aroundPlayer = undefined;
            this._curAtPlayer = undefined;
            this._attackTarget = undefined;
            this.logicState = TrollLogicState.justfierce;
            this._moveOverHandle = null;
            this._moveSelectHandle = null;
            this._UpDatahandle = null;
            this._Uptime = null;
            this._attackTime = null;
            this._homeTime = 0;
            this._troll.troll.removeSelf();
            this.CC_troll.path = null;
        }
        StartGame() {
            this._eTimePro = DataManager.instance.troll.eTimePro;
            this._eHpPro = DataManager.instance.troll.eHpPro;
        }
        set troll(value) {
            this._troll = value;
            this.CC_troll.troll = value;
        }
        get troll() {
            return this._troll;
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_GET_AROUNDPLAYER, this.GetTrollAroundPlayer, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_MOVESELECT_HANDLE, this.MoveSelectHandle, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_MOVEOVER_HANDLE, this.MoveOverHander, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_STARTATTACK, this.StartAttack, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_TROLLHIT, this.Hit, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_MOVESPEED_REDUCTION, this.MoveSpeedReduction, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.TL_VERTIGO_REDUCTION, this.VertigoReduction, this);
        }
        UpData() {
            if (this._Uptime != null) {
                if (TimeManager.instance.AfterAPeriodOfTime_Bool(this._Uptime, 0.5)) {
                    this.Reduction();
                    this._Uptime = TimeManager.instance.gameTime;
                }
            }
            if (this._troll.IsPlayIndex(trollAnim.move)) {
                this.CC_troll.Move();
            }
            if (this._UpDatahandle != null) {
                this._UpDatahandle();
            }
        }
        TrollAttack() { 
            this._troll.troll.play(1, false);
            this._troll.Attack();
            if (TimeManager.instance.AfterAPeriodOfTime_Bool(this._attackTime, 20)) {
                this._troll.TrollSkill();
                this._attackTime = Number.MAX_VALUE;
            }
            if (!(this._attackTarget == null || this._attackTarget.x == null || this._attackTarget.y == null)) {
                Sound.instance.PlaySound(Sound.instance.TB_sound.troll_attack, 1, this._troll.x, this._troll.y);
                EffectSequence.instance.AddEffect(EffectSequence.instance.effectStr.trollAttackEffect, this._attackTarget.x, this._attackTarget.y);
                let die = this._attackTarget.Hit(this._troll.power);
                if (this._curAtPlayer != this._attackTarget) {
                    this._troll.AttackEvent(this._attackTarget);
                }
                if (!die) {
                    
                    // console.log("当前玩家名字==",this._curAtPlayer.instance.name);
                    if (this._curAtPlayer != null && (this._curAtPlayer.bed == this._attackTarget || this._curAtPlayer == this._attackTarget)) {
                        this.PlayerDie(this._curAtPlayer);
                    }
                    else {
                        if (this._curAtPlayer == null) {
                            this.AttackBuild();
                        }
                        else {
                            if (this._curAtPlayer.bed != null) {
                                this._attackTarget = this._curAtPlayer.bed;
                            }
                            else {
                                this.AttackBuild();
                            }
                        }
                        this.SetMovePath();
                    }
                }
            }
        }
        PlayerDie(player) {
            if (!player || player == null) {
                return;
            }
            player.Hit(500);
            let bed = player.bed;
            player.bed = null;
            EventCenter.instance.Fire(EventCenter.instance.BUILD_SET_ROOM_DIE, player.roomIndex);
            EventCenter.instance.Fire(EventCenter.instance.MGM_ROOMBLACK, player.roomIndex);
            if (bed != null && bed.isUse) {
                bed.GameOver();
            }
            EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "玩家：" + player.name + "已被淘汰！");
            if (player.isGod) {
                EventCenter.instance.Fire(EventCenter.instance.GM_GAMEOVER);
            }
            else {
                this.FindPlayer();
                this.SetMovePath();
            }
        }
        BloodVolumeDetector() {
            if (this._troll.StateDetection(trollState.escape)) {
                return;
            }
            if (this._troll.hp <= this._eHpPro) {
                this.Escape();
            }
        }
        TrollPatrol() {
            let count = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_ROOMCOUNT);
            let ran = Math.floor(Math.random() * count);
            let room = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDBEDANDDOOR, ran);
            if (room.door.isOpen) {
                this._attackTarget = room.bed;
            }
            else {
                this._attackTarget = room.door;
            }
            this._moveSelectHandle = this.Chase;
            this._moveOverHandle = this.SelectDaquan;
            this._UpDatahandle = null;
            this.SetMovePath();
        }
        SelectDaquan() {
            let ren = Math.floor(Math.random() * 2);
            switch (ren) {
                case 0:
                    this.TrollPatrol();
                    break;
                case 1:
                    this.FindPlayer();
                    break;
            }
        }
        AttackBuild() {
            this.GetTrollAroundPlayer();
            if (this._aroundPlayer.length > 0) {
                this._curAtPlayer = this._aroundPlayer[0];
                this._attackTarget = this._curAtPlayer;
                this.SetMovePath();
            }
            else {
                if (this._aroundBuild.length <= 3) {
                    this._aroundBuild = EventCenter.instance.FireReturn(EventCenter.instance.MGM_FIND_AROUND_BUILD, this._troll.x, this._troll.y);
                }
                if (this._aroundBuild.length > 0) {
                    let pos = this._aroundBuild.shift();
                    let block = EventCenter.instance.FireReturn(EventCenter.instance.MGM_FINDPOSBLOCK, pos[0], pos[1]);
                    this._attackTarget = block;
                }
                else {
                    this.FindPlayer();
                }
            }
        }
        FindPlayer() {
            let players = this.players;
            let ran = Math.floor(Math.random() * players.length);
            let player = players[ran];
            if (!player.isDie) {
                this.FindPlayer();
            }
            else {
                this._curAtPlayer = players[ran];
                if (this._curAtPlayer.isRoom) {
                    let door = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDDOOR, this._curAtPlayer.curRoom);
                    if (door != null && !door.isOpen) {
                        this._attackTarget = door;
                    }
                    else {
                        this._attackTarget = this._curAtPlayer;
                    }
                }
                else {
                    this._attackTarget = this._curAtPlayer;
                }
                this._UpDatahandle = null;
                this._moveSelectHandle = this.Chase;
                this._moveOverHandle = this.Chase;
                this.SetMovePath();
            }
        }
        SetMovePath() {
            let path = EventCenter.instance.FireReturn(EventCenter.instance.MGM_START_END_PATH, this._troll.x, this._troll.y, this._attackTarget.x, this._attackTarget.y);
            if (path == null || !path || path.length == 0) {
                this.AttackBuild();
            }
            else {
                this.CC_troll.path = path;
                if (!this._troll.IsPlayIndex(trollAnim.move)) {
                    this._troll.setplay(trollAnim.move, true);
                }
                this._troll.state = trollState.move;
                Sound.instance.PlaySound(Sound.instance.TB_sound.troll_Wll, 1, this._troll.x, this._troll.y);
            }
        }
        Chase() {
            this.GetTrollAroundPlayer();
            if (this._aroundPlayer.length > 0) {
                let ran = Math.floor(Math.random() * this._aroundPlayer.length);
                this._curAtPlayer = this._aroundPlayer[ran];
                this._attackTarget = this._curAtPlayer;
                this.SetMovePath();
                this._UpDatahandle = null;
                this._moveSelectHandle = null;
                this._moveOverHandle = this.StartAttack;
            }
            else if (this.CC_troll.path == null) {
                this.FindPlayer();
            }
        }
        Escape() {
            if (this.troll.StateDetection(trollState.escape) || this.troll.StateDetection(trollState.vertigo)) {
                return;
            }
            this._troll.state = trollState.escape;
            let pos = DataManager.instance.build.GetTrollPos();
            this._UpDatahandle = null;
            this._moveSelectHandle = null;
            pos = EventCenter.instance.FireReturn(EventCenter.instance.MGM_GET_DATAPOSTMAPPOS, pos[0], pos[1]);
            let path = EventCenter.instance.FireReturn(EventCenter.instance.MGM_START_END_PATH, this._troll.x, this._troll.y, pos[0], pos[1]);
            if (path == null) {
                this.Escape();
                return;
            }
            this.CC_troll.path = path;
            this._moveOverHandle = this.EscapeMoveOverHandle;
            if (!this._troll.IsPlayIndex(trollAnim.move)) {
                this._troll.setplay(trollAnim.move, true);
            }
            EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, this._attackTarget.roomIndex, 1);
            this.troll.Escape();
        }
        EscapeMoveOverHandle() {
            this._homeTime = TimeManager.instance.gameTime;
            this._moveOverHandle = null;
            this._UpDatahandle = this.HomeUpHandle;
        }
        HomeUpHandle() {
            if (TimeManager.instance.AfterAPeriodOfTime_Bool(this._homeTime, 1)) {
                this._homeTime = TimeManager.instance.gameTime;
                this.HomeBB();
            }
        }
        HomeBB() {
            this._troll.hpCur += this._troll.hpMax * 0.1;
            if (this._troll.hp == 1) {
                this._UpDatahandle = null;
                this.FindPlayer();
            }
        }
        MoveOverHander() {
            if (this._moveOverHandle == null) {
                return;
            }
            else {
                this._moveOverHandle();
            }
        }
        MoveSelectHandle() {
            if (this._moveSelectHandle == null) {
                return;
            }
            else {
                this._moveSelectHandle();
            }
        }
        AttackHandle() {
            if (this._troll.StateDetection(trollState.attack)) {
                if (TimeManager.instance.AfterAPeriodOfTime_Bool(this._troll.lastAtTime, this._troll.atSpeed)) {
                    this._troll.lastAtTime = TimeManager.instance.gameTime;
                    if (this.AtRadius(this._attackTarget.x, this._attackTarget.y)) {
                        if (this._attackTime == null) {
                            this._attackTime = TimeManager.instance.gameTime;
                        }
                        this.TrollAttack();
                    }
                    else {
                        this.Chase();
                    }
                }
                if (TimeManager.instance.AfterAPeriodOfTime_Bool(this._eTime, this.aeTime)) {
                    this._eTime = TimeManager.instance.gameTime;
                    let ran = Math.random();
                    if (ran < this._eTimePro) {
                        if (this.troll.hp > 0.5) {
                            this.FindPlayer();
                        }
                        else {
                            this.Escape();
                        }
                    }
                }
            }
        }
        StartAttack(block = null) {
            if (block != null) {
                this._attackTarget = block;
                this.troll.StartAttack(this._attackTarget);
                EventCenter.instance.Fire(EventCenter.instance.BUILD_HANDLEROOMBUFF, block.roomIndex, 2);
                EventCenter.instance.Fire(EventCenter.instance.PAIL_SET_ATTACKEDAI, block.roomIndex);
                if (this._curAtPlayer) {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_PLAYERHITEFFECT, this._curAtPlayer.uid);
                }
            }
            this._UpDatahandle = this.AttackHandle;
            this.troll.state = trollState.attack;
            this._Uptime = TimeManager.instance.gameTime;
            this._eTime = TimeManager.instance.gameTime;
        }
        Hit(power, roomIndex) {
            if (this._troll.hp <= 0) {
                return;
            }
            let HpUp = Laya.LocalStorage.getItem("HpUp");
            // console.log("猛鬼受伤：HpUp=="+HpUp+"   this._troll.hp=="+this._troll.hp +"   power=="+power);
            if(HpUp==1){
                power = power/3;
            }
            this._troll.hit(power);
            if (this._troll.hp <= 0) {
                let name = PlayerManager.instance.GetPlayerName(roomIndex);
                if (name == null) {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼被神秘玩家击败");
                }
                else {
                    EventCenter.instance.Fire(EventCenter.instance.UIGM_TIPS, "猛鬼被" + name + "击败");
                }
                if (roomIndex == PlayerManager.instance.player.roomIndex) {
                    DataManager.instance.game.isMvp = true;
                }
                else {
                    DataManager.instance.game.isMvp = false;
                }
                DataManager.instance.game.mvpIndex = PlayerManager.instance.GetPlayerSkinId(roomIndex);
                EventCenter.instance.Fire(EventCenter.instance.GM_GAMEOVER, true);
                return;
            }
            if (this._troll.StateDetection(trollState.escape)) {
                return;
            }
            this.BloodVolumeDetector();
        }
        get players() {
            return PlayerManager.instance.playerSorts;
        }
        GetTrollAroundPlayer() {
            let palyerArr = [];
            let players = this.players;
            for (let i = 0; i < players.length; i++) {
                let player = players[i];
                if (!player.isDie) {
                    continue;
                }
                if (player.curRoom != -1) {
                    let door = EventCenter.instance.FireReturn(EventCenter.instance.BUILD_FINDDOOR, player.curRoom);
                    if (door != null && !door.isOpen) {
                        continue;
                    }
                }
                let x = Math.abs(player.x - this._troll.x);
                let y = Math.abs(player.y - this._troll.y);
                let r = x * x + y * y;
                if (r < this._troll.r) {
                    palyerArr.push(player);
                }
            }
            this._aroundPlayer = palyerArr;
        }
        AtRadius(x, y) {
            let a = Math.abs(this._troll.x - x);
            let b = Math.abs(this._troll.y - y);
            let r = a * a + b * b;
            if (r <= this._troll.atR) {
                return true;
            }
            return false;
        }
        MoveSpeedReduction(num) {
            this._troll.speedScale -= num;
            this._troll.moveSpeedTime = TimeManager.instance.gameTime;
        }
        VertigoReduction(num = 0) {
            this._troll.vertigoTime = num;
        }
        Reduction() {
            if (this._troll.StateDetection(trollState.vertigo) && TimeManager.instance.AfterAPeriodOfTime_Bool(this._troll.startVertiogTime, this._troll.vertigoTime)) {
                this.VertigoReduction();
            }
        }
        get aeTime() {
            if (this._troll.level >= 5) {
                this._aeTime = 20;
            }
            else {
                this._aeTime = 10;
            }
            return this._aeTime;
        }
    }

    class MainTPLgic {
        constructor() {
            this._trollThawTime = 30;
            this._trollLgoic = new TrollLogic();
            this._playerAILogic = new PlayerAILogic();
            this._playerAILogic.AddEvent();
            EventCenter.instance.AddListEvent(EventCenter.instance.MAINLG_TROLLUPDATA, this.TrollUpData, this);
        }
        StartGame() {
            this._trollLgoic.StartGame();
            this._trollLgoic.troll = TrollManager.instance.trollSprict;
            this._playerAILogic.players = PlayerManager.instance.players;
            TimeManager.instance.AddTimeOnceEvent("player", this.player, this, 1);
        }
        GameOver() {
            this._trollLgoic.GameOver();
            this._playerAILogic.GameOver();
            UpEventHandle.instance.removeListEvent("trollUpData");
        }
        TrollUpData() {
            UpEventHandle.instance.AddUPEvent("trollUpData", this._trollLgoic.UpData, this._trollLgoic);
            this._trollLgoic.TrollPatrol();
            EventCenter.instance.Fire(EventCenter.instance.SKILL_ADDUPEVENT);
        }
        player() {
            this._playerAILogic.StartGame();
        }
    }

    class GameManager {
        constructor() {
            this.gold1Arr = [100, 200, 400, 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000, 10000, 30000, 50000, 80000, 100000, 150000, 400000, 800000];
            this.gold2Arr = [100, 200, 300, 400, 500, 600, 700, 1000, 1500, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000, 10000, 15000, 20000, 50000];
            this._UIManager = new UIManager();
            this._UIManager.AddUpData();
            this._UIManager.LoadOne();
            this._mapGManager = new MapGridManager();
            this._buildManager = new BuildManager();
            this._playerManager = new PlayerManager();
            this._trollManager = new TrollManager();
            this._mainTPLogic = new MainTPLgic();
            this.AddEvent();
        }
        AddEvent() {
            EventCenter.instance.AddListEvent(EventCenter.instance.GM_STARTGAME, this.StartGame, this);
            EventCenter.instance.AddListEvent(EventCenter.instance.GM_GAMEOVER, this.GameOver, this);
        }
        StartGame() {
            Sound.instance.playMusic(Sound.instance.BG_music.gameBGM);
            DataManager.instance.StartGame();
            TimeManager.instance.StartGame();
            this._buildManager.StartGame();
            this._mapGManager.SelectMap();
            this._mapGManager.ShowMap();
            this._playerManager.StartGame(6);
            this._UIManager.StartGame();
            this._trollManager.StartGame();
            this._mainTPLogic.StartGame();
            UpEventHandle.instance.StartGame();
        }
        GameOver(isWin = false) {
            this.DD_Economics();
            DataManager.instance.GameOver();
            Sound.instance.StopAll();
            EffectSequence.instance.GameOver();
            TimeManager.instance.GameOver();
            GameDynamics.instance.GameOver();
            DataManager.instance.game.isWin = isWin;
            let c = isWin ? 1 : 0;
            EffectTween.instance.GameOver();
            UpEventHandle.instance.GameOver();
            this._mainTPLogic.GameOver();
            this._buildManager.GameOver();
            this._playerManager.GameOver();
            this._trollManager.GameOver();
            this._UIManager.GameMove(isWin == null);
            this._mapGManager.GameOver();
        }
        DD_Economics() {
            let gold = DataManager.instance.game.GetRoomPR(this._playerManager.player.roomIndex);
            let gold1 = 0;
            let gold2 = 0;
            if (gold) {
                gold1 = gold.gold1_Count;
                gold2 = gold.gold2_Count;
                for (let i = this.gold1Arr.length - 1; i >= 0; i--) {
                    let c = this.gold1Arr[i];
                    if (gold1 >= c) {
                        gold1 = c;
                        break;
                    }
                    else if (i == 0) {
                        gold1 = 0;
                    }
                }
                for (let i = this.gold2Arr.length - 1; i >= 0; i--) {
                    let c = this.gold2Arr[i];
                    if (gold2 >= c) {
                        gold2 = c;
                        break;
                    }
                    else if (i == 0) {
                        gold2 = 0;
                    }
                }
            }
        }
    }

    class UpDataScript extends Laya.Script {
        constructor() {
            super(...arguments);
            this.spth = ["Prefabs/buildMenu.json", "Prefabs/off.json", "Prefabs/BuildBloodStrip.json", "Prefabs/TrollBloodStrip.json", "Prefabs/RF.json", "Prefabs/menu.json", "Prefabs/ShopMenu.json", "Prefabs/StartGame.json", "Prefabs/BattleUI.json", "Prefabs/GameOverUI.json", "Prefabs/MatchingUI.json", "Prefabs/TipsUI.json", "Prefabs/SkillUI.json", "Prefabs/ShopUI.json", "Prefabs/TreasureChestUI.json", "res/atlas/UI.atlas", "res/atlas/StartGameUI.atlas", "res/atlas/pipei.atlas", "res/atlas/map.atlas", "res/atlas/load.atlas", "res/atlas/bullet.atlas", "res/atlas/build.atlas", "res/atlas/Atower.atlas"];
            this._loadWidth = 380;
        }
        onAwake() {
            this._scene = Laya.stage.getChildAt(0).getChildAt(0);
            this._loadIng = this._scene.getChildByName("loading");
            this._loadPanel = this._loadIng.getChildByName("loadPanel");
            this._loadText = this._loadPanel.getChildByName("loadText");
            this._load = this._loadPanel.getChildByName("load");
            this._scene.width = Laya.stage.width;
            this._scene.height = Laya.stage.height;
            this._loadIng.width = this._scene.width;
            this._loadIng.height = this._scene.height;
            this._loadPanel.pos(this._loadIng.width / 2, this._loadIng.height * 0.45);
            this._loadText.text = "猛鬼加载中0%.....";
            this._load.width = 0;
        }
        onStart() {
            Laya.loader.load(this.spth, Laya.Handler.create(this, this.onAssetLoaded), Laya.Handler.create(this, this.onLoading, null, false));
        }
        onUpdate() {
            UpEventHandle.instance.HandleUPEvent();
        }
        onAssetLoaded(texture) {
            new GameManager();
            this._loadIng.removeSelf();
            this._loadIng.visible = false;
            this._loadIng.destroy(true);
        }
        onLoading(progress) {
            let width = progress * this._loadWidth;
            progress *= 100;
            progress = Math.floor(progress);
            let dCount = Math.ceil(progress % 10) / 2;
            let d = "";
            for (let i = 0; i < dCount; i++) {
                d += ".";
            }
            this._loadText.text = "猛鬼加载中" + progress + "%" + d;
            this._load.width = width;
        }
    }

    class GameConfig {
        constructor() { }
        static init() {
            var reg = Laya.ClassUtils.regClass;
            reg("Script/UpDataScript.ts", UpDataScript);
        }
    }
    GameConfig.width = 640;
    GameConfig.height = 1136;
    GameConfig.scaleMode = "fixedwidth";
    GameConfig.screenMode = "none";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "Main.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    var Handler = Laya.Handler;
    class Main {
        constructor() {
            if (window["Laya3D"])
                Laya3D.init(GameConfig.width, GameConfig.height);
            else
                Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
            Laya["Physics"] && Laya["Physics"].enable();
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            Laya.stage.scaleMode = GameConfig.scaleMode;
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.stage.alignV = GameConfig.alignV;
            Laya.stage.alignH = GameConfig.alignH;
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true")
                Laya.enableDebugPanel();
            if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"])
                Laya["PhysicsDebugDraw"].enable();
            if (GameConfig.stat)
                Laya.Stat.show();
            Laya.alertGlobalError(true);
            Laya.loader.load("js/Platform/AdConfig.json", Handler.create(this, obj => {
                Platform.init(obj.bannerID, obj.videoID, obj.insertID, obj.boxID, obj.boxBannerID, obj.cdnUrl);
            }));
            Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
        }
        onVersionLoaded() {
            Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
        }
        onConfigLoaded() {
            GameConfig.startScene && Laya.Scene.open(GameConfig.startScene);
        }
    }
    new Main();

}());
